#include "ScrollHook.h"

SYS_SERVICE_TABLE *g_pShadowTable;

int g_ScrollDCIndex = (-1);
HANDLE g_hProcess = 0;

SCROLL_DATA g_ScrollData;
SCROLL_HOOK_TARGET g_ScrollHookTarget;

// Win32k.sys Ͽ ũ  API  Ÿ μ  ̶ ȣǾٸ TRUE ϴ.
ULONG g_IsScrolled = FALSE;

//   ŷ SSDT APIԼ ȣ Ǿ Լ ȣ ̶   0 ū  ϴ.
ULONG g_SSDTAPILockCount = 0;

typedef ULONG (*SCROLLWINDOWEX)(HWND hWnd, int dx, int dy, const RECT *prcScroll, const RECT *prcClip, HRGN hrgnUpdate, LPRECT prcUpdate, UINT flags);
ULONG (*OrigScrollWindowEx)(HWND hWnd, int dx, int dy, const RECT *prcScroll, const RECT *prcClip, HRGN hrgnUpdate, LPRECT prcUpdate, UINT flags);

typedef ULONG (*SCROLLDC)(HDC hDC,int dx, int dy, const RECT *lprcScroll, const RECT *lprcClip, HRGN hrgnUpdate, LPRECT lprcUpdate);
ULONG (*OrigScrollDC)(HDC hDC,int dx, int dy, const RECT *lprcScroll, const RECT *lprcClip, HRGN hrgnUpdate, LPRECT lprcUpdate);

typedef struct _SERVICE_DESCRIPTOR_TABLE *PSERVICE_DESCRIPTOR_TABLE;

extern PSERVICE_DESCRIPTOR_TABLE KeServiceDescriptorTable;
extern __declspec(dllimport) KeAddSystemServiceTable(ULONG, ULONG, ULONG, ULONG, ULONG); 

SYS_SERVICE_TABLE *GetServiceDescriptorShadowTableAddress ()
{ 
    // ShadowTable ּҸ  ҽڵε ڰ  𸣰ڽϴ.
	//  ͳݿ  ٴϴ ҽ   ֽϴ.

	// First, obtain a pointer to KeAddSystemServiceTable
	unsigned char *check = (unsigned char*)KeAddSystemServiceTable; 
	int i;
	//Initialize an instance of System Service Table, will be used to
	//obtain an address from KeAddSystemServiceTable
	SYS_SERVICE_TABLE *rc=0; 
	// Make 100 attempts to match a valid address with that of KeServiceDescriptorTable 
	for (i=0; i<4096; i++) { 
		__try { 
			// try to obtain an address from  KeAddSystemServiceTable 
			rc = *(SYS_SERVICE_TABLE **)check; 
			// if this address is NOT valid OR it itself is the address of 
			//KeServiceDescriptorTable OR its first entry is NOT equal 
			//to the first entry of KeServiceDescriptorTable 
			if (!MmIsAddressValid (rc) || (rc == (SYS_SERVICE_TABLE *)KeServiceDescriptorTable) 
				|| (memcmp (rc, KeServiceDescriptorTable, sizeof (*rc)) != 0)) { 
					// Proceed with the next address 
					check++; 
					// don't forget to reset the old address 
					rc = 0; 
			} 
		} __except (EXCEPTION_EXECUTE_HANDLER) { rc = 0; } 
		// when the loop is completed, check if it produced a valid address 
		if (rc) 
			// because if it didn't, we failed to find the address of KeServiceDescriptorTableShadow 
			break; 
	} 
	// otherwise, there is a valid address! So return it! 
	return rc; 
}

//     κԴϴ.
// MDL ϵ ؾ մϴ.
VOID  ClearWriteProtect(VOID)
{
  __asm
  {
    push  eax;
    mov   eax, cr0;
    and   eax, CR0_WP_MASK;
    mov   cr0, eax;
    pop   eax;
  }
}

VOID  SetWriteProtect(VOID)
{
  __asm
  {
    push  eax;
    mov   eax, cr0;
    or    eax, not CR0_WP_MASK;
    mov   cr0, eax;
    pop   eax;
  }
}

int GetScrollDCIndex(SYS_SERVICE_TABLE *p)
{
	/*
	 ȣ
	Windows 2000 >> 0x1D9 NtUserRemoveMenu
	Windows Vista >> 0x20A	NtUserScrollDC
	
	Windows 2000 Ķ   
	A0069191  	03  	NtUserRemoveMenu
	A0063B65  	02  	NtUserRemoveProp
	A009A4D9  	04  	NtUserResolveDesktop
	A00E2A8C  	01  	NtUserResolveDesktopForWOW
	A00B76FB  	04  	NtUserSBGetParms
	A0040899  	07  	NtUserScrollDC
	A00ABB92  	08  	NtUserScrollWindowEx
	A002895B  	03  	NtUserSelectPalette
	A0088DAD  	03  	NtUserSendInput
	*/

	/*
	Windows 7 RC  Լ ε
	ڼ ø NtUserResolveDesktop Լ    ֽϴ.
	
	NtUserRemoveMenu ( 0x1211 )
	NtUserRemoveProp
	NtUserResolveDesktopForWOW
	NtUserSBGetParms
	NtUserScrollDC
	NtUserScrollWindowEx
	NtUserSelectPalette
	NtUserSendInput
	*/

	// Shadow Table 쿡 ü API ε  ٸϴ.
	//  ̷ 쿡 Ķ  ̿Ͽ  Ǵ ü  
	// Ķ Ư 迭   ü ϰ˻縦  API ãƳ ˴ϴ.
	//    س Դϴ.    ϴ.
	// Windows 2000 Windows 2008 Server ׽ƮǾϴ.

	const int WIN2K_NtUserRemoveMenu = 0x1D9;
	const int WINDOWS7_RC_NtUserRemoveMenu = 0x211;
	int i;

	if (((p[1].ArgumentsTable[WINDOWS7_RC_NtUserRemoveMenu]) == 12) // NtUserRemoveMenu
			&& ((p[1].ArgumentsTable[WINDOWS7_RC_NtUserRemoveMenu + 1]) == 8) // NtUserRemoveProp
			&& ((p[1].ArgumentsTable[WINDOWS7_RC_NtUserRemoveMenu + 2]) == 4) // NtUserResolveDesktopForWOW
			&& ((p[1].ArgumentsTable[WINDOWS7_RC_NtUserRemoveMenu + 3]) == 16) // NtUserSBGetParms
			&& ((p[1].ArgumentsTable[WINDOWS7_RC_NtUserRemoveMenu + 4]) == 28) // NtUserScrollDC
			&& ((p[1].ArgumentsTable[WINDOWS7_RC_NtUserRemoveMenu + 5]) == 32) // NtUserScrollWindowEx
			&& ((p[1].ArgumentsTable[WINDOWS7_RC_NtUserRemoveMenu + 6]) == 12) // NtUserSelectPalette
			&& ((p[1].ArgumentsTable[WINDOWS7_RC_NtUserRemoveMenu + 7]) == 12) // NtUserSendInput
		)
	{
		KdPrint(("Windows 7 RC!!\n"));
		return (WINDOWS7_RC_NtUserRemoveMenu + 4);
	}

	for (i = WIN2K_NtUserRemoveMenu; i <= 0x20a; i++)
	{
		KdPrint(("%d", p[1].ArgumentsTable[i] / 4));
		if (
			   ((p[1].ArgumentsTable[i + 0]) == 12)
			&& ((p[1].ArgumentsTable[i + 1]) == 8)
			&& ((p[1].ArgumentsTable[i + 2]) == 16)
			&& ((p[1].ArgumentsTable[i + 3]) == 4)
			&& ((p[1].ArgumentsTable[i + 4]) == 16)
			&& ((p[1].ArgumentsTable[i + 5]) == 28)
			&& ((p[1].ArgumentsTable[i + 6]) == 32)
			&& ((p[1].ArgumentsTable[i + 7]) == 12)
			&& ((p[1].ArgumentsTable[i + 8]) == 12)
			)
		{
			return (i + 5);
		}
	}
	return (-1);
}

ULONG MyScrollDC(HDC hDC, int dx, int dy, const RECT *lprcScroll, const RECT *lprcClip, HRGN hrgnUpdate, LPRECT lprcUpdate)
{
	HANDLE PID;

	RECT rcScroll;
	ULONG uResult;

	SSDT_API_CALL_ENTER(g_SSDTAPILockCount);
	__try
	{
		if (lprcScroll != NULL)
		{
			// lprcScroll  Լ ȣ     ֽϴ.
			//    ϴ.
			memcpy(&rcScroll, lprcScroll, sizeof(RECT));
		}

		uResult = (OrigScrollDC(hDC, dx, dy, lprcScroll, lprcClip, hrgnUpdate, lprcUpdate));
		
		PID = PsGetCurrentProcessId();
		if (PID == g_ScrollHookTarget.hTargetProcess)
		{
			InterlockedExchange(&g_IsScrolled, TRUE);
			if (lprcScroll != NULL)
			{
				KdPrint(("MyScrollDC PID : %u, %d, HDC(%u), ScrollRect(Left:%d,Top:%d,Right:%d,Bottom:%d", PID, dy, 
						  hDC,
						  rcScroll.left,
						  rcScroll.top,
						  rcScroll.right,
						  rcScroll.bottom));

				memcpy(&g_ScrollData.rcScroll, &rcScroll, sizeof(RECT));
			}
			else
			{
				KdPrint(("MyScrollDC PID : %u, %d, HDC(%u)", PID, dy, hDC));
				memset(&g_ScrollData.rcScroll, 0, sizeof(RECT));
			}
			g_ScrollData.dy += dy;
		}
	}
	__finally
	{
		SSDT_API_CALL_LEAVE(g_SSDTAPILockCount);
	}

	return uResult;
}

ULONG MyScrollWindowEx(HWND hWnd, int dx, int dy, const RECT *prcScroll, const RECT *prcClip, HRGN hrgnUpdate, LPRECT prcUpdate, UINT flags)
{
	HANDLE PID;

	RECT rcScroll;
	ULONG uResult;

	SSDT_API_CALL_ENTER(g_SSDTAPILockCount);
	__try
	{
		if (prcScroll != NULL)
		{
			// lprcScroll  Լ ȣ     ֽϴ.
			//    ϴ.
			memcpy(&rcScroll, prcScroll, sizeof(RECT));
		}

		uResult = (OrigScrollWindowEx(hWnd, dx, dy, prcScroll, prcClip, hrgnUpdate, prcUpdate, flags));
		
		PID = PsGetCurrentProcessId();
		if ((PID == g_ScrollHookTarget.hTargetProcess)
			&& (hWnd == g_ScrollHookTarget.hTargetWindow))
		{
			InterlockedExchange(&g_IsScrolled, TRUE);
			if (prcScroll != NULL)
			{
				KdPrint(("MyScrollWindowEx PID : %u, %d: HWND(%u), ScrollRect(Left:%d,Top:%d,Right:%d,Bottom:%d", PID, dy, 
						  hWnd,
						  rcScroll.left,
						  rcScroll.top,
						  rcScroll.right,
						  rcScroll.bottom));
				memcpy(&g_ScrollData.rcScroll, &rcScroll, sizeof(RECT));
			}
			else
			{
				KdPrint(("MyScrollWindowEx PID : %u, %d, HWND(%u)", PID, dy, hWnd));
				memset(&g_ScrollData.rcScroll, 0, sizeof(RECT));
			}
			g_ScrollData.dy += dy;
		}
	}
	__finally
	{
		SSDT_API_CALL_LEAVE(g_SSDTAPILockCount);
	}

	return uResult;
}

void InstallScrollHook(HANDLE hProcess)
{
	ClearWriteProtect();

	KdPrint(("IRQL : %#x", KeGetCurrentIrql()));

	g_pShadowTable = GetServiceDescriptorShadowTableAddress();
	if (g_pShadowTable == NULL)
	{
		KdPrint(("Failed GetShadowTable"));
	}
	else
	{
		PEPROCESS pEProcess;

		KdPrint(("ServiceDescriptorShadowTableAddress : %#x", g_pShadowTable));
		KdPrint(("PID %u", hProcess));

		PsLookupProcessByProcessId(hProcess, &pEProcess);
		if (pEProcess == NULL)
		{
			SetWriteProtect();

			return ;
		}
		KeAttachProcess(pEProcess);

		g_ScrollDCIndex = GetScrollDCIndex(g_pShadowTable);
		KdPrint(("g_ScrollDCIndex: %#x", g_ScrollDCIndex));

		g_hProcess = hProcess;
		if (g_ScrollDCIndex != (-1))
		{
			//
			// ̷   ʽϴ.
			// ̷ϸ ſ ش  Ȯ  ũ ߻   ֽϴ. ( ׷ ɼ ſ .. )
			// OrigScrollDC = InterlockedExchangePointer(&(g_pShadowTable[1].ServiceTable[g_ScrollDCIndex]), MyScrollDC);
			//
			OrigScrollDC = (SCROLLDC)(g_pShadowTable[1].ServiceTable[g_ScrollDCIndex]);
			InterlockedExchangePointer(&(g_pShadowTable[1].ServiceTable[g_ScrollDCIndex]), MyScrollDC);

			OrigScrollWindowEx = (SCROLLWINDOWEX)(g_pShadowTable[1].ServiceTable[g_ScrollDCIndex + 1]);
			InterlockedExchangePointer(&(g_pShadowTable[1].ServiceTable[g_ScrollDCIndex + 1]), MyScrollWindowEx);
		}

		KeDetachProcess();
	}
	SetWriteProtect();
}

void UnInstallScrollHook(void)
{
	LARGE_INTEGER WaitTime;

	ClearWriteProtect();

	if (g_pShadowTable != NULL)
	{
		KdPrint(("ServiceDescriptorShadowTableAddress : %#x", g_pShadowTable));

		if (g_hProcess != 0)
		{
			if (g_ScrollDCIndex != (-1))
			{
				PEPROCESS pEProcess;

				PsLookupProcessByProcessId(g_hProcess, &pEProcess);

				KeAttachProcess(pEProcess);

				//g_pShadowTable[1].ServiceTable[g_ScrollDCIndex] = OrigScrollDC;
				InterlockedExchangePointer(&(g_pShadowTable[1].ServiceTable[g_ScrollDCIndex]), OrigScrollDC);
				//g_pShadowTable[1].ServiceTable[g_ScrollDCIndex + 1] = OrigScrollWindowEx;
				InterlockedExchangePointer(&(g_pShadowTable[1].ServiceTable[g_ScrollDCIndex + 1]), OrigScrollWindowEx);

				KeDetachProcess();
			}
		}
	}
	SetWriteProtect();

	WaitTime.QuadPart = -1 * 10 * 1000 * 1000;
	while (g_SSDTAPILockCount > 0)
	{
		//  ŷ  SSDT API ߿ ֽϴ.
		// ŷ   InterlockedExchangePointer Լ ̿Ͽ ŷ  
		//  Լ ȣǱ  MyScrollDC API ȣǰ ٽ  Ŀ InterlockedExchangePointer ȣȴٸ
		// ̹ MyScrollDC ȣ  Դϴ.
		//  ̹ ε   DRIVER_UNLOADED_WITHOUT_CANCELLING_PENDING_OPERATIONS 罺ũ ߻   Ƿ ̸ մϴ.
		KdPrint(("g_SSDTAPILockCount : %u\n", g_SSDTAPILockCount));

		// 1ʰ   Lock Ǯȴ ٽ üũմϴ.
		WaitTime.QuadPart = -1 * 10 * 1000 * 1000;
		KeDelayExecutionThread(KernelMode ,FALSE, &WaitTime);	

		//  !! Lock Ǯ üũ  ٽ Lock ɸ  ֽϴ.
		// ֳϸ Lockī͸ Ű κ Լ ȣ  ٷ Ű  ƴϱ Դϴ.
		//  nacked Լ     ġ κ̹Ƿ ظϸ  ʴ  ϴ.
	}
	// ٽ 1ʰ   ̹ ε   ֵ մϴ.
	WaitTime.QuadPart = -1 * 10 * 1000 * 1000;
	KeDelayExecutionThread(KernelMode ,FALSE, &WaitTime);	

	DbgPrint("OpenCapture ScrollHook Driver UnLoaded\n");
}