﻿(* ****** TCaptureEngine ********
 * 화면 캡쳐를 쉽게 할 수 있는 클래스 라이브러리다.
   제작자 : 정룡옥
   E - Mail : hackingfanatic@homtail.com
 *)                                                                                                  


unit CaptureEngine;

interface

uses Windows , Messages , Classes , Graphics , SysUtils
     , Forms , Dialogs , Registry , uCapture , Controls , Clipbrd ,
      ActiveX , SHDocVw , GR32, StdCtrls, MMSystem;

 Const
  CaptureEngineVersion = 'TCaptureEngine Version v2.0';

 resourcestring
  errScrollCapture = '스크롤 캡쳐 도중 에러가 발생하였습니다.';
  errMinSize = '모질라 웹 브라우저의 윈도우의 크기가 너무 작습니다.' + #10 + '윈도우의 크기를 늘려주세요';
  errCaptureWindow = '윈도우 또는 윈도우,컨트롤 캡쳐 작업에 실패했습니다.' + #10 + #10 + '사용자에 입력이 너무 빠릅니다.' + #10 +
                     '또는 WINE을 통해 다른 플랫폼에서 오픈 캡쳐를 사용하려고 하였습니다.'
                     + #10 + 'WINE에서는 EnumWindows 함수를 통해 다른 플랫폼에 애플리케이션에 접근 할 수 없으며 WINE' +
                     '에서 에뮬레이션 해주고 있는 Windows 애플리케이션만 접근가능합니다.';
  errExtendWindow = '윈도우가 존재하지 않습니다.';
  errUserCancel = '사용자가 캡쳐 작업을 취소했습니다.';
  errActiveWindow = '활성화 된 윈도우를 캡쳐하는데 실패했습니다.' + #10 + '' + #10 + '실패 원인은 다음과 같습니다.' + #10 + '' + #10 + '1. 활성화 되어있지만 해당 윈도우가 최소화 되어있습니다.';
  errNoFrame = '활성화 된 윈도우의 프레임을 제외한 영역 캡쳐에 실패했습니다.' + #10 + '' + #10 + '실패 원인은 다음과 같습니다.' + #10 + '' + #10 + '1. 활성화 되어있지만 해당 윈도우가 최소화 되어있습니다.';
  errIcon = '아이콘을 가져오는데 실패했습니다';
  errLastCapture = '캡쳐한 작업이 없습니다.' + #10 + '따라서 마지막으로 캡쳐한 영역을 캡쳐 할 수 없습니다.' + #10 + '또는 마지막으로 캡쳐한 작업이 실패했습니다.';
  errMenuCapture = '메뉴를 캡쳐하는데 실패했습니다.' + #10 + '' + #10 + '실패 원인은 다음과 같습니다.' + #10 + '1.오픈  캡쳐가 인식 할 수 있는 메뉴이어야 합니다.' + #10 + '   (프로그램에서 자체적으로 만든 메뉴는 메뉴인지 구별 할 수 없습니다.)' + #10 + '2.열려있는 메뉴가 없습니다.' + #10 + '3.메뉴 캡쳐 시에는 "단축키"를 이용하셔야 합니다.';
  errWallpaperCapture = '바탕화면을 캡쳐하는데 실패했습니다.' + #10 + '' + #10 + '실패원인은 다음과 같습니다.' + #10 + '1.레지스트리를 읽어오는 도중 에러가 발생하였습니다.' + #10 + '2.바탕화면이 지정되어 있지 않습니다.' + #10 + '3.바탕화면 이미지를 읽어오는데 실패했습니다.';
  errOutRes = '메모리가 부족해서 이 작업을 완료하지 못 했습니다.';

  errExportCaptureDriver = '캡쳐 드라이버 파일을 익스포트 할 수 없습니다.'
                            + #10 +
                           '다음 경로에 접근 할 수 없습니다.'
                            + #10 + #10 +
                           '%s' + #10 + #10 +
                           '비스타 이상일 경우 관리자 권한으로 프로그램을 실행시켜주세요.';

 Const
  stRect = $1;
  stRoundRect = $2;
  stCircle = $3;
  stTriangle = $4;
  stPolygon = $5;
  stPolyLine = $6;

  ctNull = $0;
  ctUserCapture = $1;
  ctWindow = $2;
  ctControl = $3;
  ctIcon = $4;
  ctFixed = $5;

  ebRoundRect = $2;
  ebEllipse = $3;
  ebTriangle = $4;
  ebPolygon = $5;
  ebPolyline = $6;

  // ************************************* //
  // ************************************* //
  // ** 스크롤 캡쳐 시 상수 선언 ** //

  // ** 실패 ** //
  sbError = $0;
  // ** 일반 윈도우 스크롤바 ** //
  sbNormal = $1;
  // ** IE  스크롤바 ** //
  sbIE = $2;
  // ** 모질라 웹브라우저 스크롤바 ** //
  sbMozilla = $3;
  // ** 사파리 ** //
  sbSafari = sbMozilla;
  // ** 구글 크롬 ** //
  sbGoogleChrome = $4;
  // ** 한글 2007 ** //
  sbHangul2007 = $5;
  // ** 오피스 2007 Word ** //
  sbMSOffice2007Word = $6;
  // ** 오피스 2007 Excel ** //
  sbMSOffice2007Excel = $7;

  // ************************************* //
  // ************************************* //

 type
	TRGB = record
	 B, G, R : byte;
	end;

	PRGBArray = ^TRGBArray;
	TRGBArray = array[0..0] of TRGB;

 function CompareBitmap(Bitmap1, Bitmap2: TBitmap; YPosition: Integer):Boolean;
 procedure EdgeBitmap(var Bitmap: TBitmap; EdgeStyle: Byte);
 procedure EdgePolygonBitmap(var Bitmap: TBitmap;PolygonPt: Array of TPoint; PolyRect: TRect);
 procedure EdgeRgnBitmap(var Bitmap: TBitmap; Left, Top, bWidth, bHeight: Integer; var ARgn: HRGN);

 type
  TMenuInfo = Record
   MnuMaxRect:TRect;
   MnuRect: Array of TRect;
 end;

 type
  TthdKeyState = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;


 type
  TCaptureEngine = class(TComponent)
  private
   FCaptureDriver: THandle;

   MenuInfo:TMenuInfo;
   function CaptureCursor: TCursorInfo;
   procedure ScreenCapture;
   procedure BeginCapture;
   procedure EndCapture(bCaptureSuccess: Boolean);
   procedure ExtendBitmap32Height(ABitmap: TBitmap32; NewWidth, NewHeight: Integer);

   procedure IEScrollCapture(WindowHandle: HWND; ScrollDelay: Integer; var ABitmap: TBitmap32);
   function WindowScrollCapture(WindowHandle: HWND; ScrollDelay: Integer; var ABitmap: TBitmap32): Boolean;
   function MozillaScrollCapture(WindowHandle:HWND; ScrollDelay: Integer; var ABitmap: TBitmap32): Boolean;
   function Office2007ScrollCapture(WindowHandle: HWND; ScrollDelay: Integer; var ABitmap: TBitmap32): Boolean;
   function GoogleChromeScrollCapture(WindowHandle: HWND; ScrollDelay: Integer; var ABitmap: TBitmap32): Boolean;

   function ScrollCapture(WindowHandle: HWND; ScrollDelay: Integer; var ABitmap: TBitmap32): Boolean;

   function GetCaptureDriverPath: String;
   function CaptureDriverLoad: Boolean;
   function CaptureDriverUnLoad: Boolean;
  public
   FTransparentCapture:Boolean;
   FCaptureCursor:Boolean;
   FBackBuffer:TBitmap;
   FCaptureBitmap:TBitmap;
   // ** 스크롤 캡쳐 시 대형 이미지 지원 ** //
   FScrollBitmap:TBitmap32;
   FSaveClipBoard:Boolean;
   FAppHide:Boolean;
   FSleep, FScrollSleep:Integer;
   FAppNotActive:Boolean;
   FCaptureRect:TRect;

   FWavFilePath: String;

   constructor Create(AOwner:TComponent); override;
   destructor Destroy; override;
   procedure CaptureSetup(TransparentCapture, CaptureCursor, SaveClipBoard,
                          AppHide: Boolean; AppSleep: Integer; AppNotActive: Boolean;
                          WavFilePath: String);
   procedure CaptureEntire;
   function CaptureUser(FShapeType: Integer): Boolean;
   function CaptureWindow(var FWindowName: String): Boolean;
   function CaptureControl(var FWindowName: String; FAutoScroll, FInvalidate: Boolean; ScrollDelay: Integer): Boolean;
   function CaptureFixed(FixedWidth, FixedHeight: Integer): Boolean;
   function CaptureIcon: Boolean;
   function CaptureColor(var AColor: TColor): Boolean;
   function CaptureExtend: Boolean;
   function CaptureActiveWindow(NoFrame: Boolean): Boolean;
   procedure CaptureRect(lpRect:TRect);
   function CaptureMenu: Boolean;
   function CaptureObject(var FWindowName:String): Boolean;
   procedure CaptureOnlyCursor;
   function CaptureWallpaper: Boolean;
   procedure CaptureWebSiteImages;
 end;

 var
  FCaptureEngine: TCaptureEngine;
  thdKeyState: TthdKeyState = Nil;
  FkeyState: Boolean = False;
  NewPoint: TPoint;
  EndPoint: TPoint;
  PolygonPt: Array of TPoint;
  PolyRect: TRect;

implementation

 uses CaptureDriver, OpenInterface, uIcon, uProcess, uExtendWindow, accessIE,
      ShellAPI, Imm, uWebSiteImages, uResource;

function CompareBitmap(Bitmap1, Bitmap2: TBitmap; YPosition: Integer): Boolean;
var
 P1, P2:PRGBArray;
 Pix1, Pix2:^TRGB;
 i, j:Integer;
 bCompare:Boolean;
begin
	Bitmap1.PixelFormat := pf24bit;
	Bitmap2.PixelFormat := pf24bit;
	Result := True;

	for i := YPosition to Bitmap1.Height - 1 do begin
		P1 := Bitmap1.ScanLine[i];
		P2 := Bitmap2.ScanLine[i];

		for j := 0 to Bitmap1.Width - 1 do begin
			Pix1 := @P1[j];	Pix2 := @P2[j];
			bCompare := (Pix1.R <> Pix2.R) or (Pix1.G <> Pix2.G) or (Pix1.B <> Pix2.B);
			if bCompare then begin
				Result := False;
				Break;
			end; // if bCompare then begin

		end; // for j := 0 to Bitmap1.Width - 1 do begin

	end; // for i := YPosition to Bitmap1.Height - 1 do begin

end;

procedure EdgeBitmap(var Bitmap: TBitmap; EdgeStyle: Byte);
var
 BackBuffer:TBitmap;
 bWidth, bHeight:integer;
 Triangle:Array[0..3] of TPoint;
begin
 bWidth := Bitmap.Width;
 bHeight := Bitmap.Height;

 BackBuffer := TBitmap.create;

 try
  with BackBuffer do begin
   width := bWidth;
   height := bHeight;
   Canvas.Brush.Color := clWhite;
   Canvas.FillRect(Rect(0, 0, bWidth, bHeight));
   Canvas.Brush.Color  := clblack;

   Case EdgeStyle of
    ebRoundRect : Canvas.RoundRect(0, 0, bWidth, bHeight,  - bWidth div 2,  - bHeight div 2);
    ebEllipse : Canvas.Ellipse(0, 0, bWidth, bHeight);
    ebTriangle : begin
                  Triangle[0].X := bWidth div 2;
                  Triangle[0].Y := 0;
                  Triangle[1].X := 0;
                  Triangle[1].Y := bHeight;
                  Triangle[2].X := bWidth;
                  Triangle[2].Y := bHeight;
                  Triangle[3].X := bWidth div 2;
                  Triangle[3].Y := 0;
                  Canvas.Polygon(Triangle);
                 end;
   end;

    Transparent := True;
    TransparentColor := clblack;
    Bitmap.Canvas.Draw(0, 0, BackBuffer);
  end;

 finally
  BackBuffer.Free;
 end;

end;

procedure EdgePolygonBitmap(var Bitmap:TBitmap;PolygonPt:Array of TPoint;PolyRect:TRect);
var
 BackBuffer:TBitmap;
 bWidth, bHeight:Integer;
 i:Integer;
begin
 bWidth := Bitmap.Width;
 bHeight := Bitmap.Height;

 BackBuffer := TBitmap.create;

 try
  with BackBuffer do begin
   width := bWidth;
   height := bHeight;
   Canvas.Brush.Color := clWhite;
   Canvas.FillRect(Rect(0, 0, bWidth, bHeight));
   Canvas.Brush.Color  := clblack;

   SetPolyFillMode(Canvas.Handle, WINDING);

    for i := Low(PolygonPt) to High(PolygonPt) do begin
      PolygonPt[i].X := PolygonPt[i].X - PolyRect.Left;
      PolygonPt[i].Y := PolygonPt[i].Y - PolyRect.Top;
    end;

    Canvas.Polygon(PolygonPt);
    Transparent := True;
    TransparentColor := clblack
  end;

  Bitmap.Canvas.Draw(0, 0, BackBuffer);
 finally
  BackBuffer.Free;
 end;

end;

procedure EdgeRgnBitmap(var Bitmap:TBitmap;Left, Top, bWidth, bHeight:Integer;var ARgn:HRGN);
var
 BRgn:HRGN;
 RRgn:HRGN;
begin
 BRgn := CreateRectRgn(0, 0, bWidth, bHeight);
 RRgn := CreateRectRgn(0, 0, 0, 0);
  try
   OffsetRgn(ARgn,  - Left,  - Top);
   CombineRgn(RRgn, BRgn, ARgn, RGN_DIFF);
   Bitmap.Canvas.Brush.Style := bsSolid;
   Bitmap.Canvas.Brush.Color := clWhite;
   OffsetRgn(RRgn, Left, Top);
   PaintRgn(Bitmap.Canvas.Handle, RRgn);
  finally
   DeleteObject(BRgn);
   DeleteObject(RRgn);
  end;
  // ** X ,  Y 위치로 옮기는게 아니라 X ,  Y 만큼 가로, 세로로 옮긴다. ** //

end;


procedure TthdKeyState.Execute;
begin
 while not Terminated do begin
  Sleep(100);
  if GetAsyncKeyState(VK_ESCAPE) < 0 then begin
   FkeyState := True;
   break;
  end;
 end;

end;

constructor TCaptureEngine.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FCaptureEngine := Self;

 FTransparentCapture := False;
 FCaptureCursor := False;
 FSaveClipboard := False;
 FAppHide := False;
 FSleep := 0;
 FScrollSleep := 0;
 MenuInfo.MnuRect := Nil;
 
 FCaptureBitmap := TBitmap.Create;
 FBackBuffer := TBitmap.Create;
 FScrollBitmap := Nil;

 FWavFilePath := '';
end;

destructor TCaptureEngine.Destroy;
begin
 FCaptureEngine := Nil;
 FCaptureBitmap.Free;
 FBackBuffer.Free;

 inherited Destroy;
end;

function TCaptureEngine.CaptureCursor:TCursorInfo;
var
 CursorPos:TPoint;
 hWindow:HWND;
 dwThreadID, dwCurrentThreadID: DWORD;
begin
 Result.hCursor  :=  0;
 ZeroMemory(@Result,  SizeOf(Result));

 CursorPos := Point(0, 0);

 if GetCursorPos(CursorPos) then begin
  Result.ptScreenPos := CursorPos;

  hWindow := WindowFromPoint(CursorPos);

  if IsWindow(hWindow) then begin

   dwThreadID  :=  GetWindowThreadProcessId(hWindow,  Nil);
   dwCurrentThreadID  :=  GetCurrentThreadId;
    if (dwCurrentThreadID <> dwThreadID) then begin
     if AttachThreadInput(dwCurrentThreadID,  dwThreadID,  True) then begin
      Result.hCursor  :=  GetCursor;
      AttachThreadInput(dwCurrentThreadID,  dwThreadID,  False);
     end;
    end else Result.hCursor  :=  GetCursor;
  end;
  
 end;

end;

procedure TCaptureEngine.ScreenCapture;
const
 // ** 윈도우 2000 이상에서 반투명화 된 윈도우를 캡쳐 할 수 있는 비트 플래그 ** //
 // ** BitBlt 함수에서 OR 연산자를 통해서 사용한다 ** //
 CAPTUREBLT = $40000000;
var
 CursorInfo: TCursorInfo;
 piconinfo: TIconInfo;
 DC: HDC;
 scrRect: TRect;
 CAPTUREBIT: Integer;
begin
 DC := GetDC(0);

 scrRect := Screen.DesktopRect;
 SetBigBitmapSize(FBackBuffer, scrRect.Right - scrRect.Left, scrRect.Bottom - scrRect.Top);

 CAPTUREBIT := 0;

 if FTransparentCapture = True then
  CAPTUREBIT := CAPTUREBLT;

 with FBackBuffer do
  BitBlt(FBackBuffer.Canvas.Handle, 0, 0, FBackBuffer.Width, FBackBuffer.Height,
         DC, scrRect.Left, scrRect.Top, SRCCOPY or CAPTUREBIT);

 if FCaptureCursor = True then begin
  CursorInfo := CaptureCursor;
  GetIconInfo(CursorInfo.hCursor, piconinfo);

  DrawIcon(FBackBuffer.Canvas.Handle, 
           CursorInfo.ptScreenPos.X - piconinfo.xHotspot, 
           CursorInfo.ptScreenPos.Y - piconinfo.yHotspot,
           CursorInfo.hCursor);
 end;

 FCaptureRect := Rect(0, 0, FBackBuffer.Width, FBackBuffer.Height);

 ReleaseDC(0, DC);
end;

procedure TCaptureEngine.BeginCapture;
begin
 // ** 활성화 되어 있을 경우에만 ** //
 if GetActiveWindow = Application.MainForm.Handle then
   // ** 캡쳐 시작 후 이전 창이 비활성화 되는것을 방지 ** //
   SetForegroundWindow(Application.Handle);

 if FAppHide = True then begin
  if FAppNotActive = True then begin
   // ** 이미 최소화 되어 있다면 무시한다. ** //
   if IsIconic(Application.Handle) = False then
    Application.Restore;
   Application.Minimize;
   ShowWindow(Application.Handle, SW_HIDE);
   
   Exit;
  end;
  ShowWindow(Application.Handle, SW_HIDE);
  // ShowWindow(Application.MainForm.Handle, SW_HIDE); 같은 형태로
  // 절대로 접근하면 안됩니다. 반드시 VCL코드를 이용해야 합니다.
  // 그렇지 않으면 특정 상황에서 컨트롤들이 화면상에서 모두 사라집니다.
  Application.MainForm.Hide;
 end;
 
 Sleep(FSleep);
end;

procedure TCaptureEngine.EndCapture(bCaptureSuccess: Boolean);
var
  bScrollClipboard: Boolean;
begin
 if (FSaveClipBoard = True) and (bCaptureSuccess = True) then begin

  bScrollClipboard := False;
  if Assigned(FScrollBitmap) = True then
   if (FScrollBitmap.Width > 0) and (FScrollBitmap.Height > 0) then begin
    Clipboard.Assign(FScrollBitmap);

    bScrollClipboard := True;
   end;

  if bScrollClipboard = False then
   Clipboard.Assign(FCaptureBitmap);
 end;

 if (FWavFilePath <> '') and (bCaptureSuccess = True)then
  PlaySound(PChar(FWavFilePath), 0, SND_FILENAME);

 if FAppHide = True then begin
  if FAppNotActive = True then begin
   ShowWindow(Application.Handle, SW_SHOW);
   Application.MainForm.Show;

   Exit;
  end;
  ShowWindow(Application.Handle, SW_SHOW);

  // ShowWindow(Application.MainForm.Handle, SW_SHOW); 같은 형태로
  // 절대로 접근하면 안됩니다. 반드시 VCL코드를 이용해야 합니다.
  // 그렇지 않으면 특정 상황에서 컨트롤들이 화면상에서 모두 사라집니다.
  Application.MainForm.Show;

  Application.Restore;
  SetWindowPos(Application.MainForm.Handle, HWND_TOPMOST, 
               0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  SetWindowPos(Application.MainForm.Handle, HWND_NOTOPMOST,
               0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  SetForegroundWindow(Application.MainForm.Handle);
 end;

end;

procedure TCaptureEngine.ExtendBitmap32Height(ABitmap: TBitmap32; NewWidth, NewHeight: Integer);
var
 BufferBitmap:TBitmap32;
begin
 BufferBitmap := TBitmap32.Create;
  try
   BufferBitmap.SetSize(ABitmap.Width, ABitmap.Height);

   BufferBitmap.Draw(0, 0, ABitmap);

   ABitmap.SetSize(NewWidth, NewHeight);
   ABitmap.Draw(0, 0, BufferBitmap);
  finally
   BufferBitmap.Free;
  end;
end;

procedure TCaptureEngine.IEScrollCapture(WindowHandle:HWND;ScrollDelay:Integer;var ABitmap:TBitmap32);
Const
 ScrollHeight = 5000;
var
 lpClassName: Array[0..255] of Char;
 lpRect: TRect;
 IE: IWebbrowser2;
 FrameNumber: Integer;
 ScrollSize: Integer;
 FHeight: Integer;
 IsHorzScrollBar: Boolean;
 bBitmap, nBitmap: TBitmap;
 DC: HDC;
begin
 // ** 시작하기 전에 포커스를 갖게 한다 ** //
 SetForegroundWindow(WindowHandle);

 // ** 스크롤 된 프레임이 변경됬는지 점검하는 변수 ** //
 FrameNumber :=  - 1;

 if GetIEFromHandle(WindowHandle, IE) = S_OK then begin
  GetWorkRect(WindowHandle, lpRect);

  Inc(lpRect.Left, GetSystemMetrics(SM_CXEDGE));
  Inc(lpRect.Top, GetSystemMetrics(SM_CYEDGE));

  Dec(lpRect.Right, GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXVSCROLL));
  Dec(lpRect.Bottom, GetSystemMetrics(SM_CYEDGE));

  GetClassName(GetParent(GetParent(GetParent(WindowHandle))),
               lpClassName, SizeOf(lpClassName));

  if lpClassName = 'Internet Explorer_Server' then begin
   GetWorkRect(WindowHandle, lpRect);
   Dec(lpRect.Right, GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXVSCROLL));
  end;

  DC := GetDC(0);

  with ABitmap do begin
   Width := lpRect.Right - lpRect.Left;
   Height := lpRect.Bottom - lpRect.Top;
   BitBlt(Canvas.Handle, 0, 0, Width, Height, DC, 
          lpRect.Left, lpRect.Top, SRCCOPY);
  end;

  bBitmap := TBitmap.Create;
  nBitmap := TBitmap.Create;
  try
   bBitmap.Width := ABitmap.Width;
   bBitmap.Height := GetSystemMetrics(SM_CXHSCROLL) - 6;
   nBitmap.Width := ABitmap.Width;
   nBitmap.Height := GetSystemMetrics(SM_CXHSCROLL) - 6;

   with bBitmap do
    BitBlt(Canvas.Handle, 0, 0, Width, Height, 
           DC, lpRect.Left, lpRect.Bottom - Height, SRCCOPY);

   ScrollSize := GetIEScrollSize(WindowHandle, IE, FrameNumber);

   with nBitmap do
    BitBlt(Canvas.Handle, 0, 0, Width, Height,
           DC, lpRect.Left, lpRect.Bottom - Height, SRCCOPY);

   if ScrollSize > 0 then
    IsHorzScrollBar := CompareBitmap(bBitmap, nBitmap, 0)
   else IsHorzScrollBar := False;
  finally
   bBitmap.Free;
   nBitmap.Free;
  end;

  if IsHorzScrollBar = True then begin
   Dec(lpRect.Bottom, GetSystemMetrics(SM_CYHSCROLL));
   ExtendBitmap32Height(ABitmap, ABitmap.Width, ABitmap.Height - GetSystemMetrics(SM_CYHSCROLL));
   //ABitmap.Height := ABitmap.Height - GetSystemMetrics(SM_CYHSCROLL);
  end;

  FHeight := ABitmap.Height;

  while ScrollSize > 0 do begin

   if FkeyState = True then
    Break;

   Sleep(ScrollDelay);

   with ABitmap do begin
    Inc(FHeight, ScrollSize);
    if Height < FHeight then
     //Height := Height + ScrollHeight;
     ExtendBitmap32Height(ABitmap, ABitmap.Width, Height + ScrollHeight);

    BitBlt(Canvas.Handle, 0, FHeight - ScrollSize, Width, ScrollSize,
           DC, lpRect.Left, lpRect.Bottom - ScrollSize, SRCCOPY);
   end;
   ScrollSize := GetIEScrollSize(WindowHandle, IE, FrameNumber);

   Application.ProcessMessages;
  end;

  ReleaseDC(0, DC);

  //ABitmap.Height := FHeight;
  ExtendBitmap32Height(ABitmap, ABitmap.Width, FHeight);

 end;

end;

function TCaptureEngine.WindowScrollCapture(WindowHandle: HWND; ScrollDelay: Integer; var ABitmap: TBitmap32): Boolean;

 procedure ScrollBarDown(ScrollBarHandle: HWND);
 var
  WindowRect: TRect;
 begin
  Sleep(10);

  GetWindowRect(ScrollBarHandle, WindowRect);

  SetCursorPos(WindowRect.Right - 2, WindowRect.Bottom - 2);

  Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
  Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);

  Sleep(40);
 end;

 function ScrollDown(WindowHandle: HWND):Integer;
 var
  bScrollPos, nScrollPos: Integer;
  ScrollInfo: TScrollInfo;
  ScrollBarHandle: HWND;
 begin
  bScrollPos := 0;  nScrollPos := 0; ScrollBarHandle := 0;

  if IsScrollnBar(0, WindowHandle, SB_VERT) = True then begin

   bScrollPos := GetScrollPos(WindowHandle, SB_VERT);
   SendMessage(WindowHandle, WM_VSCROLL, SB_LINEDOWN, 0);
   nScrollPos := GetScrollPos(WindowHandle, SB_VERT);

   Result := nScrollPos - bScrollPos;

  end else if GetScrollBarHandle(WindowHandle) <> 0 then begin

   ScrollBarHandle := GetScrollBarHandle(WindowHandle);

   bScrollPos := GetScrollPos(ScrollBarHandle, SB_CTL);
   ScrollBarDown(ScrollBarHandle);
   nScrollPos := GetScrollPos(ScrollBarHandle, SB_CTL);

   Result := nScrollPos - bScrollPos;
  end;


  ZeroMemory(@ScrollInfo, SizeOf(ScrollInfo));
  ScrollInfo.cbSize := SizeOf(ScrollInfo);
  ScrollInfo.fMask := SIF_RANGE;

  if ScrollBarHandle = 0 then
   GetScrollInfo(WindowHandle, SB_VERT, ScrollInfo)
  else GetScrollInfo(ScrollBarHandle, SB_CTL, ScrollInfo);
         
  if bScrollPos = ScrollInfo.nMax then
   Result := 0;
   
 end;

 function GetScrollSize(DC: HDC; WindowHandle: HWND; DefaultSize: Integer; var Margin: Integer):Integer;
 Const
  bHeight = 50;
  ScrollMargin = 20;
  MaxScrollSize = 150;
 var
  i: Integer;
  MarginBitmap: TBitmap;
  bBitmap, nBitmap: TBitmap;
  Rect: TRect;
 begin
  Result := 0;

  bBitmap := TBitmap.Create;
  nBitmap := TBitmap.Create;
   try
    GetWorkRect(WindowHandle, Rect);

    bBitmap.Width := Rect.Right - Rect.Left;
    nBitmap.Width := bBitmap.Width;
    bBitmap.Height := bHeight;
    nBitmap.Height := bHeight;

    with bBitmap do
     BitBlt(Canvas.Handle, 0, 0, Width, Height, DC, 
            Rect.Left, Rect.Bottom - bHeight - ScrollMargin, SRCCOPY);

    if ScrollDown(WindowHandle) = 0 then begin
     Result := 0;
     Exit;
    end;

    // 스크롤을 한 후 ScrollDealy만큼 쉽니다.
    Sleep(ScrollDelay);
    
    // ****재확인하는 부분********* //
    if DefaultSize > 0 then
     with nBitmap do begin
      BitBlt(Canvas.Handle, 0, 0, Width, Height, DC, 
             Rect.Left, Rect.Bottom - bHeight - ScrollMargin - DefaultSize, SRCCOPY);
      if CompareBitmap(bBitmap, nBitmap, 0) = True then begin
       Result := DefaultSize;
       Exit;
      end;
      
     end;
    // ************* //

    // *****공백을 점검하는 부분******** //
     with nBitmap do
      BitBlt(Canvas.Handle, 0, 0, Width, Height, DC, 
             Rect.Left, Rect.Bottom - bHeight, SRCCOPY);

    MarginBitmap := TBitmap.Create;
     try
      with MarginBitmap do begin
      Width := nBitmap.Width;
      Height := nBitmap.Height;
      Canvas.Brush.Color := nBitmap.Canvas.Pixels[0, bHeight - 1];
      Canvas.FillRect(Canvas.ClipRect);
     end;

      for i := ScrollMargin downto 1 do begin
       if CompareBitmap(MarginBitmap, nBitmap, bHeight - i) = True then begin
        Margin := i;
        break;
        end else Margin := 0;
      end;
     finally
     MarginBitmap.Free;
     end;

   // ************* //

   // *****화면이 움직인 위치를 조사하는 부분******** //
    for i := 0 to MaxScrollSize do begin
     with nBitmap do
      BitBlt(Canvas.Handle, 0, 0, Width, Height, DC, 
             Rect.Left, Rect.Bottom - bHeight - ScrollMargin - i, SRCCOPY);

      if CompareBitmap(bBitmap, nBitmap, 0) = True then begin
       Result := i;
       break;
      end;
    end;

   // ************* //

   finally
    bBitmap.Free;
    nBitmap.Free;
   end;

 end;

Const
 ScrollHeight = 5000;
var
 TmpBitmap: TBitmap32;

 DC: HDC;
 lpRect: TRect;

 FHeight: Integer;
 ScrollSize: Integer;

 hSelfProcess: THandle;
 hTargetProcess: THandle;

 ScrollHookTarget: TScrollHookTarget;
 ScrollData: TScrollData;

 lpClassName: Array[0..144] of Char;

 ScrollMargin: Integer;
 DummyMargin: Integer;

 // 이 변수값이 True이면 커널훅을 이용한 스크롤 캡쳐를 진행하며
 // FALSE인 경우에는 화면 비교방식을 이용하여 스크롤 캡쳐를 진행합니다.
 bKernelHookSuccessed: Boolean;
begin
 if CaptureDriverLoad = False then begin
  Result := False;

  Exit;
 end;
 Result := True;

 GetClassname(WindowHandle, lpClassName, sizeof(lpClassName));

 hSelfProcess := GetCurrentProcessId;
 // Cmd 창 윈도우일 경우 ScrollDC API를 이용하여 스크롤하게 되는데
 // 이 때 ScrollDC를 호출하는 프로세스가 cmd.exe가 아닌
 // csrss.exe 시스템 프로세스가 스크롤하게 된다.
 if lpClassName = 'ConsoleWindowClass' then
  hTargetProcess := GetPIDFromProcessName('csrss.exe')
 else
  GetWindowThreadProcessId(WindowHandle, hTargetProcess);

 ScrollHookTarget.hTargetWindow := WindowHandle;
 ScrollHookTarget.hSelfProcess := hSelfProcess;
 ScrollHookTarget.hTargetProcess := hTargetProcess;
 SendDataToDriver(FCaptureDriver, 1, @ScrollHookTarget, sizeof(TScrollHookTarget), Nil, 0);
 try
  DC := GetDC(0);

  GetWorkRect(WindowHandle, lpRect);
   // 시작하기 전에 포커스를 갖게 한다 ** //
  SetForegroundWindow(WindowHandle);
  // ** 화면을 다시 그려지는 동안 기다린다 ** //
  Sleep(1000);

  with ABitmap do begin
   Width := lpRect.Right - lpRect.Left;
   Height := lpRect.Bottom - lpRect.Top;
   BitBlt(Canvas.Handle, 0, 0, Width, Height, DC,
           lpRect.Left, lpRect.Top, SRCCOPY);
  end;

  ScrollSize := 0;

  ScrollMargin := 0;
  DummyMargin := 0;

  // 이미지 비교방식을 통해 스크롤이 움직였는지 확인합니다.
  ScrollSize := GetScrollSize(DC, WindowHandle, 0, ScrollMargin);
  //Sleep(ScrollDelay);

  SendDataToDriver(FCaptureDriver, 2, Nil, 0, @ScrollData, sizeof(TScrollData));
  if (-ScrollData.dy) > 0 then begin
   // 커널에서 훅킹하였을 때 스크롤이 움직였다면 커널 훅킹방식으로 스크롤 캡쳐합니다.
   bKernelHookSuccessed := True;

   // GetScrollSize함수를 호출함으로 인해서 변한 ScrollMargin변수를 다시 초기화합니다.
   ScrollMargin := 0;
   
   // 윈도우 전역 Edit클래스 컨트롤일 경우 1픽셀 스크롤 오차가
   // 발생하므로 이를 방지합니다.
   GetClassName(WindowHandle, lpClassName, sizeof(lpClassName));
   if (lpClassName = 'Edit') or (lpClassName = 'TMemo') then
    ScrollMargin := 1;

   ScrollSize := -ScrollData.dy;
   if IsRectEmpty(ScrollData.rcScroll) = False then begin
    TmpBitmap := TBitmap32.Create;
    try
     TmpBitmap.Assign(ABitmap);

     ABitmap.SetSize(ScrollData.rcScroll.Right - ScrollData.rcScroll.Left,
                     ScrollData.rcScroll.Bottom - ScrollData.rcScroll.Top);
     ABitmap.Draw(0, 0, ScrollData.rcScroll, TmpBitmap);

     lpRect := ScrollData.rcScroll;
     ClientToScreen(WindowHandle, lpRect.TopLeft);
     ClientToScreen(WindowHandle, lpRect.BottomRight);
    finally
     TmpBitmap.Free;
    end;
   end;
  end else begin
   // 커널에서 훅킹하였을 때 스크롤을 체크하지 못 하였다면 화면 비교방식으로 스크롤 캡쳐합니다.
   bKernelHookSuccessed := False;

   ExtendBitmap32Height(ABitmap, ABitmap.Width, ABitmap.Height - ScrollMargin);
  end;

  FHeight := ABitmap.Height;

  
  while ScrollSize > 0 do begin
    if FkeyState = True then
     Break;

    with ABitmap do begin
     Inc(FHeight, ScrollSize);
     if Height < FHeight then
      ExtendBitmap32Height(ABitmap, ABitmap.Width, Height + ScrollHeight);

     BitBlt(Canvas.Handle, 0, FHeight - ScrollSize, Width, ScrollSize,
            DC, lpRect.Left, lpRect.Bottom - ScrollSize - ScrollMargin, SRCCOPY);

    end;

   if bKernelHookSuccessed = True then begin
    ScrollDown(WindowHandle);

    Sleep(ScrollDelay);

    SendDataToDriver(FCaptureDriver, 2, Nil, 0, @ScrollData, sizeof(TScrollData));
    ScrollSize := -ScrollData.dy;
   end else begin
    ScrollSize := GetScrollSize(DC, WindowHandle, ScrollSize, DummyMargin);
   end;

   Application.ProcessMessages;
  end;
  ExtendBitmap32Height(ABitmap, ABitmap.Width, FHeight);

  ReleaseDC(0, DC);
 finally
   CaptureDriverUnLoad;
 end;
end;

function TCaptureEngine.MozillaScrollCapture(WindowHandle:HWND;ScrollDelay:Integer;var ABitmap:TBitmap32):Boolean;
Const
 ScrollHeight = 5000;
 bHeight_Noraml = 100;
 bHeight_Small = 25;
 WindowHeight_Min = 60;

 procedure ScrollBarDown(WindowHandle: HWND);
 var
  WindowRect: TRect;
 begin
  Sleep(10);

  GetWindowRect(WindowHandle, WindowRect);

  SetCursorPos(WindowRect.Right + 1, WindowRect.Bottom - 1);
  Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
  Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);

  Sleep(30);
 end;

 procedure ScrollBarPageDown(WindowHandle: HWND);
 var
  WindowRect: TRect;
 begin
  Sleep(10);

  GetWindowRect(WindowHandle, WindowRect);

  SetCursorPos(WindowRect.Right + 1, WindowRect.Bottom - GetSystemMetrics(SM_CYVTHUMB) - 1);
  Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
  Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);

  Sleep(30);
 end;

 function GetScrollHookSize(WindowHandle: HWND; ScrollHookHandle: HWND; bPageScroll: Boolean):Integer;
 Const
  TimeOut = 300;
 var
  lpRect: TRect;
  OldTop: Integer;
  OldTime, NowTime: DWORD;
 begin
  // 이 부분에서 기다리는 시간동안 Sleep 을 쓰면 파이어 폭스도 같이 다운먹습니다.
  OldTime := GetTickCount;

  GetWindowRect(ScrollHookHandle, lpRect);
  OldTop := lpRect.Top;

  // 원래는 웹 페이지 컨텐츠 핸들이 아닌 부모 윈도우 핸들로 보내야 하지만
  // 컨텐츠에 영역을 벗어난 좌표에 마우스 메세지를 보내도 스크롤을 하므로
  // 이런식으로 진행하였습니다.
  if bPageScroll = True then
   ScrollBarPageDown(WindowHandle)
  else ScrollBarDown(WindowHandle);

  Application.ProcessMessages;

  // 타임 아웃 시간동안 스크롤이 되었는지 계속 체크합니다.
  while True do begin
   GetWindowRect(ScrollHookHandle, lpRect);
   if OldTop <> lpRect.Top then
    Break;

   NowTime := GetTickCount;
   if (NowTime - OldTime) >= (TimeOut + ScrollDelay) then
    Break;

   // ** 파이어 폭스가 응답 할 수 있도록 해준다. ** //
   Application.ProcessMessages;
  end;

  // ** 스크롤이 된 후 화면이 업데이트되는 동안 기다린다 ** //
  OldTime := GetTickCount;
  while True do begin
   NowTime := GetTickCount;
   if (NowTime - OldTime) >= ScrollDelay + 100 then
    Break;                            

   // ** 파이어 폭스가 응답 할 수 있도록 해준다. ** //
   Application.ProcessMessages;
  end;

  if (lpRect.Top >= 0) and (OldTop >= 0) then
   Result := OldTop - lpRect.Top
  else if (lpRect.Top < 0) and (OldTop >= 0) then
   Result := OldTop + Abs(lpRect.Top)
  else if (lpRect.Top < 0) and (OldTop < 0) then
   Result := Abs(lpRect.Top) - Abs(OldTop);

  //Result := Abs(ScrollHookButton.Top) - Abs(OldTop);
 end;

 function GetScrollSize(DC: HDC; WindowHandle: HWND; ScrollHookHandle: HWND; DefaultSize: Integer; var IsScrollHook: Boolean):Integer;
 Const
  MaxScrollSize = 150;
  TimeOut = 100;
 var
  i:Integer;
  bHeight:Integer;
  bBitmap, nBitmap:TBitmap;
  lpRect:TRect;
  OldTime, NowTime: DWORD;
 begin
  Result := 0;

  bBitmap := TBitmap.Create;
  nBitmap := TBitmap.Create;
   try
    GetWindowRect(WindowHandle, lpRect);

    bHeight := bHeight_Noraml;
    // ** 비교되는 비트맵 높이보다 작다면 ** //
    if lpRect.Bottom - lpRect.Top < 150 then
     bHeight := bHeight_Small;

    // ** 화면상에 왼쪽절반부분만 이미지 비교를 한다. ** //
    bBitmap.Width := (lpRect.Right - lpRect.Left) div 2;
    nBitmap.Width := bBitmap.Width;
    bBitmap.Height := bHeight;
    nBitmap.Height := bHeight;

    with bBitmap do
     BitBlt(Canvas.Handle, 0, 0, Width, Height, DC, 
            lpRect.Left, lpRect.Bottom - bHeight, SRCCOPY);

    if IsScrollHook = True then begin
     Result := GetScrollHookSize(WindowHandle, ScrollHookHandle, False);
     if Result > 0 then
      Exit;

     IsScrollHook := False;
    end else begin
     ScrollBarDown(WindowHandle);
     // ** 스크롤이 된 후 화면이 업데이트 되는 동안 기다린다. ** //
     // ** 버튼 설치 후 화면 업데이트가 안됨 ** //
     OldTime := GetTickCount;
     while True do begin
      NowTime := GetTickCount;
      if (NowTime - OldTime) >= (TimeOut + ScrollDelay) then
       Break;

      // ** 파이어 폭스가 응답 할 수 있도록 해준다. ** //
      Application.ProcessMessages;
     end;

    end;

    // ****재확인하는 부분********* //
    if DefaultSize > 0 then
     with nBitmap do begin
      BitBlt(Canvas.Handle, 0, 0, Width, Height, DC, 
             lpRect.Left, lpRect.Bottom - bHeight - DefaultSize, SRCCOPY);
      if CompareBitmap(bBitmap, nBitmap, 0) = True then begin
       Result := DefaultSize;
       Exit;
      end;

     end;
    // ************* //

   // *****화면이 움직인 위치를 조사하는 부분******** //
    for i := 0 to MaxScrollSize do begin
     with nBitmap do
      BitBlt(Canvas.Handle, 0, 0, Width, Height, DC, 
             lpRect.Left, lpRect.Bottom - bHeight - i, SRCCOPY);

      if CompareBitmap(bBitmap, nBitmap, 0) = True then begin
       Result := i;
       break;
      end;
    end;

   // ************* //

   finally
    bBitmap.Free;
    nBitmap.Free;
   end;

 end;

var
 DC: HDC;
 lpRect: TRect;
 FHeight: Integer;
 ScrollSize: Integer;
 ScrollHookButton: TButton;
 ScrollHookHandle: HWND;
 IsScrollHook: Boolean;
begin
 Result := True;

 DC := GetDC(0);

 GetWindowRect(WindowHandle, lpRect);

 // ** 윈도우의 크기가 너무 작다면 나간다 ** //
 if lpRect.Bottom - lpRect.Top <= WindowHeight_Min then begin
  Result := False;
  SetForegroundWindow(Application.Handle);
  InfoMessage(errMinSize);
  Exit;
 end;

 // ** 화면을 다시 그려지는 동안 기다린다 ** //
 Sleep(1000);

 with ABitmap do begin
  Width := lpRect.Right - lpRect.Left;
  Height := lpRect.Bottom - lpRect.Top;
  BitBlt(Canvas.Handle, 0, 0, Width, Height, DC, 
         lpRect.Left, lpRect.Top, SRCCOPY);

 end;

 ScrollHookButton := Nil;
 ScrollHookHandle := 0;
 ScrollHookHandle := FindWindowEx(WindowHandle, 0, 'MozillaWindowClass', Nil);

 if ScrollHookHandle = 0 then
  ScrollHookHandle := FindWindowEx(WindowHandle, 0, 'MozillaContentFrameWindowClass', Nil);

 if ScrollHookHandle = 0 then begin

  ScrollHookButton := TButton.CreateParented(0);
  with ScrollHookButton do begin
   ParentWindow := WindowHandle;
   Left := 0;
   Top := 0;
   Hide;
   ScrollHookHandle := Handle;
  end;
  
 end;

 IsScrollHook := True;
 ScrollSize := GetScrollSize(DC, WindowHandle, ScrollHookHandle, 0, IsScrollHook);
 //ScrollSize := GetScrollSize(DC, WindowHandle, 0);

 if (IsScrollHook = False) and (ScrollHookButton <> Nil) then begin
  ScrollHookButton.Free;
  ScrollHookButton := Nil;
 end;

 FHeight := ABitmap.Height;
 
 try
  while ScrollSize > 0 do begin

   if FkeyState = True then
    Break;

   with ABitmap do begin
    Inc(FHeight, ScrollSize);
    if Height < FHeight then
     //Height := Height + ScrollHeight;
     ExtendBitmap32Height(ABitmap, ABitmap.Width, Height + ScrollHeight);

    BitBlt(Canvas.Handle, 0, FHeight - ScrollSize, Width, ScrollSize,
           DC, lpRect.Left, lpRect.Bottom - ScrollSize, SRCCOPY);

   end;

   if IsScrollHook = False then begin
    ScrollSize := GetScrollSize(DC, WindowHandle, 0, ScrollSize, IsScrollHook)
    end else
   ScrollSize := GetScrollHookSize(WindowHandle, ScrollHookHandle, True);

   Application.ProcessMessages;
  end;
 finally
  if ScrollHookButton <> Nil then
   ScrollHookButton.Free;
 end;

 ExtendBitmap32Height(ABitmap, ABitmap.Width, FHeight);
 //ABitmap.Height := FHeight;

 ReleaseDC(0, DC);
end;

function TCaptureEngine.Office2007ScrollCapture(WindowHandle: HWND; ScrollDelay: Integer; var ABitmap: TBitmap32): Boolean;

 procedure ScrollBarDown(TargetHandle: HWND);
 var
  WindowRect: TRect;
 begin
  Sleep(10);

  GetWindowRect(TargetHandle, WindowRect);

  if IsMSOfficeExcel2007ScrollBar(TargetHandle) = True then
   SetCursorPos(WindowRect.Right - 10, WindowRect.Bottom - 30)
  else
   SetCursorPos(WindowRect.Right + 5, WindowRect.Bottom - 60);

  Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
  Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);

  Sleep(30);
 end;

Const
 ScrollHeight = 5000;
 ScrollDelayMaxCount = 3;

 ScrollOfficeDelay = 100;
var
 TmpBitmap: TBitmap32;

 DC: HDC;
 lpRect:TRect;

 FHeight: Integer;
 ScrollSize:Integer;

 hSelfProcess: THandle;
 hTargetProcess: THandle;

 ScrollHookTarget: TScrollHookTarget;
 ScrollData: TScrollData;

 ScrollFirstDelay: Integer;

 lpClassName: array[0..144] of Char;
begin
 if CaptureDriverLoad = False then begin
  Result := False;

  Exit;
 end;
 Result := True;

 hSelfProcess := GetCurrentProcessId;
 GetWindowThreadProcessId(WindowHandle, hTargetProcess);

 ScrollHookTarget.hTargetWindow := WindowHandle;
 ScrollHookTarget.hSelfProcess := hSelfProcess;
 ScrollHookTarget.hTargetProcess := hTargetProcess;
 SendDataToDriver(FCaptureDriver, 1, @ScrollHookTarget, sizeof(TScrollHookTarget), Nil, 0);

 try
  DC := GetDC(0);

  GetWorkRect(WindowHandle, lpRect);
   // 시작하기 전에 포커스를 갖게 한다 ** //
  SetForegroundWindow(WindowHandle);
  // ** 화면을 다시 그려지는 동안 기다린다 ** //
  Sleep(1000);

  with ABitmap do begin
   Width := lpRect.Right - lpRect.Left;
   Height := lpRect.Bottom - lpRect.Top;
   BitBlt(Canvas.Handle, 0, 0, Width, Height, DC,
           lpRect.Left, lpRect.Top, SRCCOPY);
  end;

  ScrollSize := 0;

  ScrollBarDown(WindowHandle);
  Sleep(ScrollDelay + ScrollOfficeDelay);

  // 처음 스크롤바를 클릭하는 경우 오피스 계열 프로그램에서
  // 바로 스크롤이 안되고 지연되는 경우가 발생 할 수 있습니다.
  // 따라서 사용자가 설정한 딜레이 값에 추가적으로 내부적으로 딜레이를 더 두어서
  // 3초간 기다린 후 스크롤이 안되면 실패로 간주합니다.
  ScrollFirstDelay := 0;
  while True do begin
   SendDataToDriver(FCaptureDriver, 2, Nil, 0, @ScrollData, sizeof(TScrollData));
   if ScrollData.dy <> 0 then
    break;

   Inc(ScrollFirstDelay);
   if ScrollFirstDelay > ScrollDelayMaxCount then
    break;

   Sleep(1000);
  end;

  ScrollSize := -ScrollData.dy;
  if IsRectEmpty(ScrollData.rcScroll) = False then begin
   TmpBitmap := TBitmap32.Create;
   try
    TmpBitmap.Assign(ABitmap);

    ABitmap.SetSize(ScrollData.rcScroll.Right - ScrollData.rcScroll.Left,
                    ScrollData.rcScroll.Bottom - ScrollData.rcScroll.Top);
    ABitmap.Draw(0, 0, ScrollData.rcScroll, TmpBitmap);

    lpRect := ScrollData.rcScroll;
    ClientToScreen(WindowHandle, lpRect.TopLeft);
    ClientToScreen(WindowHandle, lpRect.BottomRight);
   finally
    TmpBitmap.Free;
   end;
  end;
  FHeight := ABitmap.Height;

  while ScrollSize > 0 do begin
    if FkeyState = True then
     Break;

    with ABitmap do begin
     Inc(FHeight, ScrollSize);
     if Height < FHeight then
      ExtendBitmap32Height(ABitmap, ABitmap.Width, Height + ScrollHeight);

     BitBlt(Canvas.Handle, 0, FHeight - ScrollSize, Width, ScrollSize,
            DC, lpRect.Left, lpRect.Bottom - ScrollSize, SRCCOPY);

    end;
   ScrollBarDown(WindowHandle);
   Sleep(ScrollDelay + ScrollOfficeDelay);

   SendDataToDriver(FCaptureDriver, 2, Nil, 0, @ScrollData, sizeof(TScrollData));
   ScrollSize := -ScrollData.dy;

   Application.ProcessMessages;
  end;
  ExtendBitmap32Height(ABitmap, ABitmap.Width, FHeight);

  ReleaseDC(0, DC);                                          
 finally
   CaptureDriverUnLoad;
 end;
end;

function TCaptureEngine.GoogleChromeScrollCapture(WindowHandle: HWND; ScrollDelay: Integer; var ABitmap: TBitmap32): Boolean;

 procedure ScrollBarDown(TargetHandle: HWND);
 var
  WindowRect: TRect;
 begin
  GetWindowRect(TargetHandle, WindowRect);

  SetCursorPos(WindowRect.Right - 5, WindowRect.Bottom - 1);

  Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
  Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);

  Sleep(100);
 end;

 procedure ScrollPageDown(TargetHandle: HWND);
 var
  WindowRect: TRect;
 begin
  GetWindowRect(TargetHandle, WindowRect);

  SetCursorPos(WindowRect.Right - 5, WindowRect.Bottom - GetSystemMetrics(SM_CYVTHUMB) - 1);

  Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
  Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);

  Sleep(100);
 end;

Const
 ScrollHeight = 5000;
 ScrollDelayMaxCount = 3;

 ScrollOfficeDelay = 100;
var
 TmpBitmap: TBitmap32;

 DC: HDC;
 lpRect:TRect;

 FHeight: Integer;
 ScrollSize:Integer;

 hSelfProcess: THandle;
 hTargetProcess: THandle;

 ScrollHookTarget: TScrollHookTarget;
 ScrollData: TScrollData;

 ScrollFirstDelay: Integer;

 lpClassName: array[0..144] of Char;
begin
 {
 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 // 현재 이 함수는 작업중인 함수이며 구글 크롬을 지원하기 위한 탬플릿역할을 합니다.
 // 구글 크롬에 경우 스크롤 시 일반적으로 ScrollWindowEx, ScrollDC를 같이 호출하게 됩니다.
 //
 // 또한 Scroll 계열 API를 사용하는 페이지와 전혀 사용하지 않는 페이지가 존재할 수 있습니다.
 //
 // 마지막으로 Scroll 계열 API를 사용하는 페이지인 경우인데도 불구하고
 // 간혹 해당 API를 사용하지 않고 두 번째 다시 스크롤 시 그 API가 호출되는 경우가 있을 수 있습니다.
 //
 // 위에 사항들을 고려하여 개발을 진행해야 합니다.
 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 }
 if CaptureDriverLoad = False then begin
  Result := False;

  Exit;
 end;
 Result := True;

 hSelfProcess := GetCurrentProcessId;
 GetWindowThreadProcessId(WindowHandle, hTargetProcess);

 ScrollHookTarget.hTargetWindow := WindowHandle;
 ScrollHookTarget.hSelfProcess := hSelfProcess;
 ScrollHookTarget.hTargetProcess := hTargetProcess;
 SendDataToDriver(FCaptureDriver, 1, @ScrollHookTarget, sizeof(TScrollHookTarget), Nil, 0);

 try
  DC := GetDC(0);

  GetWorkRect(WindowHandle, lpRect);
  Dec(lpRect.Right, GetSystemMetrics(SM_CXVSCROLL));
  Dec(lpRect.Bottom);
   // 시작하기 전에 포커스를 갖게 한다 ** //
  SetForegroundWindow(WindowHandle);
  // ** 화면을 다시 그려지는 동안 기다린다 ** /

  Sleep(1000);

  with ABitmap do begin
   Width := lpRect.Right - lpRect.Left;
   Height := lpRect.Bottom - lpRect.Top;
   BitBlt(Canvas.Handle, 0, 0, Width, Height, DC,
           lpRect.Left, lpRect.Top, SRCCOPY);
  end;

  ScrollSize := 0;

  ScrollBarDown(WindowHandle);
  Sleep(ScrollDelay + ScrollOfficeDelay);

  ScrollFirstDelay := 0;
  while True do begin
   SendDataToDriver(FCaptureDriver, 2, Nil, 0, @ScrollData, sizeof(TScrollData));
   if ScrollData.dy <> 0 then
    break;

   Inc(ScrollFirstDelay);
   if ScrollFirstDelay > ScrollDelayMaxCount then
    break;

   Sleep(1000);
  end;

  ScrollSize := -ScrollData.dy;
  ScrollSize := ScrollSize div 2;
  if IsRectEmpty(ScrollData.rcScroll) = False then begin
   TmpBitmap := TBitmap32.Create;
   try
    TmpBitmap.Assign(ABitmap);

    ABitmap.SetSize(ScrollData.rcScroll.Right - ScrollData.rcScroll.Left,
                    ScrollData.rcScroll.Bottom - ScrollData.rcScroll.Top);
    ABitmap.Draw(0, 0, ScrollData.rcScroll, TmpBitmap);

    lpRect := ScrollData.rcScroll;
    ClientToScreen(WindowHandle, lpRect.TopLeft);
    ClientToScreen(WindowHandle, lpRect.BottomRight);
   finally
    TmpBitmap.Free;
   end;
  end;
  FHeight := ABitmap.Height;

  while ScrollSize > 0 do begin
    if FkeyState = True then
     Break;

    with ABitmap do begin
     Inc(FHeight, ScrollSize);
     if Height < FHeight then
      ExtendBitmap32Height(ABitmap, ABitmap.Width, Height + ScrollHeight);

     BitBlt(Canvas.Handle, 0, FHeight - ScrollSize, Width, ScrollSize,
            DC, lpRect.Left, lpRect.Bottom - ScrollSize, SRCCOPY);

    end;
   ScrollBarDown(WindowHandle);
   Sleep(ScrollDelay + ScrollOfficeDelay);

   ScrollFirstDelay := 0;
   while True do begin
    SendDataToDriver(FCaptureDriver, 2, Nil, 0, @ScrollData, sizeof(TScrollData));
    if ScrollData.dy <> 0 then
     break;

    Inc(ScrollFirstDelay);
    if ScrollFirstDelay > ScrollDelayMaxCount then
     break;

    Sleep(500);
   end;
   ScrollSize := -ScrollData.dy;
   ScrollSize := ScrollSize div 2;

   Application.ProcessMessages;
  end;
  ExtendBitmap32Height(ABitmap, ABitmap.Width, FHeight);

  ReleaseDC(0, DC);
 finally
   CaptureDriverUnLoad;
 end;

end;

function TCaptureEngine.ScrollCapture(WindowHandle:HWND;ScrollDelay:Integer;var ABitmap:TBitmap32):Boolean;

 function GetScrollStyle: Byte;
 begin
  if IsMozillaScrollBar(WindowHandle) = True then
   Result := sbMozilla
  else if IsIEScrollBar(WindowHandle) = True then
   Result := sbIE
  else if IsScrollBar(WindowHandle) = True then
   Result := sbNormal
  else if IsHangul2007ScrollBar(WindowHandle) = True then
   Result := sbHangul2007
  else if IsMSOfficeWord2007ScrollBar(WindowHandle) = True then
   Result := sbMSOffice2007Word
  else if IsMSOfficeExcel2007ScrollBar(WindowHandle) = True then
   Result := sbMSOffice2007Excel
  else if IsGoogleChromeScrollBar(WindowHandle) = True then
   Result := sbGoogleChrome
  else Result := sbError;
 end;

var
 ScrollStyle:Byte;
begin
 Result := True;

 ScrollStyle := GetScrollStyle;

  case ScrollStyle of
   sbMozilla : Result := MozillaScrollCapture(WindowHandle, ScrollDelay, ABitmap);
   sbIE : IEScrollCapture(WindowHandle, ScrollDelay, ABitmap);
   sbNormal : Result := WindowScrollCapture(WindowHandle, ScrollDelay, ABitmap);
   sbHangul2007, sbMSOffice2007Word, sbMSOffice2007Excel : Result := Office2007ScrollCapture(WindowHandle, ScrollDelay, ABitmap);
   sbGoogleChrome : Result := GoogleChromeScrollCapture(WindowHandle, ScrollDelay, ABitmap);
   sbError : Result := False;
  end;

end;

procedure TCaptureEngine.CaptureSetup(TransparentCapture, CaptureCursor, SaveClipBoard,
                        AppHide: Boolean; AppSleep: Integer; AppNotActive: Boolean;
                        WavFilePath: String);
begin
 FTransparentCapture := TransparentCapture;
 FCaptureCursor := CaptureCursor;
 FSaveClipBoard := SaveClipBoard;
 FAppHide := AppHide;
 FSleep := AppSleep;
 FAppNotActive := AppNotActive;

 FWavFilePath := WavFilePath;
end;

procedure TCaptureEngine.CaptureEntire;
begin

 BeginCapture;

 try

  ScreenCapture;
  FCaptureBitmap.Assign(FBackBuffer);

 finally
  EndCapture(True);
 end;

end;

function TCaptureEngine.CaptureUser(FShapeType:Integer):Boolean;
begin
 Result := False;

 BeginCapture;

 try
  ScreenCapture;

  with TfrmCapture.Create(Application) do begin
   UserCaptureType := ctUserCapture;
   ShapeType := FShapeType;
   CaptureSetup;
   case ShowModal of
    mrOK : begin

            with FCaptureBitmap do
             case ShapeType of
              stPolygon, stPolyline : begin
                                       Width := (PolyRect.Right - PolyRect.Left) + 1;
                                       Height := (PolyRect.Bottom - PolyRect.Top) + 1;

                                       BitBlt(Canvas.Handle, 0, 0, Width, Height, FBackBuffer.Canvas.Handle,
                                              PolyRect.Left, PolyRect.Top, SRCCOPY);

                                       // 원점 좌표이므로 데스크탑 좌표로 변경합니다.
                                       FCaptureRect := OriginCoordinateToDesktopCoordinate(PolyRect);
                                       Inc(FCaptureRect.Right, 1); Inc(FCaptureRect.Bottom, 1);
                                      end;
               else begin
                     NormalizePoint(NewPoint, EndPoint);
                     Width := (EndPoint.X - NewPoint.X) + 1;
                     Height := (EndPoint.Y - NewPoint.Y) + 1;
                     BitBlt(Canvas.Handle, 0, 0, Width, Height, FBackBuffer.Canvas.Handle, 
                            NewPoint.X, NewPoint.Y, SRCCOPY);

                     FCaptureRect := Rect(NewPoint.X, NewPoint.Y, EndPoint.X + 1, EndPoint.Y + 1);
                     FCaptureRect := OriginCoordinateToDesktopCoordinate(FCaptureRect);
                    end;
              end;

            if ShapeType <> stRect then
             if ShapeType in [stPolygon, stPolyLine] = True then
              EdgePolygonBitmap(FCaptureBitmap, PolygonPt, PolyRect)
             else EdgeBitmap(FCaptureBitmap, ShapeType);

            Free;
            Result := True;
           end;
    mrCancel : begin
                Free;
                Result := False;
               end;
   end;
  end;

 finally
  PolygonPt := Nil;
  EndCapture(Result);
 end;

end;

function TCaptureEngine.CaptureWindow(var FWindowName:String):Boolean;
var
 OriginRect: TRect;
begin
 Result := False;

 BeginCapture;

 try

  ScreenCapture;

  with TfrmCapture.Create(Application) do begin
   SelectHandle := 0;
   UserCaptureType := ctWindow;
   CaptureSetup;
   case ShowModal of
    mrOK : begin
           if SelectHandle = 0 then begin
            InfoMessage(errCaptureWindow);
            Result := False;
            Exit;
           end;

           FCaptureRect := LastRect;
           FWindowName := WindowName;

           OriginRect := DesktopCoordinateToOriginCoordinate(LastRect);
           DesktopCoordinateToOriginCoordinate(LastRgn);

           with FCaptureBitmap do begin
            SetBigBitmapSize(FCaptureBitmap,
                             OriginRect.Right - OriginRect.Left,
                             OriginRect.Bottom - OriginRect.Top);

            EdgeRgnBitmap(FBackBuffer, OriginRect.Left, OriginRect.Top, Width, Height, LastRgn);

            BitBlt(Canvas.Handle, 0, 0, Width, Height, FBackBuffer.Canvas.Handle, OriginRect.Left, OriginRect.Top, SRCCOPY);
           end;

           OriginCoordinateToDesktopCoordinate(LastRgn);

           Free;
           Result := True;
          end;
    mrCancel : begin
                Free;
                Result := False;
               end;
   end;
  end;

 finally
  EndCapture(Result);
 end;
end;

function TCaptureEngine.CaptureControl(var FWindowName: String;
                                       FAutoScroll, FInvalidate: Boolean;
                                       ScrollDelay: Integer): Boolean;
var
 lpRect:TRect;
 OriginRect: TRect;
begin
 Result := False;

 BeginCapture;

 try

  ScreenCapture;

  with TfrmCapture.Create(Application) do begin
   SelectHandle := 0;
   UserCaptureType := ctControl;
   AutoScroll := FAutoScroll;
   CaptureSetup;

   case ShowModal of
    mrOK : begin
           if SelectHandle = 0 then begin
            InfoMessage(errCaptureWindow);
            Result := False;
            Exit;
           end;

           GetWorkRect(SelectHandle, lpRect);

           if (AutoScroll = True) and
              ((IsScrollBar(SelectHandle) = True)
              or (IsWebScrollBar(SelectHandle) = True)
              or (IsOfficeScrollBar(SelectHandle) = True))
              and (PtInRect(lpRect, Mouse.CursorPos) = True) then begin

               if FInvalidate = True then
                InvalidateRect(0, Nil, True);

               Sleep(FSleep);

               thdKeyState := TthdKeyState.Create(False);
                try

                 try

                  if ScrollCapture(SelectHandle, ScrollDelay, FScrollBitmap) = False then begin
                   Result := False;
                   // ** case 문 빠져나감 ** //
                   Exit;
                  end;

                  FScrollBitmap.ResetAlpha;

                  except
                   on E: Exception do begin
                    ShowWindow(Application.Handle, SW_SHOW);
                    SetForegroundWindow(Application.Handle);
                    InfoMessage(errScrollCapture + #13 + #10 + #13 + #10 + E.Message);
                   end;
                  end;

                finally
                 thdKeyState.Terminate;
                 thdKeyState.WaitFor;
                 thdKeyState := Nil;

                 FKeyState := False;
                end;

            end else with FCaptureBitmap do begin
                      OriginRect := DesktopCoordinateToOriginCoordinate(LastRect);
                      DesktopCoordinateToOriginCoordinate(LastRgn);

                      SetBigBitmapSize(FCaptureBitmap,
                                        OriginRect.Right - OriginRect.Left,
                                        OriginRect.Bottom - OriginRect.Top);

                      EdgeRgnBitmap(FBackBuffer, OriginRect.Left, OriginRect.Top, Width, Height, LastRgn);

                      BitBlt(Canvas.Handle, 0, 0, Width, Height,
                      FBackBuffer.Canvas.Handle, OriginRect.Left, OriginRect.Top, SRCCOPY);

                      OriginCoordinateToDesktopCoordinate(LastRgn);

                     end;
            FWindowName := WindowName;
            FCaptureRect := LastRect;
            Free;
            Result := True;
           end;
    mrCancel : begin
                Free;
                Result := False;
               end;
   end;
  end;

 finally
  EndCapture(Result);
 end;
 
end;

function TCaptureEngine.CaptureFixed(FixedWidth, FixedHeight:Integer):Boolean;
begin
 Result := False;

 BeginCapture;

 try

  ScreenCapture;

  with TfrmCapture.Create(Application) do begin
   UserCaptureType := ctFixed;
   FixedW := FixedWidth;
   FixedH := FixedHeight;
   CaptureSetup;
   
   case ShowModal of
    mrOK : begin
            with FCaptureBitmap do begin
              Width := FixedW;
              Height := FixedH;
              BitBlt(Canvas.Handle, 0, 0, EndPoint.X, EndPoint.Y, 
                     FBackBuffer.Canvas.Handle, NewPoint.X, NewPoint.Y, SRCCOPY);
             end;

             FCaptureRect := Rect(NewPoint.X, NewPoint.Y, 
                                NewPoint.X + FixedW, NewPoint.Y + FixedH);
            Free;
            Result := True;
           end;
    mrCancel : begin
                Free;
                Result := False;
               end;
   end;
  end;

 finally
  EndCapture(Result);
 end;

end;

function TCaptureEngine.CaptureIcon:Boolean;

 procedure DrawIcon(IconHandle:HICON);
 begin

  with FCaptureBitmap do begin
   Width := Icon_Size;
   Height := Icon_Size;

   Canvas.Brush.Color := RGB(255, 0, 255);
   Canvas.FillRect(Rect(0, 0, Icon_Size, Icon_Size));

   DrawIconEx(Canvas.Handle, 0, 0, IconHandle, Icon_Size, Icon_Size, 
              0, Canvas.Brush.Handle, DI_IMAGE);
  end;

 end;

var
 FileName:String;
begin
 Result := False;

 BeginCapture;

 try

  ScreenCapture;

  with TfrmCapture.Create(Application) do begin
   SelectHandle := 0;
   UserCaptureType := ctWindow;
   CaptureSetup;
   case ShowModal of
    mrOK : begin
           if SelectHandle = 0 then begin
            InfoMessage(errCaptureWindow);
            Exit;
           end;

           with TfrmIcon.Create(Application) do
            try
             FileName := GetProcessNameFromWindow(SelectHandle);
             LoadIcon(FileName);
             case ShowModal of
              mrOK : DrawIcon(ExtractIcon(hInstance, PChar(FileName), ListView.Selected.Index));
              mrCancel : Exit;
             end;
            finally
             Free;
            end;

            Free;
            Result := True;
           end;
    mrCancel : begin
                Free;
                Result := False;
               end;
   end;
  end;

 finally
  EndCapture(Result);
 end;
end;

function TCaptureEngine.CaptureColor(var AColor:TColor):Boolean;
begin
 Result := False;

 BeginCapture;

 try

  ScreenCapture;

  with TfrmCapture.Create(Application) do begin
   UserCaptureType := ctColor;
   CaptureSetup;
   
   case ShowModal of
    mrOK : begin
            AColor := SelectColor;
            Free;
            Result := True;
           end;
    mrCancel : begin
                Free;
                Result := False;
               end;
   end;
  end;

 finally
  EndCapture(Result);
 end;

end;

function TCaptureEngine.CaptureExtend:Boolean;
var
 lpRect:TRect;
 OriginRect: TRect;

 WindowRgn:HRGN;
begin
 Result := False;

 BeginCapture;

 try

  ScreenCapture;

  with TfrmCapture.Create(Application) do
   try
    SelectHandle := 0;
    UserCaptureType := ctWindow;
    CaptureSetup;
    case ShowModal of
     mrOK : begin
            if (SelectHandle = 0) or (IsWindow(SelectHandle) = False) then begin
             InfoMessage(errExtendWindow);
             Exit;
             end else with TfrmExtend.Create(Application) do
                       try
                        SetExtendHandle(SelectHandle);

                        case ShowModal of
                         mrOK : if IsWindow(SelectHandle) = True then begin
                                 GetWindowRect(SelectHandle, lpRect);

                                 ExtendWindow(SelectHandle);
                                 Sleep(1000);

                                 // ** BackBuffer 에 현재 화면을 담는다 ** //
                                 ScreenCapture;

                                 GetWindowRect(SelectHandle, FCaptureRect);
                                 GetWindowRealRgn(SelectHandle, WindowRgn, True);

                                 OriginRect := DesktopCoordinateToOriginCoordinate(FCaptureRect);
                                 DesktopCoordinateToOriginCoordinate(WindowRgn);
                                 with FCaptureBitmap do begin
                                  SetBigBitmapSize(FCaptureBitmap,
                                                    OriginRect.Right - OriginRect.Left,
                                                    OriginRect.Bottom - OriginRect.Top);

                                  EdgeRgnBitmap(FBackBuffer, OriginRect.Left, OriginRect.Top,
                                                Width, Height, WindowRgn);

                                  BitBlt(Canvas.Handle, 0, 0, Width, Height, 
                                  FBackBuffer.Canvas.Handle, OriginRect.Left, OriginRect.Top, SRCCOPY);
                                 end;

                                 DeleteObject(WindowRgn);
                                 RestoreWindow(SelectHandle, lpRect);

                                 Result := True;
                                end;
                         mrCancel : Exit;
                        end;

                       finally
                        Free;
                       end;
            end;
     mrCancel : Result := False;
    end;
   finally
    Free;
   end;

 finally
  EndCapture(Result);
 end;
end;

function TCaptureEngine.CaptureActiveWindow(NoFrame:Boolean):Boolean;
var
 ActiveHandle: HWND;
 WindowRgn: HRGN;
 WindowRect: TRect;

 OriginRect: TRect;
begin
 Result := False;

 BeginCapture;

 ActiveHandle := GetForegroundWindow;

 try

  if IsIconic(ActiveHandle) = True then begin
   FCaptureRect := Rect(0, 0, 0, 0);
   Exit;
  end;

  GetWindowRealRgn(ActiveHandle, WindowRgn, True);

  ScreenCapture;
  GetRgnBox(WindowRgn, FCaptureRect);

  if NoFrame = True then begin
   GetWorkRect(ActiveHandle, WindowRect);
   SetRectInDesktopRect(WindowRect);

   if EqualRect(FCaptureRect, WindowRect) = False then begin
    DeleteObject(WindowRgn);
    WindowRgn := CreateRectRgnIndirect(WindowRect);

    FCaptureRect := WindowRect;
   end;

  end;

  OriginRect := DesktopCoordinateToOriginCoordinate(FCaptureRect);
  DesktopCoordinateToOriginCoordinate(WindowRgn);
  with OriginRect do begin
   FCaptureBitmap.Width := Right - Left;
   FCaptureBitmap.Height := Bottom - Top;

   EdgeRgnBitmap(FBackBuffer, Left, Top, FBackBuffer.Width, 
                 FBackBuffer.Height, WindowRgn);

   BitBlt(FCaptureBitmap.Canvas.Handle, 0, 0, Right, 
          Bottom, FBackBuffer.Canvas.Handle, 
          Left, Top, SRCCOPY);

  end;

  Result := True;

  DeleteObject(WindowRgn);

 finally
  EndCapture(Result);
 end;

end;

procedure TCaptureEngine.CaptureRect(lpRect: TRect);
var
 OriginRect: TRect;
begin
 BeginCapture;

 try
  ScreenCapture;

  SetRectInDesktopRect(lpRect);

  OriginRect := DesktopCoordinateToOriginCoordinate(lpRect);

  with FCaptureBitmap do begin
   SetBigBitmapSize(FCaptureBitmap,
                    OriginRect.Right - OriginRect.Left,
                    OriginRect.Bottom - OriginRect.Top);
   BitBlt(Canvas.Handle, 0, 0, Width, Height,
          FBackBuffer.Canvas.Handle, OriginRect.Left, OriginRect.Top,
          SRCCOPY);
  end;
  FCaptureRect := lpRect;

 finally
  EndCapture(True);
 end;
 
end;

function EnumMenuProc(AHandle: THandle; var MenuInfo: TMenuInfo): BOOL; stdcall;
Const
 MenuClassName: array[0..11] of String =
 ('BaseBar', '#32768', 'DV2ControlHost', 'TXPStylePopupMenu',
  'TCustomActionPopupMenuEx', 'TTBPopupWindow', 'Afx:400000:800:10011:10:0',
  'TdxBarSubMenuControl', 'MozillaDropShadowWindowClass',
  'Net UI Tool Window', 'Net UI Tool Window Layered', 'MsoCommandBarPopup');
var
 lpClassName: array[0..144] of Char;
 i: Integer;
begin
  Result  :=  True;

  if IsWindowVisible(AHandle) then with MenuInfo do begin
   if IsIconic(AHandle) then
    exit;
   GetClassName(AHandle, lpClassName, SizeOf(lpClassName));

   for i := Low(MenuClassName) to High(MenuClassName) do
    if MenuClassName[i] = lpClassName then begin

     if High(MnuRect) =  - 1 then
      SetLength(MnuRect, 1)
     else SetLength(MnuRect, High(MnuRect) + 2);

     GetWindowRect(AHandle, MnuRect[High(MnuRect)]);
     // 원점좌표로 좌표를 변환합니다.
     MnuRect[High(MnuRect)] := DesktopCoordinateToOriginCoordinate(MnuRect[High(MnuRect)]);

     if High(MnuRect) = 0 then
       MnuMaxRect := MnuRect[0]
     else begin
      if MnuRect[High(MnuRect)].Left < MnuMaxRect.Left then
       MnuMaxRect.Left := MnuRect[High(MnuRect)].Left;
      if MnuRect[High(MnuRect)].Top < MnuMaxRect.Top then
       MnuMaxRect.Top := MnuRect[High(MnuRect)].Top;
      if MnuRect[High(MnuRect)].Right > MnuMaxRect.Right then
       MnuMaxRect.Right := MnuRect[High(MnuRect)].Right;
      if MnuRect[High(MnuRect)].Bottom > MnuMaxRect.Bottom then
       MnuMaxRect.Bottom := MnuRect[High(MnuRect)].Bottom;
     end;

    end;
  end;

end;

function TCaptureEngine.CaptureMenu:Boolean;
var
 i: Integer;
begin
 Result := False;

 BeginCapture;

 try

  EnumWindows(@EnumMenuProc, Integer(@MenuInfo));
  ScreenCapture;

  with MenuInfo do
   if High(MnuRect) >  - 1 then begin

    SetBigBitmapSize(FCaptureBitmap,
                      MnuMaxRect.Right - MnuMaxRect.Left,
                      MnuMaxRect.Bottom - MnuMaxRect.Top);

    for i := Low(MnuRect) to High(MnuRect) do begin
     BitBlt(FCaptureBitmap.Canvas.Handle, MnuRect[i].Left - MnuMaxRect.Left, 
     MnuRect[i].Top - MnuMaxRect.Top, MnuRect[i].Right - MnuRect[i].Left, 
     MnuRect[i].Bottom - MnuRect[i].Top, FBackBuffer.Canvas.Handle,
     MnuRect[i].Left, MnuRect[i].Top, SRCCOPY);
    end;

    FCaptureRect := MnuMaxRect;

    Result := True;

   end;

 finally
  MenuInfo.MnuRect := Nil;
  EndCapture(Result);
 end;

end;

function TCaptureEngine.CaptureObject(var FWindowName:String): Boolean;
var
 OriginRect: TRect;
begin
 Result := False;

 BeginCapture;

 try

  ScreenCapture;

  with TfrmCapture.Create(Application) do begin
   SelectHandle := 0;
   UserCaptureType := ctObject;
   CaptureSetup;
   case ShowModal of
    mrOK : begin
            if SelectHandle = 0 then begin
             InfoMessage(errCaptureWindow);
             Result := False;
             Exit;
            end;

            FCaptureRect := LastRect;
            FWindowName := WindowName;

            OriginRect := DesktopCoordinateToOriginCoordinate(LastRect);
            DesktopCoordinateToOriginCoordinate(LastRgn);

            with FCaptureBitmap do begin
              SetBigBitmapSize(FCaptureBitmap,
                                OriginRect.Right - OriginRect.Left,
                                OriginRect.Bottom - OriginRect.Top);

              EdgeRgnBitmap(FBackBuffer, OriginRect.Left, OriginRect.Top,
              Width, Height, LastRgn);

              BitBlt(Canvas.Handle, 0, 0, Width, Height,
                     FBackBuffer.Canvas.Handle, OriginRect.Left, OriginRect.Top, SRCCOPY);

            end;

            OriginCoordinateToDesktopCoordinate(LastRgn);

            Free;
            Result := True;
           end;
    mrCancel : begin
                Free;
                Result := False;
               end;
   end;
  end;

 finally
  EndCapture(Result);
 end;
end;

procedure TCaptureEngine.CaptureOnlyCursor;
var
 CursorInfo:TCursorInfo;
begin

 BeginCapture;

 try

  CursorInfo := CaptureCursor;
  with FCaptureBitmap do begin
   Width := 32;
   Height := 32;
   Canvas.Brush.Color := clFuchsia;
   DrawIconEx(Canvas.Handle, 0, 0, CursorInfo.hCursor,
              Width, Height, 0, Canvas.Brush.Handle, DI_IMAGE);
  end;

 finally
  EndCapture(True);
 end;

end;

function TCaptureEngine.CaptureWallpaper: Boolean;
var
 WallpaperPath: String;
 ExpandWallpaperPath: Array[0..MAX_PATH] of Char;
begin
 Result := False;

 BeginCapture;
              
 with TRegIniFile.Create('Software\Microsoft\Internet Explorer\Desktop\') do
  try
   WallpaperPath := ReadString('General', 'Wallpaper', '????');

   ExpandEnvironmentStrings(PChar(WallpaperPath), ExpandWallpaperPath, MAX_PATH + 1);
   
   if (WallpaperPath <> '????') and (WallpaperPath <> '') then
    try
     FCaptureBitmap.LoadFromFile(ExpandWallpaperPath);
     Result := True;
    except
    end;

  finally
   Free;
   EndCapture(Result);
  end;

end;

procedure TCaptureEngine.CaptureWebSiteImages;
begin
 with TfrmWebSiteImages.Create(Self) do
  try
   ShowModal;
  finally
   Free;
  end;
end;

function TCaptureEngine.GetCaptureDriverPath: String;
var
 lpSystemDirectory: Array[0..MAX_PATH] of Char;
begin
 GetSystemDirectory(lpSystemDirectory, sizeof(lpSystemDirectory));

 Result := lpSystemDirectory;
 Result := Result + '\drivers\OpenCapture_HookDriver.Sys';
end;

function TCaptureEngine.CaptureDriverLoad;
var
 hDevice: THandle;
 CaptureDriverPath: String;
begin
 CaptureDriverPath := GetCaptureDriverPath;

 // 캡쳐 드라이버를 리소스로부터 추출하여 로드한다.
 Result := ExportResourceFile(CaptureDriverPath, 'CAPTUREDRIVER', 'DRIVERS');
 if Result = False then begin
  InfoMessage(Format(errExportCaptureDriver, [CaptureDriverpath]));

  Exit;
 end;

 Result := (LoadDriver(CaptureDriverPath) = 0);
 //Result := (LoadDriver('D:\CaptureDriver.sys') = 0);
 if Result = True then begin
  hDevice := CreateFile('\\.\Open_CaptureDriver',
                        GENERIC_READ or GENERIC_WRITE,
                        0,
                        Nil,
                        OPEN_EXISTING,
                        FILE_ATTRIBUTE_NORMAL,
                        0);
  if hDevice = INVALID_HANDLE_VALUE then
   Result := False
  else begin
   FCaptureDriver := hDevice;
  end;
 end;

 if Result = False then
  CaptureDriverUnLoad;
end;

function TCaptureEngine.CaptureDriverUnLoad: Boolean;
begin
 if FCaptureDriver <> INVALID_HANDLE_VALUE then begin
  CloseHandle(FCaptureDriver);

  FCaptureDriver := INVALID_HANDLE_VALUE;
 end;
 UnLoadDriver;

 // 드라이버가 언로드 되었다면 드라이버 파일을 삭제한다.
 DeleteFile(GetCaptureDriverPath);

 Result := True;
end;

end.
