﻿unit accessIE;

interface

uses Windows , Messages ,MSHTML , ActiveX , SHDocVw,
     SysUtils , Dialogs;

Const
 DEFAULT_IE_SCROLLRANGE = 100;
 DEFAULT_IE_SCROLLMARGIN = 50;

 HIDDENFRAME_NAME = 'HIDDENFRAME';

type
  TObjectFromLResult = function(LRESULT: lResult; const IID: TIID;
  WPARAM: wParam; out pObject): HRESULT; stdcall;

function GetIEFromHandle(WindowHandle: HWND; var IE: IWebbrowser2): HRESULT;

function GetscrollTopElement(Element2: IHTMLElement2): IHTMLElement2;
function GetIEScrollSize(WindowHandle: HWND;FWebBrowser: IWebBrowser2; var FrameNumber: Integer): Integer;

function GetFrameDocument(Window2: IHTMLWindow2): IHTMLDocument2;

implementation

function GetIEFromHandle(WindowHandle: HWND; var IE: IWebbrowser2): HRESULT;
var
 hInst: HWND;
 lRes: Cardinal;
 MSG: Integer;
 pDoc: IHTMLDocument2;
 ObjectFromLresult: TObjectFromLresult;
begin
 hInst := LoadLibrary('Oleacc.dll');
 @ObjectFromLresult := GetProcAddress(hInst,'ObjectFromLresult');
 if @ObjectFromLresult <> nil then begin
 
  try
   MSG := RegisterWindowMessage('WM_HTML_GETOBJECT');
   SendMessageTimeOut(WindowHandle, MSG, 0, 0, SMTO_ABORTIFHUNG, 1000, lRes);
   Result := ObjectFromLresult(lRes, IHTMLDocument2, 0, pDoc);
   if Result = S_OK then
    (pDoc.parentWindow as IServiceprovider).QueryService(IWebbrowserApp, IWebbrowser2,IE);
  finally
   FreeLibrary(hInst);
  end;

 end;
end;

function GetFrameApp(F: IHTMLWindow2): IWebBrowserApp;
var
 S: IServiceProvider;
 A: IWebBrowserApp;
begin
 Result := nil;
 if F.QueryInterface(IServiceProvider, S) <> S_OK then
  Exit;

 if S.QueryService(IWebBrowserApp, IID_IWebBrowserApp, A) <> S_OK then
  Exit;
  
 Result := A;
end;

function GetFrameDocument(Window2: IHTMLWindow2): IHTMLDocument2;
var
 A: IWebBrowserApp;
 D: IHTMLDocument2;
begin
 Result := nil;
 A := GetFrameApp(Window2);
 if A = nil then
  Exit;

 if A.Document.QueryInterface(IHTMLDocument2, D) <> S_OK then
  Exit;
  
 Result := D;
end;

function GetFrameScrollSize(WindowHandle: HWND;
                            Document2: IHTMLDocument2;
                            iScrollRange: Integer;
                            var FrameNumber: Integer): Integer;
var
 i: Integer;
 OleV: OleVariant;
 Window2: IHTMLWindow2;
 Element2: IHTMLElement2;
 Document3: IHTMLDocument3;
 TextContainer: IHTMLTextContainer;
 bScrollPos, nScrollPos: Integer;
 bElementScrollPos, nElementScrollPos: Integer;
begin
  Result := 0;

  bScrollPos := 0;
  nScrollPos := 0;

  bElementScrollPos := 0;
  nElementScrollPos := 0;

  for i := Document2.frames.length-1 downto 0 do
   try
    OleV := i;

    Window2 := IHTMLWindow2(IDispatch(Document2.frames.item(OleV)));

    //
    // 웹에 환경이 워낙에 독특하다보니 여러가지 경우가 생기는데 그 중에 하나인..
    // 숨겨진 프레임인 경우에 스크롤을 하지 않습니다.
    // 이 때 숨겨진 프레임인지 확인하는 부분은 Id 값이 'HiddenFrame'인지 체크하는 것입니다.
    // 제대로 된 접근을 하려면 IAccessible Interface를 사용하는것이 더 효율적이고 강력합니다.
    //
    if UpperCase(Window2.name) = HIDDENFRAME_NAME then
     continue;

    if GetFrameDocument(Window2) <> nil then begin
     // IHTMLElement2 가 아닌 IHTMLTextContainer 부터 검사하는 이유는
     // IHTMLElement2 인 경우에는 네이버 같은 경우에 동작을 하지 않기 때문이다.
     if GetFrameDocument(Window2).body.QueryInterface(IHTMLTextContainer, TextContainer) = S_OK then begin
      try
       // 네이버 블로그에서 스크롤 캡쳐가 되지 않는 부분을 수정하기 위한 코드이다.
       Document3 := GetFrameDocument(Window2) as IHTMLDocument3;
       Element2 := Document3.documentElement as IHTMLElement2;
      except
       Element2 := nil;
      end;

      // 프레임에 경우에는 전체 IE View 영역에 일부분에 해당하므로
      // 스크롤 사이즈를 반으로 줄입니다.
      // 이렇게 하여도 스크롤하는 속도에는 크게 지장이 없습니다.
      iScrollRange := iScrollRange div 2;

      bScrollPos := TextContainer.scrollTop;
      // 스크롤을 진행합니다.
      TextContainer.scrollTop := TextContainer.scrollTop + iScrollRange;

      if Element2 <> nil then begin
       bElementScrollPos := Element2.scrollTop;
       // 스크롤을 진행합니다.
       Element2.scrollTop := Element2.scrollTop + iScrollRange;
      end;

      nScrollPos := TextContainer.scrollTop;
      if Element2 <> nil then
       nElementScrollPos := Element2.scrollTop;

      if (bElementScrollPos = nElementScrollPos) or (nElementScrollPos = 0) then
       // 이 부분에서 Continue 를 하지 않는다.
       // IHTMLTextContainer 도 검사해야 되기 때문에..
      else begin
              Result := nElementScrollPos - bElementScrollPos;
              FrameNumber := i;
              
              Exit;
             end;

      if (bScrollPos = nScrollPos) or (nScrollPos = 0) then
       Continue
        else begin
              Result := nScrollPos - bScrollPos;
              FrameNumber := i;
              
              Exit;
             end;
    end; // if GetFrameDocument(Window2).body.QueryInterface(IHTMLTextContainer,TextContainer)=S_OK then begin
   end; // if GetFrameDocument(Window2) <> nil then begin
   // ** 재귀 호출 루틴 ** //
   Result := GetFrameScrollSize(WindowHandle, GetFrameDocument(Window2), iScrollRange, FrameNumber);

   // ** Result > 0 일 경우 모든 호출 된 함수들을 빠져나감 ** //
   if Result > 0 then
    Exit;

   except
   end;

end;

function GetscrollTopElement(Element2: IHTMLElement2): IHTMLElement2;
var
 i: Integer;

 children, item: IDispatch;

 Element: IHTMLElement;
 ElementItem: IHTMLElement;
 ElementItem2: IHTMLElement2;
 ElementCollection: IHTMLElementCollection;
begin
 Result := Nil;

 try
  Element := Element2 as IHTMLElement;

  children := Element.children;
  if children = Nil then
   Exit;

  ElementCollection := children as IHTMLElementCollection;
  for i := 0 to ElementCollection.length - 1 do begin
   item := ElementCollection.item(OleVariant(i), OleVariant(i));
   if item = Nil then
    Continue;

   try
    ElementItem := item as IHTMLElement;

    (*
     디씨인 사이드갤러리 스크롤 캡쳐 안되는 부분 수정하였습니다.
     주석도 하나의 엘리먼트로 나옵니다.
     주석일 경우에는 건너띕니다.
    *)
    if ElementItem.tagName = '!' then
     Continue;
   except
    Continue;
   end;

   ElementItem2 := item as IHTMLElement2;
   if ElementItem2.currentStyle.overflow <> 'hidden' then begin
    Result := ElementItem2;

    break;
   end;
   
  end;
 except

 end;
end;

function GetIEScrollSize(WindowHandle: HWND; FWebBrowser: IWebBrowser2; var FrameNumber: Integer): Integer;
var
 iScrollPos1, iScrollPos2 :Integer;
 OldFrameNumber: Integer;

 Document: IDispatch;
 Document2: IHTMLDocument2;
 Document3: IHTMLDocument3;
 Document5: IHTMLDocument5;

 Element2: IHTMLElement2;

 bIsBackCompat: Boolean;

 IEWindowRect: TRect;
 iScrollRange: Integer;
begin
 Result := 0;

 iScrollPos1 := 0;
 iScrollPos2 := 0;

 bIsBackCompat := False;

 Document := FWebBrowser.Document;
 if Document = Nil then
  Exit;

 if Succeeded(Document.QueryInterface(IHTMLDocument2, Document2)) = False then
  Exit;

 if Succeeded(Document.QueryInterface(IHTMLDocument5, Document5)) = True then begin
  // 캡쳐하려는 문서에 DTD가 적용되어 있는지 확인합니다.
  // 선언이 되어 있다면 bIsBackCompat에 값은 False를 가집니다.
  if Document5.compatMode = 'BackCompat' then
   bIsBackCompat := True;
 end;
 
 if bIsBackCompat = True then begin
  // DTD가 선언되어 있지 않습니다.
  Element2 := Document2.body as IHTMLElement2;
 end else begin
  // DTD가 선언되어 있으므로 documentElement.scrollTop으로 얻어와야 합니다.
  if Succeeded(Document.QueryInterface(IHTMLDocument3, Document3)) = False then
   Exit;

  Element2 := Document3.documentElement as IHTMLElement2;
 end;

 if Element2.currentStyle.overflow = 'hidden' then begin
  // body에 overflow:hidden일 경우에는 스크롤바가 없으므로 scrollTop이 먹히지 않습니다.
  // 따라서 차일드 객체 중 overflow:hidden이 없는 객체를 검색합니다.
  Element2 := GetscrollTopElement(Element2);
  if Element2 = Nil then
   Exit;
 end;

 //
 // 기존에 방식은 IE에 PageDown 메세지를 보내서 스크롤하는 방식이었습니다.
 // 그러나 이럴 경우 Element에 우선 포커스를 주어야 하는데
 // IE8에 경우 Element에 포커스를 주게되면 scrollTop값이 초기화되서 0으로 바뀌게 되는
 // 버그가 존재합니다.
 // 따라서 PageDown 메세지를 보내는 방식이 아니라 직접 scrollTop에 값을 쓰는방식으로
 // 변경하였습니다.
 //

 GetWindowRect(WindowHandle, IEWindowRect);
 iScrollRange := IEWindowRect.Bottom - IEWindowRect.Top;

 Dec(iScrollRange, GetSystemMetrics(SM_CYHSCROLL));
 Dec(iScrollRange, DEFAULT_IE_SCROLLMARGIN);

 // 스크롤해야 할 값을 계산하였는데, 해당 값이 0이하라면 기본값을 줍니다.
 if iScrollRange <= 0 then
  iScrollRange := DEFAULT_IE_SCROLLRANGE;

 // 스크롤 하기전 값을 저장합니다.
 iScrollPos1 := Element2.scrollTop;

 // 스크롤합니다.
 Element2.scrollTop := Element2.scrollTop + iScrollRange;

 // 스크롤을 한 후에 값을 저장합니다.
 iScrollPos2 := Element2.scrollTop;

 // 서로 비교합니다.
 if iScrollPos1 <> iScrollPos2 then begin
  Result := iScrollPos2 - iScrollPos1;

  Exit;
 end;

 // 스크롤 하기 전과 스크롤 후에 값이 갖지만 이전에 스크롤 한적이 있다면 더 이상 스크롤할 수 없는 경우입니다.
 if ((iScrollPos1 = iScrollPos2) and (iScrollPos1 > 0)) then
  Exit;

 OldFrameNumber := FrameNumber;

 Result := GetFrameScrollSize(WindowHandle, Document2, iScrollRange, FrameNumber);

 if OldFrameNumber <> -1 then
  if OldFrameNumber <> FrameNumber then
   Result := 0;

end;

end.
