﻿unit uExtendWindow;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ufrmInherited;

type
  TfrmExtend = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    lblHandle: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    udWidth: TUpDown;
    edtWidth: TEdit;
    edtHeight: TEdit;
    udHeight: TUpDown;
    btnPreview: TButton;
    btnCapture: TButton;
    procedure btnPreviewClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function PreviewWindow(WindowHandle:HWND):Boolean;
  public
    { Public declarations }
    procedure SetExtendHandle(WindowHandle:HWND);
    procedure ExtendWindow(WindowHandle:HWND);
    procedure RestoreWindow(WindowHandle:HWND;lpRect:TRect);
  end;

var
  frmExtend: TfrmExtend;

implementation

 uses OpenInterface;

{$R *.dfm}

function TfrmExtend.PreviewWindow(WindowHandle:HWND):Boolean;
var
 lpRect:TRect;
begin
 if IsWindow(WindowHandle) = False then begin
  InfoMessage('윈도우가 존재하지 않습니다');
  Result:=False;
  end else begin
            GetWindowRect(WindowHandle,lpRect);
            ExtendWindow(WindowHandle);
            Sleep(1000);
            RestoreWindow(WindowHandle,lpRect);
            Result:=True;
           end;
end;

procedure TfrmExtend.SetExtendHandle(WindowHandle:HWND);
var
 WindowRect:TRect;
begin
 lblHandle.Caption:=IntToStr(WindowHandle);

 GetWindowRect(WindowHandle,WindowRect);

 udWidth.Position:=WindowRect.Right-WindowRect.Left;
 udHeight.Position:=WindowRect.Bottom-WindowRect.Top;
end;

procedure TfrmExtend.ExtendWindow(WindowHandle:HWND);
var
 lpRect:TRect;
begin
 Hide;
 GetWindowRect(WindowHandle,lpRect);
 MoveWindow(WindowHandle,lpRect.Left,lpRect.Top,
            udWidth.Position,udHeight.Position,True);
 SetForegroundWindow(WindowHandle);
end;

procedure TfrmExtend.RestoreWindow(WindowHandle:HWND;lpRect:TRect);
begin
 with lpRect do
  MoveWindow(WindowHandle,Left,Top,Right-Left,Bottom-Top,True);

 SetForegroundWindow(Handle);
 Show;
end;

procedure TfrmExtend.btnPreviewClick(Sender: TObject);
begin
 PreviewWindow(StrToInt(lblHandle.Caption));
end;

procedure TfrmExtend.FormCreate(Sender: TObject);
begin
 Font.Assign(Screen.MenuFont);
end;

end.
