﻿unit uIcon;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ImgList, ufrmInherited;

Const
 Icon_Size = 32;

type
  TfrmIcon = class(TfrmNormal)
    IconList: TImageList;
    ListView: TListView;
    btnOk: TButton;
    btnCancel: TButton;
    procedure btnOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListViewDblClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    function LoadIcon(FileName:String):Boolean;
  end;

var
  frmIcon: TfrmIcon;

implementation

 uses OpenInterface , ShellAPI;

{$R *.dfm}

function TfrmIcon.LoadIcon(FileName:String):Boolean;
var
 IconBitmap:TBitmap;
 IconHandle:HICON;
 nIcon:Integer;
 i:Integer;
begin
  Result:=True;
  // ** 실행파일의 있는 아이콘의 갯수를 구한다 ** //
  nIcon := ExtractIcon(hInstance, PChar(FileName), Cardinal(-1));

  if nIcon < 1 then begin
   Result:=False;
   Exit;
  end;

  ListView.Clear;
  IconList.Clear;

  IconBitmap:=TBitmap.Create;
   try
    IconBitmap.Width:=Icon_Size;
    IconBitmap.Height:=Icon_Size;
    for i:=0 to nIcon-1 do begin
     IconHandle:=ExtractIcon(hInstance, PChar(FileName),i);

     DrawIcon(IconBitmap.Canvas.Handle,0,0,IconHandle);

     ListView.AddItem(IntToStr(i+1)+' 번째 아이콘',TObject(vsIcon));
     ListView.Items[ListView.Items.Count-1].ImageIndex:=i;
     IconList.Add(IconBitmap,nil);

     IconBitmap.Canvas.FillRect(Rect(0,0,Icon_Size,Icon_Size));
    end;

     ListView.Items[0].Selected:=True;
   finally
    IconBitmap.Free;
   end;

end;

procedure TfrmIcon.btnOkClick(Sender: TObject);
begin
 if ListView.Selected = nil then
  InfoMessage('아이콘을 선택해주세요.')
   else ModalResult:=mrOk;

end;

procedure TfrmIcon.FormCreate(Sender: TObject);
begin
 ListView.DoubleBuffered:=True;
end;

procedure TfrmIcon.ListViewDblClick(Sender: TObject);
begin
 if ListView.Selected <> nil then
  btnOk.OnClick(Sender);
end;

procedure TfrmIcon.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if ListView.Selected <> nil then
  if Key = VK_RETURN then
   btnOK.OnClick(Sender);
end;

end.
