﻿unit uWebSiteImages;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, OleCtrls, SHDocVw, CheckLst, ExtCtrls, MSHTML,
  Buttons, ufrmInherited;

resourcestring
 strGetWebSite = '웹 사이트를 다운로드 중 입니다.';
 strGetImageList = '웹 사이트의 이미지 목록을 가져오는 중 입니다.';
 strGetImageListComplete = '완료';
 strDownloadingImages = '이미지를 다운로드 중 입니다.';
 errGetImageListFaild = '이미지 목록 가져오기 버튼을 눌러서 이미지 목록을 가져오세요.';
 errCreateDirFaild = '디렉토리를 생성하는데 실패하였습니다.';
 infoPath = '다음 경로로 이미지들이 저장되었습니다.';

type
  TfrmWebSiteImages = class(TfrmNormal)
    Label1: TLabel;
    edtAddress: TEdit;
    btnReadImages: TButton;
    chklstbxImages: TCheckListBox;
    WebBrowser: TWebBrowser;
    StatusBar: TStatusBar;
    tmrCheckComplete: TTimer;
    Label2: TLabel;
    Label3: TLabel;
    edtPath: TEdit;
    btnSelectFolder: TBitBtn;
    btnSaveImages: TButton;
    chkShowFolder: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure btnReadImagesClick(Sender: TObject);
    procedure tmrCheckCompleteTimer(Sender: TObject);
    procedure btnSaveImagesClick(Sender: TObject);
    procedure WebBrowserNewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure btnSelectFolderClick(Sender: TObject);
  private
    { Private declarations }
    ErrorCount: Byte;
  public
    { Public declarations }
  end;

var
  frmWebSiteImages: TfrmWebSiteImages;

implementation

 uses OpenInterface, accessIE, URLMon, filectrl, ShellAPI;

{$R *.dfm}

procedure TfrmWebSiteImages.FormCreate(Sender: TObject);
begin
 Self.Font.Assign(Screen.MenuFont);
end;

procedure TfrmWebSiteImages.btnReadImagesClick(Sender: TObject);
begin
 StatusBar.SimpleText := strGetWebSite;
 WebBrowser.Navigate(edtAddress.Text);
 tmrCheckComplete.Enabled := True;

 ErrorCount := 0;
end;

procedure TfrmWebSiteImages.tmrCheckCompleteTimer(Sender: TObject);

 procedure GetImagesList(Document2: IHTMLDocument2);
 var
  i: Integer;
  AllImages: IHTMLElementCollection;
 begin
  AllImages := Document2.images;

  // ** 웹 사이트 이미지 목록을 읽어온다 ** //
  for i := 0 to AllImages.length - 1 do
   if (Document2.images.item(i, 0) as IHTMLImgElement).href <> '' then begin
    chklstbxImages.Items.Add((Document2.images.item(i, 0) as IHTMLImgElement).href);
    chklstbxImages.Checked[chklstbxImages.Items.Count - 1] := True;
   end;

 end;

var
 i, j: Integer;
 Document2: IHTMLDocument2;
 Element2: IHTMLElement2;
 Window2: IHTMLWindow2;

 OleV: OleVariant;
begin
 Inc(ErrorCount);
 if (WebBrowser.ReadyState = READYSTATE_COMPLETE)
    or (ErrorCount = 10) then begin
  tmrCheckComplete.Enabled := False;

  chklstbxImages.Clear;

  StatusBar.SimpleText := strGetImageList;

  Document2 := WebBrowser.Document as IHTMLDocument2;
  GetImagesList(Document2);

  for i := 0 to Document2.frames.length - 1 do begin
   try
    OleV := i;
    Window2 := IHTMLWindow2(IDispatch(Document2.frames.item(OleV)));

    Document2 := GetFrameDocument(Window2);
    if Document2 <> nil then
     GetImagesList(Document2);
   except
   end;

  end;

  StatusBar.SimpleText := strGetImageListComplete;
 end;

end;

procedure TfrmWebSiteImages.btnSaveImagesClick(Sender: TObject);

 function GetFileName(Url: String): String;
 var
  i, UrlLength: Integer;
 begin
  Result := Url;

  UrlLength := Length(Url);
  for i := UrlLength downto 1 do
   if Url[i] = '/' then begin
    Result := Copy(Url, i + 1, UrlLength - i);
    Break;
   end;
 end;

var
 i: Integer;
 Path: String;
begin
 if chklstbxImages.Count = 0 then
  InfoMessage(errGetImageListFaild)
   else begin
         try
          btnReadImages.Enabled := False;
          chklstbxImages.Enabled := False;

          Path := SetFileName(edtAddress.Text);
          Path := edtPath.Text + Path;

          if DirectoryExists(Path) = False then
           if CreateDir(Path) = False then begin
            InfoMessage(errCreateDirFaild);
            Exit;
           end;

          Path := Path + '\';

          for i := 0 to chklstbxImages.Count -1 do
           UrlDownloadToFile(nil, PChar(chklstbxImages.Items[i]), PChar(Path + GetFileName(chklstbxImages.Items[i])), 0, nil);

          InfoMessage(infoPath + #13 + #10 + #13 + #10 + Path);

         finally
          btnReadImages.Enabled := True;
          chklstbxImages.Enabled := True;
         end;

         if chkShowFolder.Checked = True then
          ShellExecute(Self.Handle, nil, PChar(Path),
                       nil, nil, SW_SHOW);
        end;
end;

procedure TfrmWebSiteImages.WebBrowserNewWindow2(Sender: TObject;
  var ppDisp: IDispatch; var Cancel: WordBool);
begin
 Cancel := True;
end;

procedure TfrmWebSiteImages.btnSelectFolderClick(Sender: TObject);
var
 DirPath, AToken:String;
begin
 if SelectDirectory('디렉토리를 선택하세요. : ', '', DirPath) = True then begin

  AToken := Copy(Dirpath, Length(Dirpath), 1);

  if AToken <> '\' then
   edtPath.Text := DirPath + '\'
    else edtPath.Text := DirPath;
    
 end;

end;

end.
