﻿unit OpenDrawFrame;

interface
  uses Windows, Types, Graphics;

procedure DrawClientFrame(Canvas: TCanvas;
                          ClientRect: TRect;
                          PenColor: TColor);
procedure DrawFrame(Canvas: TCanvas;
                          SelectRect :TRect;
                          PenColor, BrushColor: TColor;
                          bkColor :Boolean = False);

implementation

procedure DrawClientFrame(Canvas: TCanvas;
                          ClientRect: TRect;
                          PenColor: TColor);
begin

 with Canvas do begin
  Pen.Style := psDot;
  Pen.Color := PenColor;
  Brush.Style := bsClear;

  Rectangle(0,  0,  ClientRect.Right,  ClientRect.Bottom);

  Pen.Style := psSolid;
 end;

end;

procedure DrawFrame(Canvas: TCanvas;
                          SelectRect :TRect;
                          PenColor, BrushColor: TColor;
                          bkColor :Boolean = False);
begin
  with SelectRect do
   with Canvas do begin

    if bkColor = False then
     Brush.Style := bsClear
      else begin
            Pen.Style := psDot;
            Brush.Style := bsSolid;
            Brush.Color := BrushColor;
           end;

    Pen.Color := PenColor;

    Rectangle(Rect(Left - 3, Top - 3, Right + 3, Bottom + 3));

    Pen.Style := psSolid;
   end;

end;

end.
