﻿unit OpenToolCbx;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GR32, OpenDrawShape;

Const
 Type_Line = 1;
 Type_Shape = 2;
 Type_Arrow = 3;

 Line_Length = 70;
 Line_Margin = 10;

 Select_Height = 30;

 COLOR_Frame = $007A8689;
 COLOR_Border = $007A8689;
 COLOR_Bk = $00EEF4F3;

type
  TfrmToolPicker = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
    ToolType: Byte;
    BackBuffer: TBitmap32;
    procedure DrawLines;
  public
    { Public declarations }
    procedure ChangeToolType(ToolType: Integer);
  end;

var
  frmToolPicker: TfrmToolPicker = nil;

implementation

 uses OpenDrawFrame;

{$R *.dfm}

procedure TfrmToolPicker.ChangeToolType(ToolType: Integer);
begin
 Self.ToolType := ToolType;
end;

procedure TfrmToolPicker.DrawLines;
var
 LinePt, LineEndPt: TPoint;
 X, Y: Integer;
begin
 with BackBuffer do begin
  Clear(clWhite32);

  Canvas.Pen.Color := clBlack;
  Canvas.Brush.Style := bsClear;

 end;

 for 

 {X := ((Width div 2) - (Line_Length div 2)) + Line_Margin;
 Y := 10;

 BackBuffer.Canvas.TextOut(10, Y, '1pt');

 LinePt := Point(X, Y);
 LineEndPt := Point(X + Line_Length, Y);



 open_Line(BackBuffer, LinePt, LineEndPt, 255, True);  }

end;

procedure TfrmToolPicker.FormCreate(Sender: TObject);
begin
 ToolType := Type_Line;

 BackBuffer := TBitmap32.Create;
 BackBuffer.SetSize(Width, Height);

 DoubleBuffered := True;
end;

procedure TfrmToolPicker.FormDeactivate(Sender: TObject);
begin
 frmToolPicker.Free;
end;

procedure TfrmToolPicker.FormDestroy(Sender: TObject);
begin
 frmToolPicker := nil;
end;

procedure TfrmToolPicker.FormPaint(Sender: TObject);
begin
 case ToolType of
  Type_Line : DrawLines;
 end;

 BackBuffer.DrawTo(Canvas.Handle, ClientRect, ClientRect);

 DrawClientFrame(Canvas, ClientRect, COLOR_Frame);
end;

end.
