﻿unit uBitmapList;

interface

 uses Windows, Classes, Graphics, Dialogs, SysUtils, GR32;

 type
  TBitmapList = class(TComponent)
   public
    Bitmaps:Array of TBitmap32;
    Tag:Integer;
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
    function GetCount:Integer;
    procedure AddBitmap(Bitmap:TBitmap32);
    procedure DeleteBitmap(Index:Integer);
    procedure ClearBitmaps;
   end;

implementation

Constructor TBitmapList.Create;
begin
 Bitmaps:=nil;
end;

Destructor TBitmapList.Destroy;
var
 i:Integer;
begin
 for i:=High(Bitmaps) downto Low(Bitmaps) do
  Bitmaps[i].Free;
 Bitmaps:=nil;
end;

function TBitmapList.GetCount:Integer;
begin
 Result:=High(Bitmaps)+1;
end;

procedure TBitmapList.AddBitmap(Bitmap:TBitmap32);
Const
 MaxCount = 11;
var
i:Integer;
begin

 if GetCount = MaxCount then begin
  Bitmaps[0].Free;
  Bitmaps[0]:=nil;
  for i:=1 to MaxCount-1 do
   Bitmaps[i-1]:=Bitmaps[i];
  Bitmaps[MaxCount-1]:=TBitmap32.Create;
  Bitmaps[MaxCount-1].Assign(Bitmap);
  Exit;
 end;

 // ** -1 이라면 변수가 nil 인 것이다. ** //
 if High(Bitmaps) = -1 then
  SetLength(Bitmaps,1)
   else SetLength(Bitmaps,High(Bitmaps)+2);

  Bitmaps[High(Bitmaps)]:=TBitmap32.Create;
  Bitmaps[High(Bitmaps)].Assign(Bitmap);

end;

procedure TBitmapList.DeleteBitmap(Index:Integer);
begin
  Bitmaps[Index].Free;
  Bitmaps[Index]:=nil;

 SetLength(Bitmaps,High(Bitmaps));

end;

procedure TBitmapList.ClearBitmaps;
var
 i:Integer;
begin
 for i:=High(Bitmaps) downto Low(Bitmaps) do
  Bitmaps[i].Free;
 Bitmaps:=nil;
end;

end.
