﻿unit uHotKey;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus, XPMenu, iniFiles;

type
  TfrmHotKey = class(TForm)
    btnCancel: TButton;
    btnOK: TButton;
    GroupBox1: TGroupBox;
    Label0: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    HotKey_0: THotKey;
    HotKey_1: THotKey;
    HotKey_2: THotKey;
    HotKey_3: THotKey;
    HotKey_4: THotKey;
    HotKey_5: THotKey;
    HotKey_6: THotKey;
    HotKey_7: THotKey;
    HotKey_8: THotKey;
    HotKey_9: THotKey;
    HotKey_10: THotKey;
    HotKey_11: THotKey;
    Label12: TLabel;
    HotKey_12: THotKey;
    Label13: TLabel;
    Label14: TLabel;
    HotKey_13: THotKey;
    Label15: TLabel;
    HotKey_14: THotKey;
    btnRestoreHotKey: TButton;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnRestoreHotKeyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmHotKey: TfrmHotKey;

implementation

uses uMain;
{$R *.dfm}

procedure TfrmHotKey.btnRestoreHotKeyClick(Sender: TObject);
Const
  HotKeyList: Array [0 .. 14] of String = ('Shift+Ctrl+R', 'Shift+Ctrl+W',
    'Shift+Ctrl+C', 'Shift+Ctrl+A', 'Shift+Ctrl+T', 'Shift+Ctrl+S',
    'Shift+Ctrl+F', 'Shift+Ctrl+I', 'Shift+Ctrl+O', 'Shift+Ctrl+E',
    'Shift+Ctrl+L', 'Shift+Ctrl+M', 'Shift+Ctrl+Z', '', '');
var
  i: Integer;
begin
  for i := 0 to 14 do
  begin
    THotKey(FindComponent('HotKey_' + IntToStr(i))).HotKey := TextToShortCut
      (HotKeyList[i]);
  end;
end;

procedure TfrmHotKey.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  frmMain.FCapture := false;
end;

procedure TfrmHotKey.FormCreate(Sender: TObject);
var
  MenuShortCut: TShortCut;
  MenuKey: Word;
  MenuShift: TShiftState;
  i: Integer;
begin
  for i := 0 to 14 do
  begin
    // 등록 된 핫키를 모두 해제합니다.
    UnRegisterHotkey(frmMain.Handle, i);

    MenuShortCut := frmMain.MainMenu.Items[2].Items[i].ShortCut;
    THotKey(FindComponent('HotKey_' + IntToStr(i))).HotKey := MenuShortCut;
  end;
end;

procedure TfrmHotKey.btnOKClick(Sender: TObject);
var
  OpenSetup: TiniFile;
  ShortCut: TShortCut;
  MenuShift: TShiftState;
  MenuKey: Word;
  i: Integer;
begin
  OpenSetup := TiniFile.Create(ExtractFilePath(Application.ExeName) + INIPath);
  try
    for i := 0 to 14 do
    begin
      OpenSetup.WriteString('단축키 설정', frmMain.MainMenu.Items[2].Items[i]
          .Caption, ShortCutToText
          (THotKey(FindComponent('HotKey_' + IntToStr(i))).HotKey));
    end;
  finally
    OpenSetup.Free;
  end;

end;

end.
