﻿{ **** 프로그램명 : 오픈 캡쳐 ****
  **** 제작자 : 정룡옥 ****
  **** 프로그램 만들날 : 2003 년 17 살때 만듦 ****
  **** e-Mail : hackingfanatic@hotmail.com ****
  ***********************************************
  **** 제작자 : 박병익 ****
  **** 심플스(Simples.Kr) : 2009 년 05월 14일 ****
  **** e-Mail : pbi12@nate.com ****
  ***********************************************
}

unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Forms,
  Dialogs, ComCtrls, Menus, ExtCtrls, ToolWin,
  ImgList, StdCtrls, ExtDlgs, Controls, Buttons, FileUtils,
  // ****** 이미지와 관련 된 추가적인 유닛 ****** //
  JPEG, LinarBitmap, userICOLoader, pngimage,
{$IFDEF UNICODE}
  // Delphi 2009 이상에서는 기본 유닛인 gifimg를 사용합니다.
  GifImg,
{$ELSE}
  // 그 이하 버전에서는 cGifImage 디렉토리안에 있는 GifImage를 사용합니다.
  GifImage,
{$ENDIF}
  // ******************************************** //
  XPMenu, Clipbrd, iniFiles, Registry, MSHTML, ActiveX, SHDocVw, ShellAPI,
  GR32, GR32_Transforms, GR32_Layers, GR32_RangeBars, OpenPalette,
  ufrmInherited, XPMan, httpget;

const
  INIPath = 'OpenSetup.INI';
  // 날짜패치 + 그날 업데이트 횟수
  UpdateDate: Integer = 2009121301;
  // 게시물 상단의 Ver.는 더 이상사용하지 않음 - 과거버전
  // 게시물 상단에 Ver2. 라는 구문이 있으면 그걸로 비교한다.
  UpdateURL: String = 'http://simples.kr/bbs/board.php?bo_table=11_1&wr_id=13';

  CM_MDICursor = WM_USER + $1003;

  tsDrag = 0;
  tsPen = 1;
  tsAirBrush = 2;
  tsEraser = 3;
  tsLine = 4;
  tsEllipse = 5;
  tsRect = 6;
  tsRoundRect = 7;
  tsText = 8;
  tsSelColor = 9;
  tsFloodFill = 10;
  tsArrow = 11;
  tsSelect = 12;
  tsZoom = 13;

  itJPEG = 1;
  itGIF = 2;
  itPNG = 3;
  it24bitBitmap = 4;
  it24bitIco = 5;
  it24bitCursor = 6;

  extGIF = 0;
  extJPG = 1;
  extIco = 2;
  extPcx = 3;
  extBmp = 4;
  extCur = 5;
  extGeneral = 6;
  extSpecial = 7;

  ctNull = 0;
  ctUserCapture = 1;
  ctWindow = 2;
  ctObject = 3;
  ctIcon = 4;
  ctFixed = 5;
  ctColor = 6;
  ctPolygon = 7;

  //Eraser Size
  esSmall = 8;
  esNormal = 16;
  esBig = 24;

  ModeInvert = 0;
  ModeGrayScale = 1;

resourcestring
  errAutoSave = '자동 저장 기능이 다음과 같은 이유로 실패했습니다.';
  errINIFileSave = '프로그램에 설정을 INI File로 저장 할 수 없습니다.' + #13 + #10 + #13 + #10 +
    '오픈 캡쳐가 실행중인 경로에 파일 쓰기 권한이 없습니다.' + #13 + #10 +
    '네트워크로 공유 된 폴더이거나 비스타이상에 운영체제에서 관리자 권한이 요구되는 폴더에 경우 ' +
    '파일을 쓸 수 없는 경우가 있을 수 있을 수 있습니다.';

type
  TCaptureCount = record
    NewImage, CaptureSel, CaptureWnd, CaptureCtrl, CaptureActiveWnd,
      CaptureFull, CaptureLast, CaptureIcon, CaptureFixed, CaptureMenu,
      CaptureCursor, CaptureNewImage, CaptureWallpaper, CaptureObject: Integer;
  end;

type
  TXXCoolBar = class(TCoolBar);

  type
    TfrmMain = class(TfrmNormal)
      StatusBar: TStatusBar;
      imglstFile: TImageList;
      MainCoolBar: TCoolBar;
      tbCapture: TToolBar;
      btnOpenFile: TToolButton;
      btnSaveFile: TToolButton;
      OpenDialog: TOpenDialog;
      SaveDialog: TSaveDialog;
      tbCaptureControl: TToolButton;
      tbCaptureFullScreen: TToolButton;
      tbCaptureLastRect: TToolButton;
      tbUserCapture: TToolButton;
      newimageBtn: TToolButton;
      MainMenu: TMainMenu;
      MenuItem1: TMenuItem;
      mnuOpenFile: TMenuItem;
      mnuSaveFile: TMenuItem;
      MenuItem7: TMenuItem;
      mnuExit: TMenuItem;
      MenuItem9: TMenuItem;
      mnuToolBar: TMenuItem;
      mnuStatusBar: TMenuItem;
      mnuCapture: TMenuItem;
      mnuUserCapture: TMenuItem;
      mnuCaptureControl: TMenuItem;
      mnuCaptureActiveWindow: TMenuItem;
      mnuCaptureFullScreen: TMenuItem;
      mnuCaptureLastRect: TMenuItem;
      N19: TMenuItem;
      MenuItem14: TMenuItem;
      menuAbout: TMenuItem;
      popupMnu: TPopupMenu;
      popClose: TMenuItem;
      mnuWindow: TMenuItem;
      TileMenu: TMenuItem;
      CascadeMenu: TMenuItem;
      MinMenu: TMenuItem;
      NormalMenu: TMenuItem;
      MaxMenu: TMenuItem;
      mnuNewImage: TMenuItem;
      ToolButton11: TToolButton;
      ToolButton19: TToolButton;
      tbTab: TToolBar;
      MDITab: TTabControl;
      mnuCaptureWindow: TMenuItem;
      mnuCaptureActiveWindowEx: TMenuItem;
      mnuCaptureIcon: TMenuItem;
      btnCopy: TToolButton;
      btnPaste: TToolButton;
      tbCaptureFixedRect: TToolButton;
      mnuCaptureFixedRect: TMenuItem;
      tbCaptureColor: TToolButton;
      mnuCaptureColor: TMenuItem;
      N1: TMenuItem;
      UseRect: TMenuItem;
      UseEllipse: TMenuItem;
      UseTriangle: TMenuItem;
      UsePolygon: TMenuItem;
      UseRoundRect: TMenuItem;
      UsePolygonLine: TMenuItem;
      mnuHotKey: TMenuItem;
      mnuCaptureMenu: TMenuItem;
      mnuCaptureWindowResize: TMenuItem;
      tbCaptureWindowResize: TToolButton;
      N3: TMenuItem;
      popCopy: TMenuItem;
      popPaste: TMenuItem;
      btnCut: TToolButton;
      mnuCopy: TMenuItem;
      mnuPaste: TMenuItem;
      mnuClose: TMenuItem;
      N17: TMenuItem;
      mnuCaptureCursor: TMenuItem;
      N5: TMenuItem;
      mnuCut: TMenuItem;
      mnuShow: TMenuItem;
      mnuUndo: TMenuItem;
      N18: TMenuItem;
      mnuRedo: TMenuItem;
      N20: TMenuItem;
      popUndo: TMenuItem;
      popRedo: TMenuItem;
      mnuUserOption: TMenuItem;
      mnuScale: TMenuItem;
      mnuGrayScale: TMenuItem;
      mnuInvert: TMenuItem;
      mnuColorNoise: TMenuItem;
      mnuMonoNoise: TMenuItem;
      mnuBrightness: TMenuItem;
      N28: TMenuItem;
      N32: TMenuItem;
      btnUndo: TToolButton;
      btnRedo: TToolButton;
      ToolButton8: TToolButton;
      XPManifest: TXPManifest;
      mnuMosaic: TMenuItem;
      mnuSetup: TMenuItem;
      mnuCaptureWallpaper: TMenuItem;
      ToolButton1: TToolButton;
      coolbrPaintBox: TCoolBar;
      pnlPaintBox: TPanel;
      tbInvert: TToolButton;
      tbGrayScale: TToolButton;
      tbBrightness: TToolButton;
      ToolButton12: TToolButton;
      mnuAutoScroll: TMenuItem;
      N2: TMenuItem;
      mnuRotate90: TMenuItem;
      mnuRotate180: TMenuItem;
      mnuRotate270: TMenuItem;
      mnuRotate: TMenuItem;
      mnuCanvasResize: TMenuItem;
      N4: TMenuItem;
      mnuCrop: TMenuItem;
      N6: TMenuItem;
      mnuSaturation: TMenuItem;
      N8: TMenuItem;
      lblColor: TLabel;
      lblPaintTool: TLabel;
      Bevel1: TBevel;
      Bevel6: TBevel;
      N7: TMenuItem;
      mnuHorzFlip: TMenuItem;
      mnuVertFlip: TMenuItem;
      mnuDelete: TMenuItem;
      mnuSelectAll: TMenuItem;
      N9: TMenuItem;
      mnuAnyAngle: TMenuItem;
      pnlPaintTool: TPanel;
      btnDrag: TSpeedButton;
      btnZoom: TSpeedButton;
      btnSelect: TSpeedButton;
      btnPen: TSpeedButton;
      btnAirBrush: TSpeedButton;
      btnSelColor: TSpeedButton;
      btnFloodFill: TSpeedButton;
      btnEraser: TSpeedButton;
      btnText: TSpeedButton;
      btnLine: TSpeedButton;
      btnRectangle: TSpeedButton;
      btnCircle: TSpeedButton;
      btnRoundRect: TSpeedButton;
      btnArrow: TSpeedButton;
      mnuCaptureWebImages: TMenuItem;
      mnuAllClose: TMenuItem;
      mnuCaptureObject: TMenuItem;
      pnlPaintToolOption: TPanel;
      pnlBitmapLayer: TPanel;
      Bevel7: TBevel;
      lblLayer: TLabel;
      lblLayerAlpha: TLabel;
      pnlEraser: TPanel;
      btnSmall: TSpeedButton;
      btnNormal: TSpeedButton;
      btnBig: TSpeedButton;
      Bevel2: TBevel;
      gbLayerAlpha: TScrollBar;
      pnlShape: TPanel;
      btnRect: TSpeedButton;
      btnSolid: TSpeedButton;
      btnClear: TSpeedButton;
      Bevel3: TBevel;
      pnlPenWidth: TPanel;
      Bevel5: TBevel;
      lblPenSize: TLabel;
      lblShapeAlpha: TLabel;
      Bevel8: TBevel;
      edtPenSize: TEdit;
      udPenSize: TUpDown;
      gbShapeAlpha: TScrollBar;
      pnlPenSize: TPanel;
      btnPenSize1: TSpeedButton;
      btnPenSize2: TSpeedButton;
      btnPenSize3: TSpeedButton;
      Bevel4: TBevel;
      btnColorExchange: TSpeedButton;
      popSave: TMenuItem;
      menuHelp: TMenuItem;
      TrayIcon: TTrayIcon;
      popupTray: TPopupMenu;
      popTraySetup: TMenuItem;
      N11: TMenuItem;
      popTrayExit: TMenuItem;
      pmnuCapture: TMenuItem;
      N12: TMenuItem;
      N13: TMenuItem;
      mnuPaintBox: TMenuItem;
      cboZoom: TComboBox;
      procedure FormCreate(Sender: TObject);
      procedure mnuOpenFileClick(Sender: TObject);
      procedure mnuSaveFileClick(Sender: TObject);
      procedure btnOpenFileClick(Sender: TObject);
      procedure btnSaveFileClick(Sender: TObject);
      procedure tbCaptureControlClick(Sender: TObject);
      procedure mnuCaptureFullScreenClick(Sender: TObject);
      procedure mnuStatusBarClick(Sender: TObject);
      procedure mnuExitClick(Sender: TObject);
      procedure mnuCaptureLastRectClick(Sender: TObject);
      procedure mnuUserCaptureClick(Sender: TObject);
      procedure FormActivate(Sender: TObject);
      procedure mnuCaptureActiveWindowClick(Sender: TObject);
      procedure tbCaptureFullScreenClick(Sender: TObject);
      procedure ActiveCaptureBtnClick(Sender: TObject);
      procedure tbCaptureLastRectClick(Sender: TObject);
      procedure MDITabMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
      procedure TileMenuClick(Sender: TObject);
      procedure CascadeMenuClick(Sender: TObject);
      procedure MinMenuClick(Sender: TObject);
      procedure MaxMenuClick(Sender: TObject);
      procedure NormalMenuClick(Sender: TObject);
      procedure mnuNewImageClick(Sender: TObject);
      procedure newimageBtnClick(Sender: TObject);
      procedure mnuCaptureWindowClick(Sender: TObject);
      procedure mnuCaptureControlClick(Sender: TObject);
      procedure mnuCaptureActiveWindowExClick(Sender: TObject);
      procedure mnuPasteClick(Sender: TObject);
      procedure mnuCopyClick(Sender: TObject);
      procedure btnPasteClick(Sender: TObject);
      procedure btnCopyClick(Sender: TObject);
      procedure mnuToolBarClick(Sender: TObject);
      procedure mnuCaptureMenuClick(Sender: TObject);
      procedure tbCaptureFixedRectClick(Sender: TObject);
      procedure mnuCaptureFixedRectClick(Sender: TObject);
      procedure tbCaptureColorClick(Sender: TObject);
      procedure mnuHotKeyClick(Sender: TObject);
      procedure mnuCutClick(Sender: TObject);
      procedure popCopyClick(Sender: TObject);
      procedure popPasteClick(Sender: TObject);
      procedure mnuCloseClick(Sender: TObject);
      procedure mnuUndoClick(Sender: TObject);
      procedure mnuRedoClick(Sender: TObject);
      procedure popUndoClick(Sender: TObject);
      procedure popRedoClick(Sender: TObject);
      procedure popupMnuPopup(Sender: TObject);
      procedure mnuCaptureCursorClick(Sender: TObject);
      procedure mnuScaleClick(Sender: TObject);
      procedure tbCaptureWindowResizeClick(Sender: TObject);
      procedure btnCutClick(Sender: TObject);
      procedure mnuGrayScaleClick(Sender: TObject);
      procedure mnuInvertClick(Sender: TObject);
      procedure btnUndoClick(Sender: TObject);
      procedure btnRedoClick(Sender: TObject);
      procedure MDITabMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
      procedure mnuSetupClick(Sender: TObject);
      procedure cboZoomChange(Sender: TObject);
      procedure menuAboutClick(Sender: TObject);
      procedure mnuCaptureWallpaperClick(Sender: TObject);
      procedure mnuColorNoiseClick(Sender: TObject);
      procedure mnuMonoNoiseClick(Sender: TObject);
      procedure mnuMosaicClick(Sender: TObject);
      procedure mnuBrightnessClick(Sender: TObject);
      procedure btnPenClick(Sender: TObject);
      procedure btnDragClick(Sender: TObject);
      procedure btnAirBrushClick(Sender: TObject);
      procedure btnSelColorClick(Sender: TObject);
      procedure btnFloodFillClick(Sender: TObject);
      procedure btnEraserClick(Sender: TObject);
      procedure btnTextClick(Sender: TObject);
      procedure btnArrowClick(Sender: TObject);
      procedure edtPenSizeChange(Sender: TObject);
      procedure btnPenSize1Click(Sender: TObject);
      procedure btnPenSize2Click(Sender: TObject);
      procedure btnPenSize3Click(Sender: TObject);
      procedure btnLineClick(Sender: TObject);
      procedure btnRectangleClick(Sender: TObject);
      procedure btnCircleClick(Sender: TObject);
      procedure btnRoundRectClick(Sender: TObject);
      procedure tbInvertClick(Sender: TObject);
      procedure tbGrayScaleClick(Sender: TObject);
      procedure tbBrightnessClick(Sender: TObject);
      procedure mnuAutoScrollClick(Sender: TObject);
      procedure popCloseClick(Sender: TObject);
      procedure mnuRotate90Click(Sender: TObject);
      procedure mnuRotate180Click(Sender: TObject);
      procedure mnuRotate270Click(Sender: TObject);
      procedure FormResize(Sender: TObject);
      procedure btnSelectClick(Sender: TObject);
      procedure btnZoomClick(Sender: TObject);
      procedure mnuCanvasResizeClick(Sender: TObject);
      procedure mnuDeleteClick(Sender: TObject);
      procedure mnuCropClick(Sender: TObject);
      procedure mnuSaturationClick(Sender: TObject);
      procedure gbLayerAlphaChange(Sender: TObject);
      procedure mnuHorzFlipClick(Sender: TObject);
      procedure mnuVertFlipClick(Sender: TObject);
      procedure mnuCaptureColorClick(Sender: TObject);
      procedure mnuSelectAllClick(Sender: TObject);
      procedure mnuCaptureIconClick(Sender: TObject);
      procedure mnuCaptureWindowResizeClick(Sender: TObject);
      procedure mnuAnyAngleClick(Sender: TObject);
      procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
      procedure gbShapeAlphaChange(Sender: TObject);
      procedure mnuCaptureWebImagesClick(Sender: TObject);
      procedure mnuAllCloseClick(Sender: TObject);
      procedure mnuCaptureObjectClick(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
      procedure btnColorExchangeClick(Sender: TObject);
      procedure popSaveClick(Sender: TObject);
      procedure menuHelpClick(Sender: TObject);
      procedure popTrayHideClick(Sender: TObject);
      procedure popTrayExitClick(Sender: TObject);
      procedure N13Click(Sender: TObject);
      procedure popupTrayPopup(Sender: TObject);
      procedure mnuPaintBoxClick(Sender: TObject);
      procedure tbUserCaptureClick(Sender: TObject);
      procedure TrayIconClick(Sender: TObject);
    procedure btnSmallClick(Sender: TObject);
    procedure btnNormalClick(Sender: TObject);
    procedure btnBigClick(Sender: TObject);
    private
      { Private declarations }
      FHttpget: THttpget;
      FXPMenu: TXPMenu;
      FModal: Boolean;
      FEraserSize: Integer;

      FInitialize: Boolean;
      function IsLayerDown: Boolean;

      procedure MainWndProc(var Message: TMessage);
      procedure MainCoolBarWndProc(var Message: TMessage);
      procedure WMHotkey(var Message: TWMHotkey);
      message WM_HOTKEY;
      procedure WMDropFiles(var Message: TWMDROPFILES);
      message WM_DROPFILES;
      procedure DefaultMDICursor(var Message: TMessage);
      message CM_MDICursor;
      procedure ConnectEvent;
      procedure CaptureTypeClick(Sender: TObject);
      procedure AppHint(Sender: TObject);
      procedure AppIdle(Sender: TObject; var Done: Boolean);
      procedure AppModalBegin(Sender: TObject);
      procedure AppModalEnd(Sender: TObject);
      procedure AppMinimize(Sender: TObject);
      // ** 버전 업데이트 체크하기 위한 함수들 **//
      procedure httpgetDoneString(Sender: TObject; Result: String);
      // ** 이미지 열기,저장과 관련 된 함수 ** //
      procedure LoadImage(FileName: string);
      function SaveImage(Bitmap: TBitmap32; FileName: string): Boolean;
      // *************************************** //
      // ** 핫키와 관련 된 함수 ** //
      function RegistryHotKey(var StrList: TStringList): Boolean;
      // ************************* //
      // ** 이미지 이펙트와 관련 된 함수 ** //
      procedure AddEffect(EffectMode: Byte);
      procedure NormalAddEffect(NormalEffectMode: Byte);
      procedure ImageRotate(ARotate: Integer);
      procedure ImageFlip(Horz: Boolean = True);
      // ** ***************************** ** //
      procedure AutoSaveImage(ABitmap: TBitmap32);

      procedure CreateTrayPoupMenu;

      procedure CopyAndInsertMenuItems(DstMenuItem: TMenuItem;
        SrcMenuItem: TMenuItem);
      procedure CopyMenuItemsState(DstMenuItem: TMenuItem;
        SrcMenuItem: TMenuItem);

      procedure CheckForUpdate;
      procedure mnuUpdateItemClick(Sender: TObject);
    protected
      procedure CreateParams(var Params: TCreateParams); override;
    public
      property Initialize: Boolean read FInitialize write FInitialize;
      property EraserSize: Integer read FEraserSize write FEraserSize;
    public
      { Public declarations }
      FPalettePen: TOpenPalette;
      FPaletteBrush: TOpenPalette;

      FBeforeToolSel: Integer;
      FLastRect: TRect;
      FCapture: Boolean;
      FCaptureCount: TCaptureCount;
      procedure XPMenuSetup(var FXPMenu: TXPMenu; AForm: TForm);
      procedure MDIClosing(MDIIndex: Integer);
      procedure UpdatePaintPanel;
      procedure ChangePaintTool(nTool: Integer);
      procedure UpdatePaintTool(nTool: Integer);
      procedure UpdateMenu(Sender: TObject);
    end;

  var
    frmMain: TfrmMain;

implementation

uses CaptureEngine,
  uMDI, uHotKey,
  uResizeImage, ColorConvert,
  uOption, uAddText, uAbout, uSaveCursor, uCommonDlg, uResizeCanvas,
  uAnyAngle, OpenInterface, libImageEffect, GR32_Resamplers;
{$R *.dfm}
{$R drvCapture.res}
{$R curMDI.res}

function TfrmMain.IsLayerDown: Boolean;
begin
  Result := False;
  if MDIChildCount > 0 then
    with TfrmMDI(ActiveMDIChild) do
      if FRBLayer <> nil then
        if (FLayerDown = True) or (FLayerMove = True) then
          Result := True;
end;

procedure TfrmMain.XPMenuSetup(var FXPMenu: TXPMenu; AForm: TForm);
begin
  FXPMenu := TXPMenu.Create(AForm);
  with FXPMenu do
  begin
    XPContainers := [];
    XPControls := [xcMainMenu, xcPopupMenu, xcToolbar];
    DimLevel := 0;
    GrayLevel := 0;
    Gradient := False;
    CheckedColor := $00BC773F;
    Color := clWhite;
    DisabledColor := $00CCAA9D;
    IconBackColor := $00EDF2F3;
    MenuBarColor := clBtnFace;
    SelectColor := $00C9DCD8;
    SelectBorderColor := $007A8689;
    SelectFontColor := clBlack;
    SeparatorColor := $00ADADAD;
    UseSystemColors := False;
    UseDimColor := True;
    Font := Self.Font;
    AutoDetect := True;
    Active := True;
  end;

end;

procedure TfrmMain.AutoSaveImage(ABitmap: TBitmap32);
var
  NumberType, FileName: string;
  Ext: string;
  i: Integer;
begin
  if MDIChildCount > 0 then
    with frmOption do
      if (edtPath.Text <> '') and (edtFileName.Text <> '') and
        (chkAutoSave.Checked = True) then
      begin

        if cboFormat.ItemIndex = 0 then
          Ext := 'jpg'
        else
          Ext := Copy(cboFormat.Text, Length(cboFormat.Text) - 3, 3);

        // 자릿수에 맞춰 일련번호 표시
        NumberType := '';
        for i := 1 to edtNumberType.Value do
          NumberType := NumberType + '0';

        FileName := edtPath.Text + edtFileName.Text + FormatFloat
          (NumberType, AutoSaveCount) + '.' + Ext;

        // ** 저장하려는 파일의 이름이 이미 존재한다면 ** //
        if FileExists(FileName) = True then
        begin
          CheckAutoSave(AutoSaveCount);
          FileName := edtPath.Text + edtFileName.Text + FormatFloat
            (NumberType, AutoSaveCount) + '.' + Ext;
        end;

        Inc(AutoSaveCount);

        try
          SaveImage(ABitmap, FileName);

          // ** 자동 저장이 성공했다면 저장한 이름으로 캡션을 바꾼다. ** //
          Self.ActiveMDIChild.Caption := FileName;
          MDITab.Tabs[MDITab.TabIndex] := ExtractFileName(FileName);
        except
          on E: Exception do
          begin
            Dec(AutoSaveCount);
            InfoMessage(errAutoSave + #13 + #10 + #13 + #10 + E.Message);
          end;
        end;

      end;
end;

procedure TfrmMain.ImageFlip(Horz: Boolean = True);
begin
  if MDIChildCount > 0 then
    with TfrmMDI(frmMain.ActiveMDIChild) do
      try
        BeginCursor;

        if FRBLayer = nil then
          SaveUndoImage(FAImage.Bitmap)
        else
          FlattenLayer(True, False);

        case Horz of
          True:
            if FRBLayer = nil then
              FAImage.Bitmap.FlipHorz(nil)
            else
              FBitmapLayer.Bitmap.FlipHorz(nil);
          False:
            if FRBLayer = nil then
              FAImage.Bitmap.FlipVert(nil)
            else
              FBitmapLayer.Bitmap.FlipVert(nil);
        end;

      finally
        EndCursor;
      end;

end;

procedure TfrmMain.ImageRotate(ARotate: Integer);
var
  OldRect: TRect;
begin
  if MDIChildCount > 0 then
    with TfrmMDI(frmMain.ActiveMDIChild) do
      try
        BeginCursor;
        FAImage.BeginUpdate;

        if FRBLayer = nil then
          SaveUndoImage(FAImage.Bitmap)
        else
        begin
          with FRBLayer.Location do
            OldRect := Rect(Round(Left), Round(Top), Round(Right), Round(Bottom)
              );

          FlattenLayer(True, False);
        end;

        case ARotate of
          90:
            if FRBLayer = nil then
              FAImage.Bitmap.Rotate90(nil)
            else
              FBitmapLayer.Bitmap.Rotate90(nil);
          180:
            if FRBLayer = nil then
              FAImage.Bitmap.Rotate180(nil)
            else
              FBitmapLayer.Bitmap.Rotate180(nil);
          270:
            if FRBLayer = nil then
              FAImage.Bitmap.Rotate270(nil)
            else
              FBitmapLayer.Bitmap.Rotate270(nil);
        end;

        if FRBLayer <> nil then
          with FRBLayer.Location do
            FRBLayer.Location := FloatRect
              (Left, Top, OldRect.Left + FBitmapLayer.Bitmap.Width,
              OldRect.Top + FBitmapLayer.Bitmap.Height);

      finally
        FAImage.EndUpdate;
        FAImage.Repaint;
        EndCursor;
        cboZoom.OnChange(nil);
      end;

end;

procedure TfrmMain.ConnectEvent;
var
  i: Integer;
  MenuItem: TMenuItem;
begin
  MenuItem := MainMenu.Items[2].Items[17];
  for i := 0 to MenuItem.Count - 1 do
    MenuItem.Items[i].OnClick := CaptureTypeClick;

  Application.OnHint := AppHint;
  Application.OnIdle := AppIdle;

  FModal := False;
  Application.OnModalBegin := AppModalBegin;
  Application.OnModalEnd := AppModalEnd;

  Application.OnMinimize := AppMinimize;
end;

procedure TfrmMain.CopyAndInsertMenuItems(DstMenuItem, SrcMenuItem: TMenuItem);
var
  i: Integer;
  MenuItem: TMenuItem;
begin
  for i := 0 to SrcMenuItem.Count - 1 do
  begin
    MenuItem := TMenuItem.Create(DstMenuItem);

    MenuItem.Caption := SrcMenuItem.Items[i].Caption;
    MenuItem.OnClick := SrcMenuItem.Items[i].OnClick;

    DstMenuItem.Add(MenuItem);
    if SrcMenuItem.Items[i].Count > 0 then
      CopyAndInsertMenuItems(MenuItem, SrcMenuItem.Items[i]);
  end;
end;

procedure TfrmMain.CopyMenuItemsState(DstMenuItem, SrcMenuItem: TMenuItem);
var
  i: Integer;
  MenuItem: TMenuItem;
begin
  // 메뉴 아이템의 개수가 다르다면 메뉴 아이템의 상태를 복사하지 않습니다.
  if DstMenuItem.Count <> SrcMenuItem.Count then
    Exit;

  for i := 0 to SrcMenuItem.Count - 1 do
  begin
    DstMenuItem[i].Default := SrcMenuItem.Items[i].Default;
    DstMenuItem[i].ShortCut := SrcMenuItem.Items[i].ShortCut;

    DstMenuItem[i].Checked := SrcMenuItem.Items[i].Checked;

    if SrcMenuItem.Items[i].Count > 0 then
      CopyMenuItemsState(DstMenuItem[i], SrcMenuItem.Items[i]);
  end;
end;

procedure TfrmMain.CreateParams(var Params: TCreateParams);
begin
  // 임시로 만들어두었습니다.
  // 나중에 이 부분에서 어떠한 코드를 작성할 것입니다.
  inherited CreateParams(Params);
end;

procedure TfrmMain.CreateTrayPoupMenu;
begin
  CopyAndInsertMenuItems(pmnuCapture, MainMenu.Items[2]);
end;

procedure TfrmMain.AppModalBegin(Sender: TObject);
begin
  FModal := True;
end;

procedure TfrmMain.AppModalEnd(Sender: TObject);
begin
  FModal := False;
end;

procedure TfrmMain.AppMinimize(Sender: TObject);
begin
  if frmOption.chkTrayIconUse.Checked = True then
    if frmOption.chkTrayMinimizeHide.Checked = True then
    begin
      Self.Hide;
      // Applcation 객체를 숨겨주지 않으면 간혹 작업 표시줄에 아이콘이 남아있을 수 있습니다.
      ShowWindow(Application.Handle, SW_HIDE);
    end;
end;

procedure TfrmMain.AppHint(Sender: TObject);
begin
  with StatusBar do

    if MDIChildCount = 0 then
    begin
      SimplePanel := True;
      SimpleText := Application.Hint;
    end
    else
    begin // == if MDIChildCount > 0 then
      with TfrmMDI(ActiveMDIChild) do
        if (FDown = True) or (IsLayerDown = True) then
        begin
          SimplePanel := False;
          cboZoom.OnChange(Sender);
        end
        else
        begin
          SimplePanel := Length(Application.Hint) > 0;
          SimpleText := Application.Hint;
        end;
    end;

end;

procedure TfrmMain.AppIdle(Sender: TObject; var Done: Boolean);
var
  lpPoint: TPoint;
begin
  if MDIChildCount > 0 then
    with TfrmMDI(ActiveMDIChild) do
      if (FDown = True) and (FDraw = True) then
      begin
        FDraw := False;
        GetCursorPos(lpPoint);
        lpPoint := FAImage.ScreenToClient(lpPoint);

        FAImage.OnMouseMove(Sender, [], lpPoint.X, lpPoint.Y, nil);
        Sleep(10);
      end;
end;

procedure TfrmMain.CaptureTypeClick(Sender: TObject);
var
  i: Integer;
  MenuItem: TMenuItem;
begin
  MenuItem := MainMenu.Items[2].Items[17];

  for i := 0 to MenuItem.Count - 1 do
    if MenuItem.Items[i].Caption = TMenuItem(Sender).Caption then
      MenuItem.Items[i].Checked := True
    else
      MenuItem.Items[i].Checked := False;

end;

// ** 메뉴에 단축키와 레지스트리에 핫키를 등록시킨다. ** //

function TfrmMain.RegistryHotKey(var StrList: TStringList): Boolean;
var
  OpenSetup: TiniFile;
  MenuShortCut: TShortCut;
  MenuShortCutText: string;
  i: Integer;
begin
  Result := True;
  OpenSetup := TiniFile.Create(ExtractFilePath(Application.ExeName) + INIPath);
  StrList.Add('다음 핫키를 등록 할 수 없습니다.');
  StrList.Add('');
  try

    for i := 0 to 14 do
    begin
      MenuShortCutText := OpenSetup.ReadString
        ('단축키 설정', MainMenu.Items[2].Items[i].Caption, ShortCutToText
          (MainMenu.Items[2].Items[i].ShortCut));

      MenuShortCut := TextToShortCut(MenuShortCutText);
      MainMenu.Items[2].Items[i].ShortCut := MenuShortCut;

      if MenuShortCutText <> '' then
        if SetWindowHotKey(Self.Handle, i, MenuShortCut) = False then
          StrList.Add(MainMenu.Items[2].Items[i].Caption + ': ' +
              MenuShortCutText);
    end;

  finally
    OpenSetup.Free;
    if StrList.Count > 2 then
      Result := False;
  end;

end;

// ******************************************** //

procedure TfrmMain.MDIClosing(MDIIndex: Integer);
var
  i: Integer;
begin

  MDITab.Tabs.Delete(MDIIndex);
  if MDITab.Tabs.Count <> 0 then
  begin

    if MDIIndex = MDITab.Tabs.Count then
      MDITab.TabIndex := MDIIndex - 1
    else
      MDITab.TabIndex := MDIIndex;
  end
  else
    MDITab.Tabs.Add('캡쳐 작업 없음');

  if MDIChildCount > 0 then
    for i := 0 to MDIChildCount - 1 do
      if MDIChildRen[i].Tag <> MDIIndex then
        if MDIChildRen[i].Tag > MDIIndex then
          MDIChildRen[i].Tag := MDIChildRen[i].Tag - 1;

end;

procedure TfrmMain.CheckForUpdate;
begin
  if frmOption.chkCheckForUpdate.Checked = True then
  begin
    try
      FHttpget.OnDoneString := httpgetDoneString;
      // 원래 배포하는 게시물 하나로 모든 버전관리를 처리한다.
      FHttpget.URL := UpdateURL;
      FHttpget.GetString;
    except
      // 오류 무시
    end;
  end;
end;

procedure TfrmMain.UpdateMenu(Sender: TObject);
var
  i, j: Integer;
begin
  if MDIChildCount = 0 then
  begin
    // 창이 모두 닫힌 경우 실행됩니다.
    for i := 0 to MainMenu.Items.Count - 1 do
      for j := 0 to MainMenu.Items.Items[i].Count - 1 do
        if (i <> 2) and (i <> 4) and (i <> 6) then
          MainMenu.Items.Items[i].Items[j].Enabled := False;

    mnuNewImage.Enabled := True;
    mnuOpenFile.Enabled := True;
    mnuExit.Enabled := True;

    btnDrag.Down := True;

    for i := 0 to popupMnu.Items.Count - 1 do
      popupMnu.Items[i].Enabled := False;

    // 이미지 편집 도구에 의해 변경 된 커서를 원래대로 되돌립니다.
    Screen.Cursor := crDefault;

    // 모든 컨트롤을 숨깁니다.
    for i := 0 to pnlPaintToolOption.ControlCount - 1 do
      TControl(pnlPaintToolOption.Controls[i]).Visible := False;

    // 이전에 상태표시줄에 나타나있었던 텍스트를 모두 삭제합니다.
    StatusBar.SimplePanel := True;
    StatusBar.SimpleText := '';
  end
  else
  begin
    // 창이 하나라도 열려 있을 경우 실행됩니다.
    for i := 3 to 5 do
      for j := 0 to MainMenu.Items.Items[i].Count - 1 do
        if i in [3, 5] then
          MainMenu.Items.Items[i].Items[j].Enabled := True;

    mnuCut.Enabled := TfrmMDI(ActiveMDIChild).FRBLayer <> nil;
    mnuCrop.Enabled := mnuCut.Enabled;
    mnuDelete.Enabled := mnuCut.Enabled;
    mnuCopy.Enabled := True;
    mnuPaste.Enabled := True;
    mnuSelectAll.Enabled := True;

    mnuSaveFile.Enabled := True;
    mnuClose.Enabled := True;
    mnuAllClose.Enabled := True;

    popClose.Enabled := True;
  end;

end;

procedure TfrmMain.UpdatePaintPanel;
var
  i: Integer;
  EraserCursorBmp: TBitmap;
  EraserCursorMaskBmp: TBitmap;
  EraserCursorInfo: TIconInfo;
begin
  if ActiveMDIChild <> nil then
  begin

    with TfrmMDI(ActiveMDIChild) do
    begin
      for i := 0 to pnlPaintToolOption.ControlCount - 1 do
        TControl(pnlPaintToolOption.Controls[i]).Visible := False;

      if FRBLayer <> nil then
      begin
        pnlPaintToolOption.FindChildControl('pnlBitmapLayer').Visible := True;

        Exit;
      end;

      case ToolSel of
        tsPen, tsArrow, tsLine:
          pnlPaintToolOption.FindChildControl('pnlPenSize').Visible := True;
        tsRect, tsEllipse, tsRoundRect:
          pnlPaintToolOption.FindChildControl('pnlShape').Visible := True;
        tsEraser:
          begin
            EraserCursorBmp := TBitmap.Create;
            EraserCursorMaskBmp := TBitmap.Create;
            with EraserCursorBmp do
            begin
              Canvas.Brush.Color := FPaletteBrush.Color;
              Canvas.Pen.Style := psSolid;
              Canvas.Pen.Color := Canvas.Brush.Color;
              SetSize(EraserSize, EraserSize);
              Canvas.Rectangle(0, 0, EraserSize, EraserSize);
              EraserBitmap.Assign(EraserCursorBmp);

              SetSize(Round(EraserSize * FAImage.Scale), Round(EraserSize * FAImage.Scale));
              Canvas.Pen.Color := clBlack;
              if Canvas.Brush.Color = clBlack then Canvas.Pen.Color := clWhite;
              Canvas.Rectangle(0, 0, Width, Height);
            end;

            with EraserCursorMaskBmp do
            begin
              SetSize(EraserCursorBmp.Width, EraserCursorBmp.Height);
              Canvas.Pen.Style := psSolid;
              Canvas.Pen.Color := clBlack;
              Canvas.Brush.Color := EraserCursorBmp.Canvas.Brush.Color;
              if Canvas.Brush.Color = clWhite then Canvas.Brush.Color := clBlack;
              Canvas.Rectangle(0, 0, Width, Height);
            end;

            with EraserCursorInfo do
            begin
              fIcon := False;
              xHotSpot := Trunc(FAImage.Scale * (EraserSize / 2));
              yHotSpot := Trunc(FAImage.Scale * (EraserSize / 2));
              hbmMask := EraserCursorMaskBmp.Handle;
              hbmColor := EraserCursorBmp.Handle;
            end;

            Screen.Cursors[tsEraser] := CreateIconIndirect(EraserCursorInfo);
            EraserCursorBmp.Free;
            EraserCursorMaskBmp.Free;

            FAImage.Cursor := tsEraser;
            pnlPaintToolOption.FindChildControl('pnlEraser').Visible := True;
          end;
      end;

      if ToolSel in [tsPen, tsAirBrush, tsArrow, tsLine, tsRect, tsEllipse,
        tsRoundRect] then
        pnlPaintToolOption.FindChildControl('pnlPenWidth').Visible := True;

    end;
  end;

end;

procedure TfrmMain.UpdatePaintTool(nTool: Integer);
begin
  case nTool of
    tsDrag:
      btnDrag.Down := True;
    tsPen:
      btnPen.Down := True;
    tsAirBrush:
      btnAirBrush.Down := True;
    tsFloodFill:
      btnFloodFill.Down := True;
    tsEraser:
      btnEraser.Down := True;
    tsText:
      btnText.Down := True;
    tsArrow:
      btnArrow.Down := True;
    tsLine:
      btnLine.Down := True;
    tsRect:
      btnRectangle.Down := True;
    tsEllipse:
      btnCircle.Down := True;
    tsRoundRect:
      btnRoundRect.Down := True;
    tsSelect:
      btnSelect.Down := True;
  end;

  UpdatePaintPanel;

end;

procedure TfrmMain.ChangePaintTool(nTool: Integer);
begin
  if MDIChildCount > 0 then
    with TfrmMDI(ActiveMDIChild) do
    begin
      if nTool = ToolSel then
        Exit;

      if (ToolSel = tsSelColor) and (frmMain.btnSelColor.Tag = -1) then
      begin
        UpdatePaintTool(FBeforeToolSel);
        btnSelColor.Tag := 0;
      end;

      if ToolSel <> tsSelColor then
        FBeforeToolSel := ToolSel;

      if FRBLayer <> nil then
        if (ToolSel in [tsSelect, tsText]) then
          FlattenLayer(False, True);

      ToolSel := nTool;

      if ToolSel = tsDrag then
        FAImage.Cursor := CUR_DRAG
      else
        FAImage.Cursor := nTool;

      UpdatePaintPanel;

    end;

end;

procedure TfrmMain.DefaultMDICursor(var Message: TMessage);
const
  CUR_LIST: array [0 .. 14] of string = ('CUR_PEN', 'CUR_BRUSH', 'CUR_ERASER',
    'CUR_SHAPE', 'CUR_SHAPE', 'CUR_SHAPE', 'CUR_SHAPE', 'CUR_TEXT',
    'CUR_SELCOLOR', 'CUR_FILL', 'CUR_SHAPE', 'CUR_SELECTIMAGE', 'CUR_ZOOM',
    'CUR_DRAG_DOWN', 'CUR_DRAG_MOVE');
var
  i: Integer;
begin
  for i := 0 to High(CUR_LIST) do
    Screen.Cursors[i + 1] := LoadCursor(HInstance, PChar(CUR_LIST[i]));
end;

procedure TfrmMain.WMDropFiles(var Message: TWMDROPFILES);
var
  StringList: TStringList;
  FileName: array [0 .. MAX_PATH] of char;
  Count: Integer;
  i: Integer;
begin
  // ** 0xFFFFFFFF ** //
  Count := DragQueryFile(Message.Drop, $FFFFFFFF, FileName, MAX_PATH);
  StringList := TStringList.Create;
  try

    for i := 0 to Count - 1 do
    begin
      DragQueryFile(Message.Drop, i, FileName, MAX_PATH);
      StringList.Add(FileName);
    end;

    LoadImage(StringList.Text);

  finally
    DragFinish(Message.Drop);
    StringList.Free;
  end;

end;

procedure TfrmMain.WMHotkey(var Message: TWMHotkey);

  function FindColorPicker: Boolean;
  var
    ColorPickerHandle: HWND;
  begin
    Result := False;
    ColorPickerHandle := FindWindow('TfrmOpenColorPicker',
      'frmOpenColorPicker');

    if ColorPickerHandle <> 0 then
      if GetParent(ColorPickerHandle) = Application.Handle then
        Result := True;
  end;

var
  FDown: Boolean;
begin
  if FindColorPicker = False then
  begin

    if MDIChildCount > 0 then
      FDown := TfrmMDI(frmMain.ActiveMDIChild).FDown
    else
      FDown := False;

    if (Self.FCapture = False) and (FDown = False) and (FModal = False) and
      (IsLayerDown = False) then
      MainMenu.Items[2].Items[Message.HotKey].Click;

  end;
end;

procedure TfrmMain.LoadImage(FileName: string);

  function FileExt(FileName: string): Byte;
  var
    FExt: string;
  begin
    FExt := ExtractFileExt(FileName);
    FExt := StrUpper(PChar(FExt));

    if FExt = '.GIF' then
      Result := extGIF
    else if FExt = '.JPG' then
      Result := extJPG
    else if FExt = '.ICO' then
      Result := extIco
    else if FExt = '.BMP' then
      Result := extBmp
    else if FExt = '.CUR' then
      Result := extCur
    else if (FExt = '.EMF') or (FExt = '.WMF') then
      Result := extGeneral
    else
      Result := extSpecial;
  end;

var
  Start: DWORD;
  Finish: Real;

  ABitmap: TBitmap;
  PNGObject: TPngObject;
  JPEG: TJPEGImage;
  GIF: TGIFImage;
  Icon: TIcon;

  StrList, ErrList: TStringList;
  i: Integer;
begin
  StrList := TStringList.Create;
  StrList.Text := FileName;

  OpenDialog.InitialDir := ExtractFileDir(StrList[0]);

  ErrList := TStringList.Create;
  ErrList.Add('다음 파일을 열 수 없습니다');
  ErrList.Add('');

  BeginCursor;

  Start := GetTickCount;

  FCapture := True;

  try
    for i := 0 to StrList.Count - 1 do
    begin
      StatusBar.Panels[0].Text := '진행 중인 항목 :' + IntToStr(i + 1)
        + ' 남은 항목 :' + IntToStr(StrList.Count) + ' ESC키를 누르면 중지합니다.';
      if GetKeyState(VK_ESCAPE) < 0 then
        break;
      FileName := StrList[i];
      try
        frmMDI := TfrmMDI.Create(Application);

        if MDITab.Tabs[0] = '캡쳐 작업 없음' then
          MDITab.Tabs[0] := ExtractFileName(FileName)
        else
        begin
          MDITab.Tabs.Add(ExtractFileName(FileName));
          MDITab.TabIndex := MDITab.Tabs.Count - 1;
        end;

        frmMDI.Tag := MDITab.Tabs.Count - 1;
        frmMDI.Caption := FileName;

        case FileExt(FileName) of

          extGIF:
            try
              GIF := TGIFImage.Create;
              GIF.LoadFromFile(FileName);
              frmMDI.FAImage.Bitmap.Assign(GIF.Images[0].Bitmap);
            finally
              GIF.Free;
            end;

          extJPG:
            try
              JPEG := TJPEGImage.Create;
              JPEG.LoadFromFile(FileName);
              frmMDI.FAImage.Bitmap.Assign(JPEG);
            finally
              JPEG.Free;
            end;

          extIco:
            try
              Icon := TIcon.Create;
              ABitmap := TBitmap.Create;
              Icon.LoadFromFile(FileName);

              ABitmap.Width := 32;
              ABitmap.Height := 32;
              ABitmap.Canvas.Draw(0, 0, Icon);
              frmMDI.FAImage.Bitmap.Assign(ABitmap);

            finally
              ABitmap.Free;
              Icon.Free;
            end;

          extBmp:
            frmMDI.FAImage.Bitmap.LoadFromFile(FileName);

          extCur:
            try
              Icon := TIcon.Create;
              ABitmap := TBitmap.Create;
              Icon.Handle := LoadCursorFromFile(PChar(FileName));

              if Icon.Handle = 0 then
                raise Exception.Create('커서를 여는데 실패..')
              else
              begin
                ABitmap.Width := 32;
                ABitmap.Height := 32;

                ABitmap.Canvas.Draw(0, 0, Icon);
                frmMDI.FAImage.Bitmap.Assign(ABitmap);
              end;

            finally
              ABitmap.Free;
              Icon.ReleaseHandle;
              Icon.Free;
            end;

          extGeneral:
            frmMDI.FAImage.Bitmap.LoadFromFile(FileName);

          extSpecial:
            try
              PNGObject := TPngObject.Create;
              ABitmap := TBitmap.Create;
              PNGObject.LoadFromFile(FileName);
              ABitmap.Assign(PNGObject);
              frmMDI.FAImage.Bitmap.Assign(ABitmap);
            finally
              ABitmap.Free;
              PNGObject.Free;
            end;

        end;

        cboZoom.OnChange(nil);
        StatusBar.Panels[1].Text := Format
          ('가로 : %d x 세로 : %d', [frmMDI.FAImage.Bitmap.Width,
          frmMDI.FAImage.Bitmap.Height]);

      except
        ErrList.Add(FileName);
        MDIClosing(frmMDI.Tag);
        frmMDI.Free;
      end;

      if StrList.Count > 1 then
        Sleep(100);

      Application.ProcessMessages;
    end;

  finally
    EndCursor;

    Finish := (GetTickCount - Start) / 1000;
    StatusBar.Panels[2].Text := '걸린 시간: ' + Format('%.2f Sec', [Finish]);

    if ErrList.Count > 2 then
      InfoMessage(ErrList.Text);

    StrList.Free;
    ErrList.Free;

    FCapture := False;
  end;

end;

procedure TfrmMain.popSaveClick(Sender: TObject);
begin
  mnuSaveFile.Click;
end;

procedure TfrmMain.popTrayExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.popTrayHideClick(Sender: TObject);
begin
  Self.Hide;
end;

function TfrmMain.SaveImage(Bitmap: TBitmap32; FileName: string): Boolean;

  function IsIconSize(W, H: Integer): Boolean;
  begin
    Result := False;
    if W <> H then
      Exit;
    if W in [16, 24, 32, 48, 64, 72, 96, 128] then
      Result := True;
  end;

  function IsCursorSize(W, H: Integer): Boolean;
  begin
    Result := False;
    if W <> H then
      Exit;
    if W = 32 then
      Result := True;
  end;

// 파일 이름부터 이미지 타입을 가져오는 함수
  procedure CheckImageType(var FileName: string; var ImageType: Byte);
  var
    CheckName, TempExt: string;
  begin
    CheckName := FileName;
    CheckName := Copy(FileName, Length(FileName) - 2, 3);
    // ** 소문자로 변환 ** //
    LowerCase(CheckName);

    if CheckName = 'jpg' then
      ImageType := itJPEG
    else if CheckName = 'gif' then
      ImageType := itGIF
    else if (CheckName = 'png') or (CheckName = 'mng') then
      ImageType := itPNG
    else if CheckName = 'bmp' then
      ImageType := it24bitBitmap
    else if CheckName = 'ico' then
      ImageType := it24bitIco
    else if CheckName = 'cur' then
      ImageType := it24bitCursor
    else
    begin
      // 기존에 파일명 확장자가 없다면, 필터인덱스로 강제로 추가
      TempExt := '';
      case SaveDialog.FilterIndex of
        1: TempExt := '.jpg';
        2: TempExt := '.gif';
        3: TempExt := '.png';
        4: TempExt := '.bmp';
        5: TempExt := '.ico';
        6: TempExt := '.cur';
        else TempExt := '.png'; // 아무것도 없으면 png
      end;
      // 파일명에 확장자 추가해서 다시 ImageType검사
      FileName := FileName + TempExt;
      CheckImageType(FileName, ImageType);
    end;

  end;

var
  ImageType: Byte;

  ABitmap: TBitmap;

  ABitmap32: TBitmap32;
  PNGObject: TPngObject;
  GifImage: TGIFImage;
begin

  Result := False;

  CheckImageType(FileName, ImageType);

  case ImageType of
    itJPEG:
      with TJPEGImage.Create do
        try
          ABitmap := TBitmap.Create;
          ABitmap.Assign(Bitmap);
          CompressionQuality := frmOption.gbJpeg.Position;
          Compress;
          Assign(ABitmap);
          SaveToFile(FileName);
        finally
          Free;
          ABitmap.Free;
        end;
    itGIF:
      try
        GifImage := TGIFImage.Create;
        ABitmap := TBitmap.Create;
{$IFNDEF UNICODE}
        GifImage.ColorReduction := rmQuantizeWindows;
        GifImage.DitherMode := dmFloydSteinberg;
        GifImage.Compression := gcLZW;
{$ENDIF}
        ABitmap.Assign(Bitmap);
        GifImage.Assign(ABitmap);
        GifImage.SaveToFile(FileName);
      finally
        GifImage.Free;
        ABitmap.Free;
      end;
    itPNG:
      try
        PNGObject := TPngObject.Create;
        ABitmap := TBitmap.Create;
        ABitmap.Assign(Bitmap);
        ABitmap.PixelFormat := pf24bit;
        PNGObject.Assign(ABitmap);
        PNGObject.SaveToFile(FileName);
      finally
        ABitmap.Free;
        PNGObject.Free;
      end;
    it24bitBitmap:
      try
        ABitmap := TBitmap.Create;
        ABitmap.Assign(Bitmap);
        ABitmap.PixelFormat := pf24bit;
        ABitmap.SaveToFile(FileName);
      finally
        ABitmap.Free;
      end;
    it24bitIco:
      with TLinearBitmap.Create do
        try
          ABitmap := TBitmap.Create;
          ABitmap.Assign(Bitmap);
          ABitmap.PixelFormat := pf24bit;
          Assign(ABitmap);

          PixelFormat := pf24bit;
          if IsIconSize(ABitmap.Width, ABitmap.Height) then
            SaveToFile(FileName)
          else
          begin
            InfoMessage
              ('이미지를 아이콘으로 저장하시려면 이미지의 크기를 다음과 같이 변경해주세요.' + #10 + '' + #10 +
                '[ 16 x 16 ] ,  [ 24 x 24 ] ,  [ 32 x 32 ] ,  [48 x 48 ] ,  [64 x 64 ] ,  [72 x 72 ] ,  [96 x 96 ] ,  [128 x 128 ]'
                + #10 + '' +
                #10 + '이미지의 크기 변경은 메뉴에 [ 이미지 - 이미지 실제 크기 변경 ] 에서 할 수 있습니다.');

            Exit;
          end;
        finally
          Free;
          ABitmap.Free;
        end;
    it24bitCursor:
      with TLinearBitmap.Create do
        try
          ABitmap := TBitmap.Create;
          ABitmap.Assign(Bitmap);

          ABitmap.PixelFormat := pf24bit;

          Assign(ABitmap);
          if IsCursorSize(ABitmap.Width, ABitmap.Height) then
          begin
            with TfrmSaveCursor.Create(Application) do
              try
                ImgCursor.Picture.Bitmap.Width := 32;
                ImgCursor.Picture.Bitmap.Height := 32;
                ImgCursor.Picture.Bitmap.Canvas.Draw(0, 0, ABitmap);
                if ShowModal <> mrOk then
                  Exit;
                // ** mrOk 라면 .. ** //
                SaveToFile(FileName);
              finally
                Free;
              end;
          end
          else
          begin
            InfoMessage
              ('이미지를 커서로 저장하시려면 이미지의 크기를 다음과 같이 변경해주세요.' + #10 + '' + #10 +
                '[ 32 x 32 ]' + #10 + '' + #10 +
                '이미지의 크기 변경은 메뉴에 [ 이미지 - 이미지 실제 크기 변경 ] 에서 할 수 있습니다.');

            Exit;
          end;

        finally
          ABitmap.Free;
          Free;
        end;
  end;

  Result := True;

end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  FInitialize := False;

  // 트레이 아이콘과 관련하여 메인 폼에서 WM_CLOSE 메세지를
  // VCL 메세지 프로시저보다 먼저 받도록 하기 위한 준비작업을 합니다.
  WindowProc := MainWndProc;
  MainCoolBar.WindowProc := MainCoolBarWndProc;

  CreateTrayPoupMenu;

  FHttpget := THttpget.Create(Self);
  FPalettePen := TOpenPalette.Create(Self);
  FPaletteBrush := TOpenPalette.Create(Self);

  // 반드시 이름을 지정해줍니다.
  // 이름을 지정하지 않을 경우 Form의 컴포넌트를 순회해서 이 컴포넌트에 접근 시
  // 에러가 발생 할 수 있습니다.
  FPalettePen.Name := 'PalettePen';
  FPaletteBrush.Name := 'PaletteBrush';

  FPaletteBrush.Parent := pnlPaintBox;
  FPalettePen.Parent := pnlPaintBox;

  FPalettePen.SetBounds(14, 23, 28, 28);

  FPaletteBrush.SetBounds(31, 33, 28, 28);

  FPalettePen.Color := clBlack;
  FPaletteBrush.Color := clWhite;

  gbShapeAlpha.OnChange(Self);

  XPMenuSetup(FXPMenu, Self);
  // ** 이벤트 연결 ** //
  ConnectEvent;
  // ******************************************** //
  // ** 캡쳐 반복횟수에 관련 되 변수를 초기화 .** //
  FillChar(FCaptureCount, SizeOf(TCaptureCount), 0);
  // ******************************************** //
  Randomize;

  FPalettePen.FileName := ExtractFilePath(Application.ExeName) + INIPath;
  FPaletteBrush.FileName := FPalettePen.FileName;

  Screen.OnActiveFormChange := UpdateMenu;

  SetRectEmpty(FLastRect);

  FBeforeToolSel := -1;

  // ** 해상도가 640 x 480 일때 * //
  if Screen.Width = 640 then
  begin
    Width := 587;
    Height := 436;
  end;

  StatusBar.DoubleBuffered := True;

  DragAcceptFiles(Handle, True);

  LoadINI(Self, True, 'MainWindow', INIPath);
  LoadCheckMenuItem(mnuAutoScroll, 'MainMenuScroll', INIPath);
  LoadCheckMenuItems(mnuUserOption, 'MainMenuCapture', INIPath);
  LoadCheckMenuItems(mnuShow, 'MainMenuControlShow', INIPath);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  FPaletteBrush.Free;
  FPalettePen.Free;
end;

procedure TfrmMain.mnuOpenFileClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    LoadImage(OpenDialog.Files.GetText);
end;

procedure TfrmMain.mnuSaveFileClick(Sender: TObject);

  function IsIconSize(W, H: Integer): Boolean;
  begin
    Result := False;
    if W <> H then
      Exit;
    if W in [16, 24, 32, 48, 64, 72, 96, 128] then
      Result := True;
  end;

  function IsCursorSize(W, H: Integer): Boolean;
  begin
    Result := False;
    if W <> H then
      Exit;
    if W = 32 then
      Result := True;
  end;

  function IsReadOnly(FileName: string): Boolean;
  var
    Attrs: Integer;
  begin
    Result := False;
    if not FileExists(FileName) then
      Exit;
    Attrs := FileGetAttr(FileName);
    if Attrs and faReadOnly <> 0 then
      Result := True;
  end;

  procedure SetSaveFileName(var FileName: string);
  begin
    if (Copy(FileName, Length(FileName), 1)) = '*' then
      FileName := (Copy(FileName, 0, Length(FileName) - 1));
    if Copy(FileName, Length(FileName) - 3, 1) = '.' then
      FileName := Copy(FileName, 0, Length(FileName) - 4);
  end;

var
  FileName: string;
begin

  if MDIChildCount = 0 then
  begin
    InfoMessage('현재 열려있는 창이 없습니다.' + #10 + #10 +
        '화면을 캡쳐하거나 파일로 부터 이미지를 불러오세요.');
    Exit;
  end
  else
    with TfrmMDI(ActiveMDIChild) do
    begin
      if frmOption.chkTime.Checked = True then
      begin
        FileName := FormatDateTime(frmOption.edtTime.Text, Now);
        FileName := SetFileName(FileName);
      end
      else
        FileName := Caption;

      SetSaveFileName(FileName);
      SaveDialog.FileName := FileName;
    end;

  if (TfrmMDI(ActiveMDIChild).FAImage.Bitmap.Width = 0) and
    (TfrmMDI(ActiveMDIChild).FAImage.Bitmap.Height = 0) then
    InfoMessage('비어있는 이미지이므로 저장 할 수 없습니다.')
  else if SaveDialog.Execute = True then
    if IsReadOnly(SaveDialog.FileName) then
      InfoMessage('선택한 파일이 읽기 전용이므로 저장 할 수 없습니다.')
    else
      with TfrmMDI(ActiveMDIChild) do
      begin
        try
          // 텍스트를 편집 중이었거나 또는 레이어로 편집 중이었다면 작업한 내용을 이미지에 출력한 후 저장하도록 합니다.
          if (FfrmAddText <> nil) or (FRBLayer <> nil) then
            FlattenLayer(True, True);

          if SaveImage(FAImage.Bitmap, SaveDialog.FileName) = True then
          begin
            uBitmapList.Tag := uBitmapList.GetCount;
            Caption := SaveDialog.FileName;
            MDITab.Tabs[MDITab.TabIndex] := ExtractFileName
              (SaveDialog.FileName);
          end;

        except
          on E: Exception do
            InfoMessage
              ('이미지를 파일로 저장하는데 실패했습니다' + #13 + #10 + FileName + #13 + #10 +
                E.Message, '실패');
        end;

      end;

end;

procedure TfrmMain.btnOpenFileClick(Sender: TObject);
begin
  mnuOpenFile.Click;
end;

procedure TfrmMain.btnSaveFileClick(Sender: TObject);
begin
  mnuSaveFile.Click;
end;

procedure TfrmMain.tbCaptureControlClick(Sender: TObject);
begin
  mnuCaptureControl.Click;
end;

procedure TfrmMain.mnuCaptureFullScreenClick(Sender: TObject);
begin
  FCapture := True;

  with TCaptureEngine.Create(Application) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, frmOption.chkActive.Checked, edtWavPath.Text);

      CaptureEntire;

      frmMDI := TfrmMDI.Create(Application);
      SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 5);

      frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
      frmMDI.FAImage.Bitmap.ResetAlpha;

      AutoSaveImage(frmMDI.FAImage.Bitmap);

    finally
      FLastRect := FCaptureRect;
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);

end;

procedure TfrmMain.mnuStatusBarClick(Sender: TObject);
begin
  if StatusBar.Showing = True then
  begin
    StatusBar.Hide;
    mnuStatusBar.Checked := False;
  end
  else
  begin
    StatusBar.Show;
    mnuStatusBar.Checked := True;
  end;
end;

procedure TfrmMain.mnuExitClick(Sender: TObject);
var
  i: Integer;
  bMDISave: Boolean;
begin
  bMDISave := False;

  // MDI 창이 이미 떠있고 저장해야 할 작업이 남아있는지 체크합니다.
  if frmOption.chkUseSave.Checked = True then
    for i := 0 to MDIChildCount - 1 do
    begin
      if Copy(MDIChildRen[i].Caption, Length(MDIChildRen[i].Caption), 1)
        = '*' then
      begin
        bMDISave := True;

        break;
      end;

    end;

  // 저장해야 할 작업이 남아있다면 화면상에 폼을 보여주도록 합니다.
  if bMDISave = True then
    TrayIconClick(Sender);

  // Close 함수를 사용하면 MDIChild 일 경우 차일드 폼이 있는지 여부를
  // 모두 체크하여 Child를 모두 종료하고 마지막으로 PostQuitMessage를 보냅니다.
  // ( WM_CLOSE를 자기자신에게 보내지 않습니다. )
  Close;
end;

procedure TfrmMain.mnuCaptureLastRectClick(Sender: TObject);
begin

  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      if IsRectEmpty(FLastRect) = True then
      begin
        InfoMessage(errLastCapture);
        Exit;
      end;

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      CaptureRect(FLastRect);

      frmMDI := TfrmMDI.Create(Application);
      SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 6);

      frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
      frmMDI.FAImage.Bitmap.ResetAlpha;

      AutoSaveImage(frmMDI.FAImage.Bitmap);

    finally
      FLastRect := FCaptureRect;
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);
end;

procedure TfrmMain.tbUserCaptureClick(Sender: TObject);
begin
  mnuUserCapture.Click;
end;

procedure TfrmMain.mnuUserCaptureClick(Sender: TObject);
var
  ShapeType: Integer;
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      if UseRect.Checked = True then
        ShapeType := CaptureEngine.stRect
      else if UseRoundRect.Checked = True then
        ShapeType := CaptureEngine.stRoundRect
      else if UseEllipse.Checked = True then
        ShapeType := CaptureEngine.stCircle
      else if UseTriangle.Checked = True then
        ShapeType := CaptureEngine.stTriangle
      else if UsePolygon.Checked = True then
        ShapeType := CaptureEngine.stPolygon
      else if UsePolygonLine.Checked = True then
        ShapeType := CaptureEngine.stPolyLine;

      if CaptureUser(ShapeType) = True then
      begin
        frmMDI := TfrmMDI.Create(Application);
        SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 1);

        frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
        frmMDI.FAImage.Bitmap.ResetAlpha;

        AutoSaveImage(frmMDI.FAImage.Bitmap);

        FLastRect := FCaptureRect;
      end
      else
        SendMessage(Handle, CM_MDICursor, 0, 0);

    finally
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);
end;

procedure TfrmMain.FormActivate(Sender: TObject);
var
  i: Integer;
  StrList: TStringList;
begin
  if FInitialize = False then
  begin
    // 프로그램이 처음 실행되었을 경우 실행됩니다.
    CheckForUpdate;

    StrList := TStringList.Create;
    try
      if not RegistryHotKey(StrList) then
        InfoMessage(StrList.Text);

      StrList.Clear;

      if mnuToolBar.Checked = False then
      begin
        mnuToolBar.Checked := True;
        mnuToolBar.Click;
      end;

      if mnuStatusBar.Checked = False then
      begin
        mnuStatusBar.Checked := True;
        mnuStatusBar.Click;
      end;

      if mnuPaintBox.Checked = False then
      begin
        mnuPaintBox.Checked := True;
        mnuPaintBox.Click;
      end;

      if mnuAutoScroll.Checked = True then
      begin
        mnuAutoScroll.Checked := False;
        mnuAutoScroll.Click;
      end;

      for i := 1 to ParamCount do
        StrList.Add(ParamStr(i));

      if StrList.Count > 0 then
        LoadImage(StrList.GetText);
    finally
      StrList.Free;
    end;

    FInitialize := True;
  end;
  // ******************************** //

end;

procedure TfrmMain.mnuCaptureActiveWindowClick(Sender: TObject);
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      if CaptureActiveWindow(False) = True then
      begin
        frmMDI := TfrmMDI.Create(Application);
        SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 4);

        frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
        frmMDI.FAImage.Bitmap.ResetAlpha;

        AutoSaveImage(frmMDI.FAImage.Bitmap);

        FLastRect := FCaptureRect;
      end
      else
        InfoMessage(errActiveWindow);

    finally
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);
end;

procedure TfrmMain.tbCaptureFullScreenClick(Sender: TObject);
begin
  mnuCaptureFullScreen.Click;
end;

procedure TfrmMain.ActiveCaptureBtnClick(Sender: TObject);
begin
  mnuCaptureActiveWindow.Click;
end;

procedure TfrmMain.tbCaptureLastRectClick(Sender: TObject);
begin
  mnuCaptureLastRect.Click;
end;

procedure TfrmMain.MDITabMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i: Integer;
begin
  for i := 0 to MDIChildCount - 1 do
    if MDIChildRen[i].Tag = MDITab.TabIndex then
    begin
      MDIChildRen[i].Show;
      Exit;
    end;

end;

procedure TfrmMain.TileMenuClick(Sender: TObject);
begin
  Tile;
end;

procedure TfrmMain.CascadeMenuClick(Sender: TObject);
begin
  Cascade;
end;

procedure TfrmMain.MinMenuClick(Sender: TObject);
var
  i: Integer;
begin
  for i := MDIChildCount - 1 downto 0 do
    MDIChildRen[i].WindowState := wsMinimized;
end;

procedure TfrmMain.MainWndProc(var Message: TMessage);
begin
  case Message.Msg of
    WM_CLOSE:
      if frmOption.chkTrayIconUse.Checked = True then
        if frmOption.chkTrayCloseHide.Checked = True then
        begin
          Application.Minimize;
          ShowWindow(Application.Handle, SW_HIDE);

          Hide;

          Exit;
        end;
  end;
  Self.WndProc(Message);
end;

procedure TfrmMain.MainCoolBarWndProc(var Message: TMessage);
begin
  case Message.Msg of
    WM_LBUTTONDOWN:
      // CoolBar 왼쪽에 Gripper를 이용하여 사용자가 드래그를 이용하여
      // 컨트롤을 움직이지 못 하도록 합니다.
      // ( Gripper를 없애려면 TCoolBar 코드를 수정하지 않는 이상은
      // 없애는게 불가능합니다.
      // 개같은.. 그라데이션 옵션 넣을 시간에 NoGripper 옵션조차 만들어 놓지
      // 않았습니다. )
      Exit;
  end;
  TXXCoolBar(MainCoolBar).WndProc(Message);
end;

procedure TfrmMain.MaxMenuClick(Sender: TObject);

var
  i: Integer;
begin
  for i := MDIChildCount - 1 downto 0 do
    MDIChildRen[i].WindowState := wsMaximized;
end;

procedure TfrmMain.NormalMenuClick(Sender: TObject);

var
  i: Integer;
begin
  for i := MDIChildCount - 1 downto 0 do
    MDIChildRen[i].WindowState := wsNormal;
end;

procedure TfrmMain.mnuNewImageClick(Sender: TObject);

const
  imgWidth = 300;
  imgHeight = 200;
begin
  with TfrmMDI.Create(Application) do
  begin
    SendMessage(Handle, CM_CaptureStart, 0, 0);
    try
      with FAImage.Bitmap do
      begin
        Width := imgWidth;
        Height := imgHeight;
        FillRect(0, 0, Width, Height, clWhite32);
      end;

    except
      InfoMessage('새 이미지를 만드는데 실패했습니다.');
      // ** TfrmMDI ** //
      Close;
      Exit;
    end;
  end;

  cboZoom.OnChange(nil);

end;

procedure TfrmMain.newimageBtnClick(Sender: TObject);
begin
  mnuNewImage.Click;
end;

procedure TfrmMain.httpgetDoneString(Sender: TObject; Result: String);

var
  CVer: String;
  MenuItem: TMenuItem;
begin
  // 결과값을 체크해서 업데이트가 있으면 알려줌
  // 현재 버전 값인 UpdateDate 와 게시물에서 파싱한 값을 비교한다.
  // 버전이 더 크면, 메시지창으로 알려준다.

  // 기존에 Ver. 은 문제가 있으므로 Ver2. 으로 비교합니다.
  // Ver.는 오픈 캡쳐 오래 된 버전에서 사용합니다.
  // 따라서 새 버전에서 Ver.를 그대로 사용 할 경우 오픈 캡쳐 오래 된 버전에서
  // 업데이트를 시도합니다. 그런데 해당 오래 된 버전에 경우 업데이트 체크 안 함
  // 기능이 없습니다. 따라서 사용자가 취소를 누르면 계속 해서 업데이트를 하라고
  // 실행할 때마다 뜹니다. 끄는 옵션도 없습니다.
  // 그래서 Ver2.를 사용합니다.
  CVer := Copy(Result, Pos('Ver2.', Result) + 5, 10);
  if StrToIntDef(CVer, 0) > UpdateDate then
  begin
    MenuItem := TMenuItem.Create(MainMenu);

    MenuItem.Caption := '새 버전 받기(&U) ';
    MenuItem.Name := 'mnuUpdate';

    MenuItem.OnClick := mnuUpdateItemClick;

    MainMenu.Items.Add(MenuItem);
    FXPMenu.ActivateMenuItem(MenuItem, False);
  end;

end;

procedure TfrmMain.mnuCaptureWindowClick(Sender: TObject);

var
  WindowName: string;
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      if CaptureWindow(WindowName) = True then
      begin
        frmMDI := TfrmMDI.Create(Application);
        SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 2);

        frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
        frmMDI.FAImage.Bitmap.ResetAlpha;

        AutoSaveImage(frmMDI.FAImage.Bitmap);

        if WindowName <> '' then
        begin
          MDITab.Tabs[frmMain.MDITab.TabIndex] := WindowName;
          ActiveMDIChild.Caption := WindowName;
          MDITab.Tabs[frmMain.MDITab.TabIndex] := frmMain.MDITab.Tabs
            [frmMain.MDITab.TabIndex] + '*';
          ActiveMDIChild.Caption := frmMain.ActiveMDIChild.Caption + '*';
        end;

        FLastRect := FCaptureRect;
      end
      else
        SendMessage(Handle, CM_MDICursor, 0, 0);

    finally
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);
end;

procedure TfrmMain.mnuCaptureControlClick(Sender: TObject);

var
  IsAsterisk, WindowName: string;
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      FScrollBitmap := TBitmap32.Create;
      FScrollBitmap.SetSize(0, 0);

      if CaptureControl(WindowName, frmMain.mnuAutoScroll.Checked,
        frmOption.chkInvalidate.Checked, frmOption.udScrollDelay.Position)
        = True then
      begin

        try
          frmMDI := TfrmMDI.Create(Application);

          // 스크롤 캡쳐와 관련하여 FScrollBitmap에 Width와 Heigh가 있으면
          // Bitmap에 Assign 하게 되는데 매우 큰 비트맵에 경우에는 Assign
          // 할 경우 속도가 매우 느릴 수 있으니 참고바랍니다.
          // 기존에는 TfrmMDI를 먼저 생성하고 FScrollBitmap이 frmMDI에 Bitmap에 포인터를
          // 가르키도록 했는데 이렇게 하면 TfrmMDI 가 생성되면서 다른 윈도우의 포커스를 뺏어버리는
          // 경우가 생깁니다.
          if (FScrollBitmap.Width = 0) and (FScrollBitmap.Height = 0) then
            frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap)
          else
            frmMDI.FAImage.Bitmap.Assign(FScrollBitmap);

          frmMDI.FAImage.Bitmap.ResetAlpha;
          SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 3);

          AutoSaveImage(frmMDI.FAImage.Bitmap);

        except
          InfoMessage(errOutRes);
        end;

        with frmOption do
          if (edtPath.Text <> '') and (edtFileName.Text <> '') and
            (chkAutoSave.Checked = True) then
            IsAsterisk := ''
          else
            IsAsterisk := '*';

        if WindowName <> '' then
        begin
          MDITab.Tabs[frmMain.MDITab.TabIndex] := WindowName;
          ActiveMDIChild.Caption := WindowName;
          MDITab.Tabs[frmMain.MDITab.TabIndex] := frmMain.MDITab.Tabs
            [frmMain.MDITab.TabIndex] + IsAsterisk;
          ActiveMDIChild.Caption := frmMain.ActiveMDIChild.Caption + IsAsterisk;
        end;

        FLastRect := FCaptureRect;
        // ** 캡쳐 시작 시 커서가 바뀌는데 캡쳐 후 커서를 원래대로.. ** //
      end;

    finally
      FScrollBitmap.Free;

      Free;
      FCapture := False;
    end;

  SendMessage(Handle, CM_MDICursor, 0, 0);
  cboZoom.OnChange(nil);
end;

procedure TfrmMain.mnuCaptureActiveWindowExClick(Sender: TObject);
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      if CaptureActiveWindow(True) = True then
      begin
        frmMDI := TfrmMDI.Create(Application);
        SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 4);

        frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
        frmMDI.FAImage.Bitmap.ResetAlpha;

        AutoSaveImage(frmMDI.FAImage.Bitmap);

        FLastRect := FCaptureRect;
      end
      else
        InfoMessage(errNoFrame);

    finally
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);

end;

procedure TfrmMain.mnuPaintBoxClick(Sender: TObject);
begin
  if coolbrPaintBox.Showing = True then
  begin
    coolbrPaintBox.Hide;
    mnuPaintBox.Checked := False;
  end
  else
  begin
    coolbrPaintBox.Show;
    mnuPaintBox.Checked := True;
  end;
end;

procedure TfrmMain.mnuPasteClick(Sender: TObject);

var
  ABitmap: TBitmap;
  P: TPoint;
  L, T, W, H: Single;
begin
  if MDIChildCount <> 0 then
    if TfrmMDI(ActiveMDIChild).IsDraw = False then
      with TfrmMDI(ActiveMDIChild) do
        try
          if FRBLayer <> nil then
            FlattenLayer(False, True);

          with CreateBitmapLayer do
          begin
            SaveUndoImage(FAImage.Bitmap);

            { TODO : 그림판에서 붙여넣기 시
              TBitmap32 로 붙여넣으면 크기가 제대로 않 나온다
              그래서 TBitmap 로 붙여넣고 그걸 다시 TBitmap32
              로 붙여놓는다 .. }
            ABitmap := TBitmap.Create;
            try
              ABitmap.Assign(ClipBoard);
              Bitmap.Assign(ABitmap);
            finally
              ABitmap.Free;
            end;

            with FAImage.GetViewportRect do
              P := FAImage.ControlToBitmap
                (Point((Right + Left) div 2, (Top + Bottom) div 2));

            W := Bitmap.Width / 2;
            H := Bitmap.Height / 2;
            L := Round(P.X - W);
            T := Round(P.Y - H);

            with FRBLayer do
              Location := FloatRect(L, T, L + Bitmap.Width, T + Bitmap.Height);
          end;
        except
          InfoMessage('지원되지 않는 클립보드 포맷입니다.', '에러');

          mnuUndo.OnClick(Sender);
          rBitmapList.ClearBitmaps;
          frmMain.mnuRedo.Enabled := False;
        end;

end;

procedure TfrmMain.mnuCopyClick(Sender: TObject);
begin
  if MDIChildCount <> 0 then
    if TfrmMDI(ActiveMDIChild).IsDraw = False then
      with TfrmMDI(ActiveMDIChild) do
        if FRBLayer <> nil then
          ClipBoard.Assign(FBitmapLayer.Bitmap)
        else
          ClipBoard.Assign(FAImage.Bitmap);

end;

procedure TfrmMain.btnPasteClick(Sender: TObject);
begin
  mnuPaste.Click;
end;

procedure TfrmMain.btnColorExchangeClick(Sender: TObject);

var
  TempColor: TColor;
begin
  TempColor := FPalettePen.Color;
  FPalettePen.Color := FPaletteBrush.Color;
  FPaletteBrush.Color := TempColor;
  UpdatePaintPanel;
end;

procedure TfrmMain.btnCopyClick(Sender: TObject);
begin
  mnuCopy.Click;
end;

procedure TfrmMain.mnuToolBarClick(Sender: TObject);
begin
  if mnuToolBar.Checked = True then
  begin
    tbCapture.Hide;
    cboZoom.Hide;
    tbCapture.Tag := 1;
    mnuToolBar.Checked := False;
    MainCoolBar.Height := 30;
  end
  else
  begin
    tbCapture.Show;
    cboZoom.Show;
    tbCapture.Tag := 0;
    mnuToolBar.Checked := True;
    MainCoolBar.Height := 57;
  end;

end;

procedure TfrmMain.mnuCaptureMenuClick(Sender: TObject);
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      if CaptureMenu = True then
      begin
        frmMDI := TfrmMDI.Create(Application);
        SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 9);

        frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
        frmMDI.FAImage.Bitmap.ResetAlpha;

        AutoSaveImage(frmMDI.FAImage.Bitmap);

        FLastRect := FCaptureRect;
      end
      else
        InfoMessage(errMenuCapture);

    finally
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);

end;

procedure TfrmMain.tbCaptureFixedRectClick(Sender: TObject);
begin
  mnuCaptureFixedRect.Click;
end;

procedure TfrmMain.mnuCaptureFixedRectClick(Sender: TObject);
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      if CaptureFixed(frmOption.udWidth.Position, frmOption.udHeight.Position)
        = True then
      begin
        frmMDI := TfrmMDI.Create(Application);
        SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 8);

        frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
        frmMDI.FAImage.Bitmap.ResetAlpha;

        AutoSaveImage(frmMDI.FAImage.Bitmap);

        FLastRect := FCaptureRect;
      end
      else
        SendMessage(Handle, CM_MDICursor, 0, 0);
    finally
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);

end;

procedure TfrmMain.tbCaptureColorClick(Sender: TObject);
begin
  mnuCaptureColor.Click;
end;

procedure TfrmMain.mnuHotKeyClick(Sender: TObject);

var
  StrList: TStringList;
begin
  with TfrmHotKey.Create(Application) do
    try
      ShowModal;

      StrList := TStringList.Create;
      try
        if RegistryHotKey(StrList) = False then
          InfoMessage(StrList.Text);
      finally
        StrList.Free;
      end;

    finally
      Free;
    end;
end;

procedure TfrmMain.mnuCutClick(Sender: TObject);
begin
  if MDIChildCount <> 0 then
    if TfrmMDI(ActiveMDIChild).IsDraw = False then
      with TfrmMDI(ActiveMDIChild) do
        if FRBLayer <> nil then
        begin
          ClipBoard.Assign(FBitmapLayer.Bitmap);
          FAImage.Layers.Clear;
          FRBLayer := nil;

          if FfrmAddText <> nil then
            FreeAndNil(FfrmAddText);

          UpdateMenu(Sender);

          FAImage.Cursor := ToolSel;
        end;

end;

procedure TfrmMain.popCopyClick(Sender: TObject);
begin
  mnuCopy.Click;
end;

procedure TfrmMain.popPasteClick(Sender: TObject);
begin
  mnuPaste.Click;
end;

procedure TfrmMain.mnuCloseClick(Sender: TObject);
begin
  if MDIChildCount <> 0 then
    ActiveMDIChild.Close;
end;

procedure TfrmMain.mnuUndoClick(Sender: TObject);

var
  ABitmap32: TBitmap32;
begin
  if MDIChildCount <> 0 then
    if TfrmMDI(ActiveMDIChild).IsDraw = False then
      with TfrmMDI(ActiveMDIChild) do
        try
          BeginCursor;

          if FRBLayer <> nil then
          begin
            FRBLayer.LayerOptions := LOB_NO_UPDATE;

            ABitmap32 := TBitmap32.Create;
            try
              ABitmap32.SetSize(FAImage.Bitmap.Width, FAImage.Bitmap.Height);
              FAImage.PaintTo(ABitmap32, ABitmap32.BoundsRect);
              rBitmapList.AddBitmap(ABitmap32);

              FRBLayer.ChildLayer := nil;
              FAImage.Layers.Clear;
              FRBLayer := nil;

              if FfrmAddText <> nil then
                FreeAndNil(FfrmAddText);

              pnlBitmapLayer.Visible := False;

              FAImage.Cursor := ToolSel;
            finally
              ABitmap32.Free;
            end;
          end
          else
            rBitmapList.AddBitmap(FAImage.Bitmap);

          FAImage.Bitmap.Assign(uBitmapList.Bitmaps[uBitmapList.GetCount - 1]);
          uBitmapList.DeleteBitmap(uBitmapList.GetCount - 1);

          FAImage.Repaint;

          // ** 비트맵리스트가 텅비었다면 .. ** //
          if uBitmapList.GetCount = 0 then
            mnuUndo.Enabled := False;

          EditingImage;

          mnuRedo.Enabled := True;

          UpdateMenu(Sender);
          cboZoom.OnChange(Sender);
        finally // ** with TfrmMDI(ActiveMDIChild) do try ** //
          EndCursor;
        end;

end;

procedure TfrmMain.mnuUpdateItemClick(Sender: TObject);
begin
  // 히스토리를 사용자들이 확인 후에 다운로드 받을 수 있도록 URL로 이동
  ShellExecute(Self.Handle, nil, PChar(UpdateURL), nil, nil,
    SW_SHOW);
  // 그리고 다운로드 받을 때 보통 기존 파일을 덮어씌우는
  // 경우가 많기 때문에 프로그램은 종료하도록 한다.
  mnuExitClick(nil);

end;

procedure TfrmMain.mnuRedoClick(Sender: TObject);

var
  ABitmap32: TBitmap32;
begin
  if MDIChildCount <> 0 then
    if TfrmMDI(ActiveMDIChild).IsDraw = False then
      with TfrmMDI(ActiveMDIChild) do
        try
          BeginCursor;

          if FRBLayer <> nil then
          begin
            FRBLayer.LayerOptions := LOB_NO_UPDATE;

            ABitmap32 := TBitmap32.Create;
            try
              ABitmap32.SetSize(FAImage.Bitmap.Width, FAImage.Bitmap.Height);
              FAImage.PaintTo(ABitmap32, ABitmap32.BoundsRect);
              uBitmapList.AddBitmap(ABitmap32);

              FRBLayer.ChildLayer := nil;
              FAImage.Layers.Clear;
              FRBLayer := nil;
            finally
              ABitmap32.Free;
            end;
          end
          else
            uBitmapList.AddBitmap(FAImage.Bitmap);

          FAImage.Bitmap.Assign(rBitmapList.Bitmaps[rBitmapList.GetCount - 1]);
          rBitmapList.DeleteBitmap(rBitmapList.GetCount - 1);

          FAImage.Repaint;

          // ** 비트맵리스트가 텅비었다면 .. ** //
          if rBitmapList.GetCount = 0 then
            mnuRedo.Enabled := False;

          EditingImage;

          mnuUndo.Enabled := True;

          UpdateMenu(Sender);
          cboZoom.OnChange(Sender);
        finally
          EndCursor;
        end;

end;

procedure TfrmMain.popUndoClick(Sender: TObject);
begin
  mnuUndo.Click;
end;

procedure TfrmMain.popRedoClick(Sender: TObject);
begin
  mnuRedo.Click;
end;

procedure TfrmMain.popupMnuPopup(Sender: TObject);
begin

  popUndo.Enabled := mnuUndo.Enabled;
  popRedo.Enabled := mnuRedo.Enabled;
  popCopy.Enabled := mnuCopy.Enabled;
  popPaste.Enabled := mnuPaste.Enabled;
  popSave.Enabled := mnuSaveFile.Enabled;

end;

procedure TfrmMain.popupTrayPopup(Sender: TObject);
begin
  CopyMenuItemsState(pmnuCapture, MainMenu.Items[2]);
end;

procedure TfrmMain.mnuCaptureCursorClick(Sender: TObject);
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      CaptureOnlyCursor;

      frmMDI := TfrmMDI.Create(Application);
      SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 10);

      frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
      frmMDI.FAImage.Bitmap.ResetAlpha;

      AutoSaveImage(frmMDI.FAImage.Bitmap);

    finally
      // LastRect := FCaptureRect;
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);

end;

procedure TfrmMain.mnuScaleClick(Sender: TObject);

var
  SrcBitmap32: TBitmap32;
  DstBitmap32: TBitmap32;
  DstRect: TRect;
begin
  if MDIChildCount > 0 then
    with TfrmMDI(frmMain.ActiveMDIChild).FAImage do
      try
        SrcBitmap32 := TBitmap32.Create;
        DstBitmap32 := TBitmap32.Create;
        BeginUpdate;
        with TfrmResizeImage.Create(Application) do
          try
            udWidth.Tag := Bitmap.Width;
            udHeight.Tag := Bitmap.Height;

            case ShowModal of
              mrOk:
                begin
                  BeginCursor;
                  try
                    TfrmMDI(frmMain.ActiveMDIChild).FlattenLayer(True, True);

                    DstRect := Rect(0, 0, udWidth.Position, udHeight.Position);
                    DstBitmap32.SetSize(DstRect.Right, DstRect.Bottom);

                    SrcBitmap32.Assign(Bitmap);
                    if chkLinear.Checked then
                    begin
                      TKernelResampler.Create(SrcBitmap32);
                      TKernelResampler(SrcBitmap32.Resampler).Kernel :=
                        TLinearKernel.Create
                    end
                    else
                      TNearestResampler.Create(SrcBitmap32);

                    SrcBitmap32.DrawTo(DstBitmap32, DstRect);
                    Bitmap.Assign(DstBitmap32);
                  finally
                    EndCursor;
                  end;

                end;
              mrCancel:
                ;
            end;

          finally
            SrcBitmap32.Free;
            DstBitmap32.Free;
            EndUpdate;
            Free;
            cboZoom.OnChange(Sender);
          end;

      except
        InfoMessage('이미지의 크기를 변경하는데 실패했습니다.' + #10 + '' + #10 +
            '실패 원인은 다음과 같습니다.' + #10 + '' + #10 + '1.이미지의 크기가 너무 큽니다.' + #10 +
            '2.윈도우에서 사용할 수 있는 리소스가 부족합니다.', '실패');
        mnuUndo.OnClick(Sender);
      end;

end;

procedure TfrmMain.tbCaptureWindowResizeClick(Sender: TObject);
begin
  mnuCaptureWindowResize.Click;
end;

procedure TfrmMain.btnCutClick(Sender: TObject);
begin
  mnuCut.Click;
end;

procedure TfrmMain.mnuGrayScaleClick(Sender: TObject);
begin
  NormalAddEffect(ModeGrayScale);
end;

procedure TfrmMain.mnuInvertClick(Sender: TObject);
begin
  NormalAddEffect(ModeInvert);
end;

procedure TfrmMain.btnUndoClick(Sender: TObject);
begin
  mnuUndo.Click;
end;

procedure TfrmMain.btnRedoClick(Sender: TObject);
begin
  mnuRedo.Click;
end;

procedure TfrmMain.MDITabMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
  begin
    mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
    mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
  end;
end;

procedure TfrmMain.mnuSetupClick(Sender: TObject);
begin
  // 사용자가 확인 버튼을 누르지 않고 취소할 경우에 실행됩니다.

  // 기존에 환경설정창이 켜져있으면 다시 켜지 않는다.
  if frmOption.Showing then Exit;

  // 폼 생성시 Auto-Create 에서 환경설정 로드 함
  frmOption.ShowModal;

  // 이전 버전에서 이 부분의 코드가 주석처리되어 있었는데 다시 주석을 해제합니다.
  // 폼을 ShowModal후 다시 Create를 하지 않게되면 이후에 이 폼에 접근 시 잘 못 된 값을
  // 가져오게 되기 때문입니다.
  frmOption.Free;
  // Create 시 TfrmOption 폼에서 내부적으로 LoadINI를 수행합니다.
  frmOption := TfrmOption.Create(Application);
end;

procedure TfrmMain.cboZoomChange(Sender: TObject);
begin
  if MDIChildCount > 0 then
    with TfrmMDI(ActiveMDIChild) do
    begin
      if FAImage.Bitmap.Empty = False then
      begin
        FAImage.Scale := StrToInt
          (Copy(cboZoom.Items[cboZoom.ItemIndex], 0, Length
              (cboZoom.Items[cboZoom.ItemIndex]) - 1)) / 100;

        StatusBar.Panels[0].Text := Format
          ('가로 : %d x 세로 : %d', [FAImage.Bitmap.Width, FAImage.Bitmap.Height]);
        StatusBar.Panels[2].Text := cboZoom.Text;
      end;
      if ToolSel = tsEraser then UpdatePaintPanel;
    end;

end;

procedure TfrmMain.menuAboutClick(Sender: TObject);
begin
  with TfrmAbout.Create(Application) do
    try
      ShowModal;
    finally
      Free;
    end;

end;

procedure TfrmMain.mnuCaptureWallpaperClick(Sender: TObject);
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      if CaptureWallpaper = True then
      begin
        frmMDI := TfrmMDI.Create(Application);
        SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 11);

        frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);

        AutoSaveImage(frmMDI.FAImage.Bitmap);

      end
      else
        InfoMessage(errWallpaperCapture);

    finally
      // LastRect := FCaptureRect;
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);
end;

procedure TfrmMain.NormalAddEffect(NormalEffectMode: Byte);

var
  ABitmap: TBitmap;
begin
  if MDIChildCount <> 0 then
    with TfrmMDI(ActiveMDIChild) do
      try
        BeginCursor;
        ABitmap := TBitmap.Create;
        try
          if FRBLayer = nil then
          begin
            SaveUndoImage(FAImage.Bitmap);
            ABitmap.Assign(FAImage.Bitmap);
          end
          else
          begin
            FlattenLayer(True, False);
            ABitmap.Assign(FBitmapLayer.Bitmap);
          end;

          case NormalEffectMode of
            ModeInvert:
              Invert(ABitmap);
            ModeGrayScale:
              GrayScale(ABitmap);
          end;

          if FRBLayer = nil then
            FAImage.Bitmap.Assign(ABitmap)
          else
            FBitmapLayer.Bitmap.Assign(ABitmap);

        finally
          ABitmap.Free;
          EndCursor;
        end;
      except
        on E: Exception do
          InfoMessage(E.Message);
      end;
end;

procedure TfrmMain.AddEffect(EffectMode: Byte);
begin
  if MDIChildCount <> 0 then
    with TfrmCommonDlg.Create(Application) do
      try
        if Boolean(SendMessage(Handle, CM_Effect, 0, EffectMode)) = True then
          ShowModal;
      finally
        Free;
      end;

end;

procedure TfrmMain.mnuColorNoiseClick(Sender: TObject);
begin
  AddEffect(ModeColorNoise);
end;

procedure TfrmMain.mnuMonoNoiseClick(Sender: TObject);
begin
  AddEffect(ModeMonoNoise);
end;

procedure TfrmMain.mnuMosaicClick(Sender: TObject);
begin
  AddEffect(ModeMosaic);
end;

procedure TfrmMain.mnuBrightnessClick(Sender: TObject);
begin
  AddEffect(ModeBrightness);
end;

procedure TfrmMain.btnPenClick(Sender: TObject);
begin
  ChangePaintTool(tsPen);
end;

procedure TfrmMain.btnDragClick(Sender: TObject);
begin
  ChangePaintTool(tsDrag);
end;

procedure TfrmMain.btnAirBrushClick(Sender: TObject);
begin
  ChangePaintTool(tsAirBrush);
end;

procedure TfrmMain.btnSelColorClick(Sender: TObject);
begin
  ChangePaintTool(tsSelColor);
end;

procedure TfrmMain.btnFloodFillClick(Sender: TObject);
begin
  ChangePaintTool(tsFloodFill);
end;

procedure TfrmMain.btnEraserClick(Sender: TObject);
begin
  if btnSmall.Down = True then EraserSize := esSmall;
  if btnNormal.Down = True then EraserSize := esNormal;
  if btnBig.Down = True then EraserSize := esBig;
  ChangePaintTool(tsEraser);
end;

procedure TfrmMain.btnTextClick(Sender: TObject);
begin
  ChangePaintTool(tsText);
end;

procedure TfrmMain.btnArrowClick(Sender: TObject);
begin
  ChangePaintTool(tsArrow);
end;

procedure TfrmMain.edtPenSizeChange(Sender: TObject);
begin

  case udPenSize.Position of
    1:
      btnPenSize1.Down := True;
    2:
      btnPenSize2.Down := True;
    3:
      btnPenSize3.Down := True;
  end;

end;

procedure TfrmMain.btnPenSize1Click(Sender: TObject);
begin
  edtPenSize.Text := '1';
end;

procedure TfrmMain.btnPenSize2Click(Sender: TObject);
begin
  edtPenSize.Text := '2';
end;

procedure TfrmMain.btnPenSize3Click(Sender: TObject);
begin
  edtPenSize.Text := '3';
end;

procedure TfrmMain.btnLineClick(Sender: TObject);
begin
  ChangePaintTool(tsLine);
end;

procedure TfrmMain.btnSmallClick(Sender: TObject);
begin
  EraserSize := esSmall;
  UpdatePaintPanel;
end;

procedure TfrmMain.btnNormalClick(Sender: TObject);
begin
  EraserSize := esNormal;
  UpdatePaintPanel;
end;

procedure TfrmMain.btnBigClick(Sender: TObject);
begin
  EraserSize := esBig;
  UpdatePaintPanel;
end;

procedure TfrmMain.btnRectangleClick(Sender: TObject);
begin
  ChangePaintTool(tsRect);
end;

procedure TfrmMain.btnCircleClick(Sender: TObject);
begin
  ChangePaintTool(tsEllipse);
end;

procedure TfrmMain.btnRoundRectClick(Sender: TObject);
begin
  ChangePaintTool(tsRoundRect);
end;

procedure TfrmMain.tbInvertClick(Sender: TObject);
begin
  mnuInvert.Click;
end;

procedure TfrmMain.tbGrayScaleClick(Sender: TObject);
begin
  mnuGrayScale.Click;
end;

procedure TfrmMain.tbBrightnessClick(Sender: TObject);
begin
  mnuBrightness.Click;
end;

procedure TfrmMain.TrayIconClick(Sender: TObject);
begin
  // 폼이 최소화 되어 있는지 체크하고 최소화 되어 있다면 폼이 보이도록 합니다.
  // 여기서 폼에 핸들을 주면 안되고 애플리케이션의 핸들을 주어야 합니다.
  if IsIconic(Application.Handle) = True then
    Application.Restore;

  Self.Show;
  // 활성화시킵니다.
  SetForegroundWindow(Self.Handle);
end;

procedure TfrmMain.mnuAutoScrollClick(Sender: TObject);
begin
  mnuAutoScroll.Checked := not mnuAutoScroll.Checked;
  mnuCaptureControl.Default := mnuAutoScroll.Checked;
end;

procedure TfrmMain.popCloseClick(Sender: TObject);
begin
  mnuClose.Click;
end;

procedure TfrmMain.mnuRotate90Click(Sender: TObject);
begin
  ImageRotate(90);
end;

procedure TfrmMain.mnuRotate180Click(Sender: TObject);
begin
  ImageRotate(180);
end;

procedure TfrmMain.mnuRotate270Click(Sender: TObject);
begin
  ImageRotate(270);
end;

procedure TfrmMain.FormResize(Sender: TObject);

const
  Edge = 20;
begin
  MDITab.Width := Width - Edge;
  coolbrPaintBox.Refresh;
end;

procedure TfrmMain.btnSelectClick(Sender: TObject);
begin
  ChangePaintTool(tsSelect);
end;

procedure TfrmMain.btnZoomClick(Sender: TObject);
begin
  ChangePaintTool(tsZoom);
end;

procedure TfrmMain.mnuCanvasResizeClick(Sender: TObject);

var
  ABitmap32: TBitmap32;
begin
  if MDIChildCount > 0 then
    with TfrmResizeCanvas.Create(Application) do
      try
        with TfrmMDI(frmMain.ActiveMDIChild) do
        begin
          udWidth.Position := FAImage.Bitmap.Width;
          udHeight.Position := FAImage.Bitmap.Height;
        end;
        {
          with TfrmMDI(frmMain.ActiveMDIChild) do begin....
          두 개가 중복되는 이유는 ShowModal 하면 MDI.ShowMdal
          이 되기 때문에..
          }
        case ShowModal of
          mrOk:
            with TfrmMDI(frmMain.ActiveMDIChild) do
              try
                BeginCursor;
                FlattenLayer(True, True);
                ABitmap32 := TBitmap32.Create;
                try
                  ABitmap32.Assign(FAImage.Bitmap);
                  FAImage.Bitmap.SetSize(udWidth.Position, udHeight.Position);
                  FAImage.Bitmap.FillRect
                    (0, 0, udWidth.Position, udHeight.Position, clWhite32);
                  FAImage.Bitmap.Draw(0, 0, ABitmap32);
                  FAImage.Repaint;
                finally
                  ABitmap32.Free;
                  EndCursor;
                end; // try ~ finally
                cboZoom.OnChange(Sender);
              except
                InfoMessage('캔버스의 크기를 재설정하는데 실패했습니다.', '실패');
              end; // try ~ except
          mrCancel:
            ;
        end;

      finally
        Free;
      end;

end;

procedure TfrmMain.mnuDeleteClick(Sender: TObject);
begin
  if MDIChildCount <> 0 then
    if TfrmMDI(ActiveMDIChild).IsDraw = False then
      with TfrmMDI(ActiveMDIChild) do
        if FRBLayer <> nil then
        begin

          // ** 레이어를 삭제 후 뒷 배경도 삭제해야 된다면 ** //
          if FBitmapLayer.Tag = Layer_DeleteRgn then
            with FAImage.Bitmap.Canvas do
            begin
              FlattenLayer(True, False);
              Brush.Style := bsSolid;
              Brush.Color := frmMain.FPaletteBrush.Color;
              with FRBLayer.Location do
                FillRect(Rect(Round(Left), Round(Top), Round(Right), Round
                      (Bottom)));
            end;

          FAImage.Layers.Clear;
          FRBLayer := nil;

          if FfrmAddText <> nil then
            FreeAndNil(FfrmAddText);

          UpdateMenu(Sender);
          FAImage.Cursor := ToolSel;
        end;

end;

procedure TfrmMain.mnuCropClick(Sender: TObject);

var
  ABitmap32: TBitmap32;
begin ;
  if MDIChildCount <> 0 then
    if TfrmMDI(ActiveMDIChild).IsDraw = False then
      with TfrmMDI(ActiveMDIChild) do
        if FRBLayer <> nil then
        begin
          FCapture := True;
          try
            // ** ABitmap32 = BitmapLayer.Bitmap
            // ABitmap32 와 BitmapLayer.Bitmap 이
            // 가리키는 곳이 같다 ** //
            ABitmap32 := FBitmapLayer.Bitmap;
            // ** frmMDI OnActive이벤트가 발생하면
            // 이미지 배율적용이 안된다.. ** //
            with TfrmMDI.Create(Application) do
            begin
              SendMessage(Handle, CM_CaptureStart, 0, 0);

              with FAImage.Bitmap do
              begin
                Assign(ABitmap32);
                DrawMode := dmOpaque;
                MasterAlpha := 255;
              end;
            end;

          finally
            FCapture := False;
          end;

          cboZoom.OnChange(nil);
          UpdateMenu(Sender);
        end;

end;

procedure TfrmMain.mnuSaturationClick(Sender: TObject);
begin
  AddEffect(ModeSaturation);
end;

procedure TfrmMain.gbLayerAlphaChange(Sender: TObject);
begin
  if MDIChildCount > 0 then
    with TfrmMDI(ActiveMDIChild) do
      if FRBLayer <> nil then
      begin
        FRBLayer.LayerOptions :=
          LOB_VISIBLE or LOB_MOUSE_EVENTS or LOB_NO_UPDATE;
        FBitmapLayer.Bitmap.MasterAlpha := Round
          ((255 / 100) * gbLayerAlpha.Position);
        lblLayerAlpha.Caption := '투명도 : ' + IntToStr(gbLayerAlpha.Position)
          + '%';
      end;
end;

procedure TfrmMain.mnuHorzFlipClick(Sender: TObject);
begin
  ImageFlip(True);
end;

procedure TfrmMain.mnuVertFlipClick(Sender: TObject);
begin
  ImageFlip(False);
end;

procedure TfrmMain.mnuCaptureColorClick(Sender: TObject);

var
  AColor: TColor;
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, False, False, chkCaptureMinimized.Checked,
          udDelay.Position, False, edtWavPath.Text);

      if CaptureColor(AColor) = True then
        with TfrmColorConvert.Create(Application) do
          try
            shpPrevColor.Brush.Color := AColor;

            ShowModal;
          finally
            Free;
          end;

      SendMessage(Handle, CM_MDICursor, 0, 0);

    finally
      Free;
      FCapture := False;
    end;

end;

procedure TfrmMain.mnuSelectAllClick(Sender: TObject);
begin
  if MDIChildCount <> 0 then
    if TfrmMDI(ActiveMDIChild).IsDraw = False then
      with TfrmMDI(ActiveMDIChild) do
      begin

        FAImage.BeginUpdate;
        try
          if FRBLayer <> nil then
            FlattenLayer(True, True);

          with CreateBitmapLayer do
          begin
            Bitmap.Assign(FAImage.Bitmap);
            // ** Assign 했으니 설정을 다시 한다 ** //
            Bitmap.DrawMode := dmBlend;
            Bitmap.MasterAlpha := Round((255 / 100) * gbLayerAlpha.Position);

            with FRBLayer do
              Location := FloatRect(0, 0, Bitmap.Width, Bitmap.Height);

            // ** 이 후 마우스로 드래그 시 영역 삭제 ** //
            Tag := Layer_DeleteRgn;

          end;

        finally
          FAImage.EndUpdate;
          FAImage.Repaint;
        end;

      end; // with TfrmMDI(ActiveMDIChild) do begin

end;

procedure TfrmMain.mnuCaptureIconClick(Sender: TObject);
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, False, False, chkCaptureMinimized.Checked,
          udDelay.Position, False, edtWavPath.Text);

      if CaptureIcon = True then
      begin
        frmMDI := TfrmMDI.Create(Application);
        SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 7);

        frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
        frmMDI.FAImage.Bitmap.ResetAlpha;

        AutoSaveImage(frmMDI.FAImage.Bitmap);

      end
      else
        SendMessage(Handle, CM_MDICursor, 0, 0);

    finally
      // LastRect := FCaptureRect;
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);
end;

procedure TfrmMain.mnuCaptureWindowResizeClick(Sender: TObject);
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      if CaptureExtend = True then
      begin
        frmMDI := TfrmMDI.Create(Application);
        SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 2);

        frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
        frmMDI.FAImage.Bitmap.ResetAlpha;

        AutoSaveImage(frmMDI.FAImage.Bitmap);

        FLastRect := FCaptureRect;
      end
      else
        SendMessage(Handle, CM_MDICursor, 0, 0);

    finally
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);
end;

procedure TfrmMain.mnuAnyAngleClick(Sender: TObject);
begin
  if MDIChildCount <> 0 then
    with TfrmAnyAngle.Create(Application) do
      try
        ShowModal;
      finally
        Free;
      end;

end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);

var
  i: Integer;
begin
  for i := 0 to 14 do
    UnRegisterHotkey(Handle, i);

  FXPMenu.Free;
  FHttpget.Free;

  Screen.OnActiveFormChange := nil;

  try
    SaveINI(Self, True, 'MainWindow', INIPath);

    SaveCheckMenuItem(mnuAutoScroll, 'MainMenuScroll', INIPath);
    SaveCheckMenuItems(mnuUserOption, 'MainMenuCapture', INIPath);
    SaveCheckMenuItems(mnuShow, 'MainMenuControlShow', INIPath);
  except
    InfoMessage(errINIFileSave);
  end;
end;

procedure TfrmMain.gbShapeAlphaChange(Sender: TObject);
begin
  lblShapeAlpha.Caption := '투명도 : ' + IntToStr(gbShapeAlpha.Position) + '%';
end;

procedure TfrmMain.menuHelpClick(Sender: TObject);

const
  URL: String = 'http://simples.kr/bbs/board.php?bo_table=11_1&wr_id=77';
begin
  // 홈페이지로 이동
  ShellExecute(Self.Handle, nil, PChar(URL), nil, nil, SW_SHOW);
end;

procedure TfrmMain.mnuCaptureWebImagesClick(Sender: TObject);
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try
      CaptureWebSiteImages;
    finally
      Free;
      FCapture := False;
    end;

end;

procedure TfrmMain.mnuAllCloseClick(Sender: TObject);

var
  i: Integer;
  FormList: TList;
begin
  FormList := TList.Create;
  try
    for i := 0 to MDIChildCount - 1 do
      FormList.Add(Pointer(MDIChildRen[i]));

    for i := 0 to FormList.Count - 1 do
      TForm(FormList[i]).Close;
  finally
    FormList.Free;
  end;
end;

procedure TfrmMain.mnuCaptureObjectClick(Sender: TObject);

var
  WindowName: string;
begin
  FCapture := True;

  with TCaptureEngine.Create(nil) do
    try

      with frmOption do
        CaptureSetup(True, chkCaptureMouse.Checked,
          chkCaptureClipBoard.Checked, chkCaptureMinimized.Checked,
          udDelay.Position, chkActive.Checked, edtWavPath.Text);

      if CaptureObject(WindowName) = True then
      begin
        frmMDI := TfrmMDI.Create(Application);
        SendMessage(frmMDI.Handle, CM_CaptureStart, 0, 12);

        frmMDI.FAImage.Bitmap.Assign(FCaptureBitmap);
        frmMDI.FAImage.Bitmap.ResetAlpha;

        AutoSaveImage(frmMDI.FAImage.Bitmap);

        if WindowName <> '' then
        begin
          MDITab.Tabs[frmMain.MDITab.TabIndex] := WindowName;
          ActiveMDIChild.Caption := WindowName;
          MDITab.Tabs[frmMain.MDITab.TabIndex] := frmMain.MDITab.Tabs
            [frmMain.MDITab.TabIndex] + '*';
          ActiveMDIChild.Caption := frmMain.ActiveMDIChild.Caption + '*';
        end;

        FLastRect := FCaptureRect;
      end
      else
        SendMessage(Handle, CM_MDICursor, 0, 0);

    finally
      Free;
      FCapture := False;
    end;

  cboZoom.OnChange(nil);

end;

procedure TfrmMain.N13Click(Sender: TObject);
begin
  menuAboutClick(Sender);
end;

end.
