﻿unit uResizeImage;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ufrmInherited, GR32_RangeBars;

type
  TfrmResizeImage = class(TfrmNormal)
    gbxResizeImage: TGroupBox;
    lblWidth: TLabel;
    lblHeight: TLabel;
    edtWidth: TEdit;
    edtHeight: TEdit;
    udWidth: TUpDown;
    udHeight: TUpDown;
    lblZoom: TLabel;
    edtZoom: TEdit;
    udZoom: TUpDown;
    btnOK: TButton;
    btnCanel: TButton;
    Label3: TLabel;
    chkLinear: TCheckBox;
    sbValue: TScrollBar;
    procedure sbValueChange(Sender: TObject);
    procedure edtZoomChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure udWidthChanging(Sender: TObject; var AllowChange: Boolean);
    procedure udHeightChanging(Sender: TObject; var AllowChange: Boolean);
    procedure edtZoomKeyPress(Sender: TObject; var Key: Char);
    procedure edtWidthKeyPress(Sender: TObject; var Key: Char);
    procedure edtHeightKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmResizeImage: TfrmResizeImage;

implementation

uses uMain, uMDI, Math;

{$R *.dfm}

procedure TfrmResizeImage.sbValueChange(Sender: TObject);
begin
  if sbValue.Position < 100 then
  begin
    lblZoom.Caption := '축소 :';
    udZoom.Position := sbValue.Position;
    udWidth.Position := Max(1, Round(udWidth.Tag * sbValue.Position / 100));
    udHeight.Position := Max(1, Round(udHeight.Tag * sbValue.Position / 100));
  end
  else
  begin
    lblZoom.Caption := '확대 :';
    udZoom.Position := sbValue.Position;
    udWidth.Position := Max(1, Round(udWidth.Tag * sbValue.Position / 100));
    udHeight.Position := Max(1, Round(udHeight.Tag * sbValue.Position / 100));
  end;

end;

procedure TfrmResizeImage.edtZoomChange(Sender: TObject);
begin
  sbValue.Position := udZoom.Position;
end;

procedure TfrmResizeImage.FormActivate(Sender: TObject);
begin
  sbValueChange(Sender);
end;

procedure TfrmResizeImage.udWidthChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  btnOK.Enabled := (udWidth.Position < 4500) and (udHeight.Position < 4500);
end;

procedure TfrmResizeImage.udHeightChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  btnOK.Enabled := (udWidth.Position < 4500) and (udHeight.Position < 4500);
end;

procedure TfrmResizeImage.edtZoomKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = #13 then
    Key := #0;
end;

procedure TfrmResizeImage.edtWidthKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    Key := #0;
end;

procedure TfrmResizeImage.edtHeightKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    Key := #0;
end;

procedure TfrmResizeImage.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
    ModalResult := mrOK;
end;

procedure TfrmResizeImage.FormCreate(Sender: TObject);
begin
  udZoom.Position := 100;
end;

end.
