﻿unit uSaveCursor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, ImgList, ufrmInherited;

type
  TfrmSaveCursor = class(TfrmNormal)
    Label1: TLabel;
    edt_xHotSpot: TEdit;
    ud_xHotSpot: TUpDown;
    Label2: TLabel;
    Label3: TLabel;
    edt_yHotSpot: TEdit;
    ud_yHotSpot: TUpDown;
    ImgCursor: TImage;
    Label4: TLabel;
    Label5: TLabel;
    Shape1: TShape;
    Label6: TLabel;
    Button1: TButton;
    Button2: TButton;
    lblViewHotSpot: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure edt_xHotSpotChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure edt_yHotSpotChange(Sender: TObject);
    procedure ImgCursorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    OldPt: TPoint;
    First: Boolean;
    procedure ChangePixel;
  public
    { Public declarations }
  end;

var
  frmSaveCursor: TfrmSaveCursor;
  FHotSpot: TPoint;

implementation

{$R *.dfm}

procedure TfrmSaveCursor.ChangePixel;
begin
  if First then
    First := False
  else
    SetPixel(ImgCursor.Picture.Bitmap.Canvas.Handle, OldPt.X, OldPt.Y, RGB(0, 0,
      0));

  SetPixel(ImgCursor.Picture.Bitmap.Canvas.Handle,
    ud_xHotSpot.Position, ud_yHotSpot.Position, RGB(0, 0, 0));

  ImgCursor.Refresh;

  OldPt := Point(ud_xHotSpot.Position, ud_yHotSpot.Position);
  lblViewHotSpot.Caption := '설정 된 핫스팟: ' + 'X 좌표 :' +
    IntToStr(ud_xHotSpot.Position)
    + '    ' + 'Y 좌표:' + IntToStr(ud_yHotSpot.Position);
end;

procedure TfrmSaveCursor.Button1Click(Sender: TObject);
begin
  FHotSpot := Point(ud_xHotSpot.Position, ud_yHotSpot.Position);
end;

procedure TfrmSaveCursor.edt_xHotSpotChange(Sender: TObject);
begin
  ChangePixel;
end;

procedure TfrmSaveCursor.FormCreate(Sender: TObject);
begin
  ImgCursor.Canvas.Pen.Mode := pmNotXor;
  OldPt := Point(ud_xHotSpot.Position, ud_yHotSpot.Position);
  First := True;

  ImgCursor.Cursor := 4;
end;

procedure TfrmSaveCursor.edt_yHotSpotChange(Sender: TObject);
begin
  ChangePixel;
end;

procedure TfrmSaveCursor.ImgCursorMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ud_xHotSpot.Position := X div 2;
  ud_yHotSpot.Position := Y div 2;

  ChangePixel;
end;

end.
