// CodeGear C++ Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Bufstream.pas' rev: 11.00

#ifndef BufstreamHPP
#define BufstreamHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Streams.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Monitor.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Bufstream
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TBufferedStream;
class PASCALIMPLEMENTATION TBufferedStream : public Streams::TFilterStream 
{
	typedef Streams::TFilterStream inherited;
	
private:
	bool NextNoDataExcept;
	
protected:
	Sysutils::TByteArray *InBuffer;
	int InBufPos;
	int InBufSize;
	int InBufMax;
	Sysutils::TByteArray *OutBuffer;
	int OutBufPos;
	int OutBufSize;
	
public:
	__fastcall TBufferedStream(int InputBufSize, int OutputBufSize, Streams::TBaseStream* NextStream);
	__fastcall virtual ~TBufferedStream(void);
	virtual int __fastcall Write(void *Buf, int Count);
	virtual int __fastcall Read(void *Buf, int Count);
	virtual void __fastcall Flush(void);
	virtual int __fastcall Available(void);
	__property bool NoDataExcept = {read=fNoDataExcept, write=fNoDataExcept, nodefault};
};


class DELPHICLASS EStreamCreate;
class PASCALIMPLEMENTATION EStreamCreate : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EStreamCreate(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EStreamCreate(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EStreamCreate(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EStreamCreate(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EStreamCreate(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EStreamCreate(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EStreamCreate(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EStreamCreate(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EStreamCreate(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::ResourceString _rsInvalidBufferSize;
#define Bufstream_rsInvalidBufferSize System::LoadResourceString(&Bufstream::_rsInvalidBufferSize)
extern PACKAGE int DefaultBufferSize;
static const Shortint DefaultBuffer = -1;
static const Shortint fmRead = 0x0;
static const Shortint fmWrite = 0x1;
extern PACKAGE TBufferedStream* __fastcall OpenBufferedFile(AnsiString Name, int Mode);

}	/* namespace Bufstream */
using namespace Bufstream;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Bufstream
