// CodeGear C++ Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Linarbitmap.pas' rev: 11.00

#ifndef LinarbitmapHPP
#define LinarbitmapHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Streams.hpp>	// Pascal unit
#include <Delphistream.hpp>	// Pascal unit
#include <Memutils.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Monitor.hpp>	// Pascal unit
#include <Mathutils.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Linarbitmap
{
//-- type declarations -------------------------------------------------------
#pragma pack(push,1)
struct RGBRec
{
	
public:
	Byte B;
	Byte G;
	Byte R;
} ;
#pragma pack(pop)

typedef RGBRec *PRGBRec;

typedef RGBRec TRGBArray[1];

typedef TRGBArray *PRGBArray;

typedef RGBRec TPalette[256];

typedef TPalette *PPalette;

typedef tagPALETTEENTRY TPalEntries[256];

class DELPHICLASS TLinearBitmap;
class DELPHICLASS TBitmapLoader;
class PASCALIMPLEMENTATION TLinearBitmap : public Memutils::TAssignObject 
{
	typedef Memutils::TAssignObject inherited;
	
protected:
	int fWidth;
	int fHeight;
	Graphics::TPixelFormat fPixelFormat;
	int fBytesPerLine;
	int fPixelSize;
	int fSize;
	bool fPresent;
	void * __fastcall GetScanLine(int Y);
	void * __fastcall GetPixel(int X, int Y);
	Graphics::TColor __fastcall GetPixelColor(int X, int Y);
	void __fastcall SetPixelColor(int X, int Y, Graphics::TColor Color);
	void __fastcall SetPixelFormat(Graphics::TPixelFormat PixFormat);
	
public:
	Sysutils::TByteArray *Map;
	TPalette *Palette;
	__property int Width = {read=fWidth, nodefault};
	__property int Height = {read=fHeight, nodefault};
	__property int BytesPerLine = {read=fBytesPerLine, nodefault};
	__property Graphics::TPixelFormat PixelFormat = {read=fPixelFormat, write=SetPixelFormat, nodefault};
	__property int PixelSize = {read=fPixelSize, nodefault};
	__property void * ScanLine[int Y] = {read=GetScanLine};
	__property void * Pixel[int X][int Y] = {read=GetPixel/*, default*/};
	__property Graphics::TColor PixelColor[int X][int Y] = {read=GetPixelColor, write=SetPixelColor};
	__property int Size = {read=fSize, nodefault};
	__property bool Present = {read=fPresent, nodefault};
	__fastcall TLinearBitmap(void)/* overload */;
	__fastcall TLinearBitmap(int Width, int Height, Graphics::TPixelFormat PixFormat)/* overload */;
	__fastcall TLinearBitmap(TLinearBitmap* Other)/* overload */;
	__fastcall virtual ~TLinearBitmap(void);
	void __fastcall New(int Width, int Height, Graphics::TPixelFormat PixFormat);
	virtual void __fastcall Dispose(void);
	void __fastcall Clear(Byte Value = (Byte)(0x0));
	void __fastcall ClearColor(Graphics::TColor Color);
	virtual void __fastcall AssignTo(System::TObject* Other);
	virtual void __fastcall Assign(System::TObject* Other);
	void __fastcall TakeOver(TLinearBitmap* Other);
	void __fastcall CopyToClipboard(void);
	bool __fastcall GetFromClipboard(void);
	void __fastcall PasteImage(TLinearBitmap* Source, int X, int Y);
	TBitmapLoader* __fastcall LoadFromFile(const AnsiString FileName);
	void __fastcall SaveToFile(const AnsiString FileName);
	void __fastcall LoadFromStream(Streams::TSeekableStream* Stream, const AnsiString FormatExt)/* overload */;
	void __fastcall LoadFromStream(Classes::TStream* Stream, const AnsiString FormatExt)/* overload */;
	void __fastcall SaveToStream(Streams::TSeekableStream* Stream, const AnsiString FormatExt)/* overload */;
	void __fastcall SaveToStream(Classes::TStream* Stream, const AnsiString FormatExt)/* overload */;
	bool __fastcall IsGrayScale(void);
	void __fastcall ResizeCanvas(int XSiz, int YSiz, int XPos, int YPos, Graphics::TColor Color = (Graphics::TColor)(0x0));
	void __fastcall GetFromDIB(tagBITMAPINFO &DIB);
	void __fastcall GetFromHDIB(HBITMAP HDIB);
	int __fastcall MakeDIB(Windows::PBitmapInfo &Bitmap);
	void __fastcall PaintToCanvas(Graphics::TCanvas* Canvas, const Types::TRect &Dest, bool HalftoneStretch = false);
	void __fastcall StretchDIBits(unsigned DC, const Types::TRect &Dest, bool HalftoneStretch = false);
	void __fastcall PaintToTBitmap(Graphics::TBitmap* Target);
};


typedef DynamicArray<TLinearBitmap* >  TLinearBitmapArray;

typedef TLinearBitmap TLinarBitmap;
;

class PASCALIMPLEMENTATION TBitmapLoader : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	virtual bool __fastcall CanLoad(AnsiString Ext);
	virtual bool __fastcall CanSave(AnsiString Ext);
	virtual AnsiString __fastcall GetLoadFilter();
	virtual AnsiString __fastcall GetSaveFilter();
	virtual void __fastcall LoadFromStream(Streams::TSeekableStream* Stream, AnsiString Ext, TLinearBitmap* Bitmap);
	virtual void __fastcall SaveToStream(Streams::TSeekableStream* Stream, AnsiString Ext, TLinearBitmap* Bitmap);
	virtual void __fastcall LoadFromFile(const AnsiString FileName, const AnsiString FileType, TLinearBitmap* Bitmap);
	virtual void __fastcall SaveToFile(const AnsiString FileName, const AnsiString FileType, TLinearBitmap* Bitmap);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TBitmapLoader(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TBitmapLoader(void) { }
	#pragma option pop
	
};


class DELPHICLASS TLinearGraphic;
class PASCALIMPLEMENTATION TLinearGraphic : public Graphics::TGraphic 
{
	typedef Graphics::TGraphic inherited;
	
protected:
	TLinearBitmap* FImage;
	virtual void __fastcall Draw(Graphics::TCanvas* ACanvas, const Types::TRect &Rect);
	virtual bool __fastcall GetEmpty(void);
	virtual int __fastcall GetHeight(void);
	virtual int __fastcall GetWidth(void);
	virtual void __fastcall SetHeight(int Value);
	virtual void __fastcall SetWidth(int Value);
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	
public:
	__property TLinearBitmap* Bitmap = {read=FImage};
	__fastcall virtual TLinearGraphic(void);
	__fastcall virtual ~TLinearGraphic(void);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	virtual void __fastcall LoadFromFile(const AnsiString FileName);
	virtual void __fastcall SaveToFile(const AnsiString FileName);
	virtual void __fastcall LoadFromClipboardFormat(Word AFormat, unsigned AData, HPALETTE APalette);
	virtual void __fastcall SaveToClipboardFormat(Word &AFormat, unsigned &AData, HPALETTE &APalette);
};


typedef TLinearGraphic TLinarGraphic;
;

typedef TBitmapLoader* TBitmapLoaderList[1];

typedef TBitmapLoaderList *PBitmapLoaderList;

class DELPHICLASS TBitmapLoaders;
class PASCALIMPLEMENTATION TBitmapLoaders : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TBitmapLoaderList *Loaders;
	int Count;
	int MemCount;
	void __fastcall AddLoader(TBitmapLoader* Loader);
	TBitmapLoader* __fastcall GetLoader(AnsiString Ext);
	TBitmapLoader* __fastcall GetSaver(AnsiString Ext);
	AnsiString __fastcall GetLoadFilter();
	AnsiString __fastcall GetSaveFilter();
	__fastcall virtual ~TBitmapLoaders(void);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TBitmapLoaders(void) : System::TObject() { }
	#pragma option pop
	
};


class DELPHICLASS ELinearBitmap;
class PASCALIMPLEMENTATION ELinearBitmap : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall ELinearBitmap(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall ELinearBitmap(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall ELinearBitmap(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall ELinearBitmap(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall ELinearBitmap(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall ELinearBitmap(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall ELinearBitmap(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall ELinearBitmap(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~ELinearBitmap(void) { }
	#pragma option pop
	
};


class DELPHICLASS EUnsupportedFileFormat;
class PASCALIMPLEMENTATION EUnsupportedFileFormat : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EUnsupportedFileFormat(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EUnsupportedFileFormat(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EUnsupportedFileFormat(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EUnsupportedFileFormat(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EUnsupportedFileFormat(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EUnsupportedFileFormat(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EUnsupportedFileFormat(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EUnsupportedFileFormat(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EUnsupportedFileFormat(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TProgressUpdate)(int Done);

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::ResourceString _rsInvalidPixelFormat;
#define Linarbitmap_rsInvalidPixelFormat System::LoadResourceString(&Linarbitmap::_rsInvalidPixelFormat)
extern PACKAGE System::ResourceString _rsInvalidBitmapSize;
#define Linarbitmap_rsInvalidBitmapSize System::LoadResourceString(&Linarbitmap::_rsInvalidBitmapSize)
extern PACKAGE System::ResourceString _rsUnsupportedFileFormat;
#define Linarbitmap_rsUnsupportedFileFormat System::LoadResourceString(&Linarbitmap::_rsUnsupportedFileFormat)
extern PACKAGE System::ResourceString _rsErrorInBitmapData;
#define Linarbitmap_rsErrorInBitmapData System::LoadResourceString(&Linarbitmap::_rsErrorInBitmapData)
extern PACKAGE System::ResourceString _rsUnsupportedBitmapFormat;
#define Linarbitmap_rsUnsupportedBitmapFormat System::LoadResourceString(&Linarbitmap::_rsUnsupportedBitmapFormat)
extern PACKAGE TBitmapLoaders* BitmapLoaders;
extern PACKAGE TProgressUpdate ProgressUpdate;
extern PACKAGE RGBRec GrayPal[256];
extern PACKAGE RGBRec BlackPix24;
extern PACKAGE RGBRec WhitePix24;
extern PACKAGE AnsiString __fastcall ExtractFileExtNoDot(const AnsiString FileName);
extern PACKAGE RGBRec __fastcall GrayPix24(Byte Level);
extern PACKAGE Graphics::TColor __fastcall RGB2TColor(Byte R, Byte G, Byte B);
extern PACKAGE RGBRec __fastcall GetRGBRec(Byte R, Byte G, Byte B);
extern PACKAGE Graphics::TColor __fastcall RGB2BGR(const Graphics::TColor Color);
extern PACKAGE void __fastcall DrawHDIBToTBitmap(unsigned HDIB, Graphics::TBitmap* Bitmap);
extern PACKAGE void __fastcall DrawDIBToTBitmap(tagBITMAPINFO &DIB, Graphics::TBitmap* Bitmap);
extern PACKAGE void __fastcall MakeGrayPal(void *Palette, int ColorCount);
extern PACKAGE Byte __fastcall BestColorMatch(Graphics::TColor Color, RGBRec const * Palette);
extern PACKAGE void __fastcall MakeLogPalette(RGBRec const * Pal, void *PalEntries, int ColorCount = 0x100);
extern PACKAGE HPALETTE __fastcall MakeHPalette(RGBRec * Pal, int ColorCount = 0x100);
extern PACKAGE TPalette __fastcall GetFromHPalette(const HPALETTE HPal, int ColorCount = 0x100);
extern PACKAGE TPalette __fastcall GetFromRGBPalette(void *Pal);
extern PACKAGE void __fastcall AddLoader(TBitmapLoader* Loader);
extern PACKAGE void __fastcall DeInterleave(TLinearBitmap* Image, Sysutils::PByteArray Source = (void *)(0x0), int Planes = 0x3);

}	/* namespace Linarbitmap */
using namespace Linarbitmap;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Linarbitmap
