// CodeGear C++ Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Streams.pas' rev: 11.00

#ifndef StreamsHPP
#define StreamsHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Monitor.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Streams
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TBaseStream;
class PASCALIMPLEMENTATION TBaseStream : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	bool fCanWrite;
	bool fCanRead;
	bool fNoDataExcept;
	virtual void __fastcall SetNoDataExcept(bool Status);
	
public:
	__fastcall TBaseStream(void);
	virtual int __fastcall Write(void *Buf, int Count) = 0 ;
	virtual int __fastcall Read(void *Buf, int Count) = 0 ;
	virtual bool __fastcall EOS(void);
	virtual int __fastcall Available(void) = 0 ;
	virtual void __fastcall Flush(void);
	virtual void __fastcall CopyFrom(TBaseStream* Source);
	__property bool CanRead = {read=fCanRead, nodefault};
	__property bool CanWrite = {read=fCanWrite, nodefault};
	__property bool NoDataExcept = {read=fNoDataExcept, write=SetNoDataExcept, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TBaseStream(void) { }
	#pragma option pop
	
};


class DELPHICLASS TFilterStream;
class PASCALIMPLEMENTATION TFilterStream : public TBaseStream 
{
	typedef TBaseStream inherited;
	
protected:
	TBaseStream* Next;
	virtual void __fastcall SetNoDataExcept(bool Status);
	
public:
	__fastcall TFilterStream(TBaseStream* InOutStream);
	virtual int __fastcall Write(void *Buf, int Count);
	virtual int __fastcall Read(void *Buf, int Count);
	virtual int __fastcall Available(void);
	void __fastcall FreeAll(void);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TFilterStream(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSeekableStream;
class PASCALIMPLEMENTATION TSeekableStream : public TBaseStream 
{
	typedef TBaseStream inherited;
	
protected:
	virtual int __fastcall GetPos(void) = 0 ;
	virtual int __fastcall GetSize(void) = 0 ;
	
public:
	virtual void __fastcall Seek(int loc) = 0 ;
	__property int Position = {read=GetPos, write=Seek, nodefault};
	__property int Size = {read=GetSize, nodefault};
	virtual void __fastcall Truncate(void) = 0 ;
public:
	#pragma option push -w-inl
	/* TBaseStream.Create */ inline __fastcall TSeekableStream(void) : TBaseStream() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSeekableStream(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum Streams__4 { sfaArchive, sfaHidden, sfaSystem, sfaReadOnly, sfaTemporary, sfaCompressed, sfaDirectory };
#pragma option pop

typedef Set<Streams__4, sfaArchive, sfaDirectory>  TFileAttributes;

#pragma option push -b-
enum Streams__5 { fsRead, fsWrite, fsCreate, fsShareRead, fsShareWrite };
#pragma option pop

typedef Set<Streams__5, fsRead, fsShareWrite>  TfsModes;

class DELPHICLASS TFileStream;
class PASCALIMPLEMENTATION TFileStream : public TSeekableStream 
{
	typedef TSeekableStream inherited;
	
protected:
	unsigned Handle;
	AnsiString name;
	virtual int __fastcall GetPos(void);
	virtual int __fastcall GetSize(void);
	TFileAttributes __fastcall GetFileAttr(void);
	void __fastcall SetFileAttr(TFileAttributes fa);
	_FILETIME __fastcall GetLastWriteTime();
	void __fastcall SetLastWriteTime(const _FILETIME &Time);
	
public:
	__fastcall TFileStream(AnsiString filename, TfsModes mode)/* overload */;
	__fastcall TFileStream(unsigned FileHandle)/* overload */;
	__fastcall virtual ~TFileStream(void);
	virtual void __fastcall Delete(void);
	virtual int __fastcall Write(void *Buf, int Count);
	virtual int __fastcall Read(void *Buf, int Count);
	virtual int __fastcall Available(void);
	virtual void __fastcall Flush(void);
	virtual void __fastcall Seek(int loc);
	virtual void __fastcall Truncate(void);
	__property TFileAttributes Attributes = {read=GetFileAttr, write=SetFileAttr, nodefault};
	__property _FILETIME LastWriteTime = {read=GetLastWriteTime, write=SetLastWriteTime};
	__property AnsiString FileName = {read=name};
	__property unsigned FileHandle = {read=Handle, nodefault};
};


class DELPHICLASS TDummyStream;
class PASCALIMPLEMENTATION TDummyStream : public TBaseStream 
{
	typedef TBaseStream inherited;
	
public:
	__fastcall TDummyStream(void);
	virtual int __fastcall Write(void *Buf, int Count);
	virtual int __fastcall Read(void *Buf, int Count);
	virtual int __fastcall Available(void);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TDummyStream(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::ResourceString _rs_UnspecifiedError;
#define Streams_rs_UnspecifiedError System::LoadResourceString(&Streams::_rs_UnspecifiedError)
extern PACKAGE System::ResourceString _rs_ReadError;
#define Streams_rs_ReadError System::LoadResourceString(&Streams::_rs_ReadError)
extern PACKAGE System::ResourceString _rs_WriteError;
#define Streams_rs_WriteError System::LoadResourceString(&Streams::_rs_WriteError)
extern PACKAGE System::ResourceString _rs_ReadLessError;
#define Streams_rs_ReadLessError System::LoadResourceString(&Streams::_rs_ReadLessError)
extern PACKAGE System::ResourceString _rs_IOError;
#define Streams_rs_IOError System::LoadResourceString(&Streams::_rs_IOError)
extern PACKAGE System::ResourceString _rs_ReadDenied;
#define Streams_rs_ReadDenied System::LoadResourceString(&Streams::_rs_ReadDenied)
extern PACKAGE System::ResourceString _rs_WriteDenied;
#define Streams_rs_WriteDenied System::LoadResourceString(&Streams::_rs_WriteDenied)
extern PACKAGE System::ResourceString _rs_CreateFileError;
#define Streams_rs_CreateFileError System::LoadResourceString(&Streams::_rs_CreateFileError)
extern PACKAGE System::ResourceString _rs_CloseFileError;
#define Streams_rs_CloseFileError System::LoadResourceString(&Streams::_rs_CloseFileError)
extern PACKAGE System::ResourceString _rs_DeleteFileError;
#define Streams_rs_DeleteFileError System::LoadResourceString(&Streams::_rs_DeleteFileError)
extern PACKAGE System::ResourceString _rs_TruncateFileError;
#define Streams_rs_TruncateFileError System::LoadResourceString(&Streams::_rs_TruncateFileError)
extern PACKAGE System::ResourceString _rs_SeekFileError;
#define Streams_rs_SeekFileError System::LoadResourceString(&Streams::_rs_SeekFileError)
extern PACKAGE System::ResourceString _rs_GetFileAttrError;
#define Streams_rs_GetFileAttrError System::LoadResourceString(&Streams::_rs_GetFileAttrError)
extern PACKAGE System::ResourceString _rs_SetFileAttrError;
#define Streams_rs_SetFileAttrError System::LoadResourceString(&Streams::_rs_SetFileAttrError)
extern PACKAGE System::ResourceString _rs_NoFileAccessSpec;
#define Streams_rs_NoFileAccessSpec System::LoadResourceString(&Streams::_rs_NoFileAccessSpec)
#define fsReset (Set<Streams__5, fsRead, fsShareWrite> () << Streams__5(0) << Streams__5(1) )
#define fsRewrite (Set<Streams__5, fsRead, fsShareWrite> () << Streams__5(0) << Streams__5(1) << Streams__5(2) )
#define fsShared (Set<Streams__5, fsRead, fsShareWrite> () << Streams__5(3) << Streams__5(4) )
extern PACKAGE void __fastcall CopyStream(TBaseStream* Source, TBaseStream* Dest, const int Size);
extern PACKAGE AnsiString __fastcall GetLastErrorText();

}	/* namespace Streams */
using namespace Streams;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Streams
