unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtDlgs, StdCtrls,
  ImageDLLLoader, userICOLoader, JPEGLoader, PNGLOader, HIPSLoader, BMPLoader, PCXLoader,
  LinarBitmap, ExtCtrls, FileUtils;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    SaveDialog1: TSaveDialog;
    Button2: TButton;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
                        
procedure TForm1.FormCreate(Sender: TObject);
begin
  ImageDLLLoader.Default.FindDLLs(ProgramPath);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  OpenPictureDialog1.Filter:='All images ('+BitmapLoaders.GetLoadFilter;
  if OpenPictureDialog1.Execute then
    with TLinearBitmap.Create do
      try
        Image1.Picture:=nil;
        LoadFromFile(OpenPictureDialog1.FileName);
        AssignToTBitmap(Image1.Picture.Bitmap);
      finally
        Free;
      end;

  // Note: Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName) will
  // also load picture in all formats, but the result will not be a TBitmap.
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SaveDialog1.Filter:=BitmapLoaders.GetSaveFilter;
  if SaveDialog1.Execute then
    with TLinearBitmap.Create do
      try
        GetFromTBitmap(Image1.Picture.Bitmap);
        // To compress JPEG2000 files to 5% of raw bitmap size, set
        // ImageDLLLoader.Default.CompOptions:='rate=0.05';
        SaveToFile(SaveDialog1.FileName);
      finally
        Free;
      end;
end;

end.

